angular.module('quipsphere.auth.controllers', [])

// AUTH
.controller('AuthCtrl', function($scope, $ionicConfig,$window) {
    $scope.setbackground = {};
    $scope.setbackground.size = $window.innerHeight+"px";

    // document.getElementsByClassName('walkthrough-view')[0].setAttribute("style","background-size:100%");
})

// INTROSLIDES
.controller('IntroslidesCtrl', function($scope, $ionicSlideBoxDelegate, $rootScope) {

    $scope.slideHasChanged = function(e){
        console.log(e);
    }

    $scope.moveSlide = function(index){
        $ionicSlideBoxDelegate.$getByHandle('introslides').slide(index, 1000);
    }

    $scope.gotoWalk = function(){
        $rootScope.goto('auth.walkthrough');
    }
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
        if(toState.name == 'auth.introslides'){
            /*setTimeout(function(){
                $scope.moveSlide(1);
            },3000)*/
        }
    });

})
// WALKTHROUGH
.controller('WalkthroughCtrl', function($scope, $state, $templateCache, $q, $rootScope, $ionicModal, Country, $timeout, UserService, $ionicModal, $http, $ionicLoading, Constant, API ,deviceType, socket, S3URL_PROFILEPIC_PATH) {
    
   /* $ionicModal.fromTemplateUrl('apple.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal
        })  

        $scope.openModal = function() {
            $scope.modal.show()
        }

        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.$on('$destroy', function() {
            $scope.modal.remove();
        });*/

        /* if($rootScope.flagsplash === 0){
        // $rootScope.opensplashModal();
        // $timeout(function() {
        //     $rootScope.closesplashModal();
        //     $rootScope.flagsplash = 1;
        // }, 3000);
    }*/


    $scope.data = [];

    var fbLoginSuccess = function(response) {
        if (!response.authResponse){
            fbLoginError("Cannot find the authResponse");
            return;
        }

        var authResponse = response.authResponse;

        getFacebookProfileInfo(authResponse).then(function(profileInfo) {
            // For the purpose of this example I will store user data on local storage
            UserService.setUser({
                authResponse: authResponse,
                userID: profileInfo.id,
                name: profileInfo.name,
                first_name: profileInfo.first_name,
                last_name: profileInfo.last_name,
                email: profileInfo.email,
                picture : "http://graph.facebook.com/" + authResponse.userID + "/picture?type(large)"
            });

            API.checkemail({email:profileInfo.email}, function(data){
                console.log(data);

                if(data.Result == 1){
                    API.savefbid({email:profileInfo.email, fb_id: profileInfo.id}, function(data){
                        console.log(data);
                        if(data.Result == 1){
                            //$rootScope.goto('app.home',{}); 
                            // Success
                            LoginSuccess(data);
                            if($rootScope.user_data.quipper_id){
                                if (deviceType.isAny()) {
                                    PushNotificationsService.register();
                                }
                            }
                        }else{
                            console.log("Error!");
                        }
                    });
                }else{
                    API.checkfbid({fb_id:profileInfo.id}, function(data){
                        console.log(data);
                        if(data.Result == 1){
                            var fbdata = {fb_id:profileInfo.id};

                            API.fbloginsuccess(fbdata, function(data){
                                var spinner = document.getElementById("signup-spinner-container");
                                var btn = document.getElementById("signup-btn-container");
                                if(data.Result == 1){
                                    //$rootScope.goto('app.home',{}); 
                                    // Success
                                    LoginSuccess(data);
                                    if($rootScope.user_data.quipper_id){
                                        if (deviceType.isAny()) {
                                            PushNotificationsService.register();
                                        }
                                    }
                                }else{
                                    console.log("Error!"); 
                                }
                            });

                        }else{
                            var spinner = document.getElementById("signup-spinner-container");
                            var btn = document.getElementById("signup-btn-container");
                            $scope.showmepls = 1;
                            $scope.user = {};
                            $scope.user.fb_id = "";
                            $scope.user.firstname = "";
                            $scope.user.lastname = "";
                            $scope.user.password = "quipsphere";
                            $scope.user.handle = "";
                            $scope.user.email = "";
                            $scope.user.confirm_password = "quipsphere";
                            $scope.user.avatar = "";

                            $scope.submitfacebookData = function() {
                                var spinner = document.getElementById("signup-spinner-container");
                                var btn = document.getElementById("signup-btn-container");
                                $scope.showmepls = 1;
                                $scope.showme = 0;
                                $scope.hideme = true;
                                $ionicLoading.show({
                                    template: 'Logging in...'
                                });
                                
                                console.log($scope.data);
                                $scope.user.fb_id = $scope.data.id;
                                $scope.user.firstname = $scope.data.first_name;
                                $scope.user.lastname = $scope.data.last_name;
                                $scope.user.avatar = $scope.data.picture.data.url;
                                //$scope.user.handle = $scope.data.name;

                                if($scope.data.email == null || $scope.data.email == "undefined" || $scope.data.email == "") {
                                    $scope.user.email = $scope.data.id + 'quipsphere@quipsphere.com';
                                } else {
                                    $scope.user.email = $scope.data.email;
                                }

                                spinner.style.display = "block";
                                btn.style.display = "none";

                                var fbdata = {fb_id: $scope.user.fb_id,
                                              fname: $scope.user.firstname, 
                                              lname: $scope.user.lastname,
                                              handle: $scope.user.handle,
                                              email: $scope.user.email,
                                              password: $scope.user.password,
                                              avatar: $scope.user.avatar
                                             };

                                console.log(fbdata);

                                API.fbsignup(fbdata, function(data){
                                    if(data.Result == 1){
                                        var fbdata = {fb_id:profileInfo.id};

                                        API.fbloginsuccess(fbdata, function(data){
                                            if(data.Result == 1){
                                                //$rootScope.goto('app.home',{}); 
                                                // Success
                                                LoginSuccess(data);
                                                if($rootScope.user_data.quipper_id){
                                                    if (deviceType.isAny()) {
                                                        PushNotificationsService.register();
                                                    }
                                                }
                                            }else{
                                                console.log("Error!"); 
                                            }
                                            console.log(data);
                                       /* }, function(data){
                                            //var msg = "Something went wrong please try again";
                                            //LoginError(msg);
                                            console.log('error!');*/
                                        });

                                        

                                    $scope.user = {};

                                    /*$scope.user.email = "orlydonx@gmail.com";
                                    $scope.user.password = "123456";*/

                                    $scope.user.email = "";
                                    $scope.user.password = "";

                                    // We need this for the form validation
                                    $scope.selected_tab = "";
                                    /*$scope.$on('my-tabs-changed', function (event, data) {
                                    $scope.selected_tab = data.title;
                                    });*/

                                    $scope.goBack = function() {
                                          return false;
                                          //ionicHistory.backView();
                                    };
                                        
                                    }else{
                                        SignupError(data.Message[0]);
                                    }
                                    console.log(data);
                                }, function(data){
                                    var msg = "Something went wrong please try again";
                                    SignupError(msg);
                                    console.log('err' + data);
                                });
                            }
                            $ionicLoading.hide();
                            $state.go('auth.walkthrough'); 
                        }
                    });
                }
            });

        },  function(fail){
            // Fail get profile info
            console.log('profile info fail', fail);
        });
    };

    function SignupSuccess(msg, quipper_id ){
        $rootScope.post_signup_msg = msg;        
        window.localStorage['quipper_id'] = quipper_id ;

        //spinner.style.display = "none";
        //btn.style.display = "block";

        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
            $rootScope.goto('auth.login',{});
        }

        $rootScope.goto('auth.signup_photo',{});
        
       
    }

    function SignupError(msg){
        var spinner = document.getElementById("signup-spinner-container");
        var btn = document.getElementById("signup-btn-container");

        spinner.style.display = "none";
        btn.style.display = "block";
        $ionicLoading.hide();
        $scope.showme = 1;
        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
        }
        title = 'Oops!';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }


    // This is the fail callback from the login method
    var fbLoginError = function(error){
        console.log('fbLoginError', error);
        $ionicLoading.hide();
    };

    // This method is to get the user profile info from the facebook api
    var getFacebookProfileInfo = function (authResponse) {
        var info = $q.defer();

        facebookConnectPlugin.api('/me?fields=first_name,last_name,email,picture?type=large,name&access_token=' + authResponse.accessToken, null, 
            function (response) {
                console.log(response);
                $scope.data = response;
                info.resolve(response);
            },
            function (response) {
                console.log(response);
                $scope.data = response;
                console.log($scope.data);
                console.log($scope.data.access_token);
                info.reject(response);

            }
        );
        return info.promise;
    };

    //call back for fb logout
    var fbLoginoutSuccess = function(response) {
        facebookConnectPlugin.login(['email', 'public_profile'], fbLoginSuccess, fbLoginError);
    };

    var fbLoginOutError = function(response) {
        console.log(response);
    };

    //This method is executed when the user press the "Login with facebook" button
    $scope.facebookSignIn = function() {
        facebookConnectPlugin.getLoginStatus(function(success){
            if(success.status === 'connected'){
                $ionicLoading.show({
                    template: 'Logging in...'
                });
                facebookConnectPlugin.logout(fbLoginoutSuccess, fbLoginOutError);


                // The user is logged in and has authenticated your app, and response.authResponse supplies
                // the user's ID, a valid access token, a signed request, and the time the access token
                // and signed request each expire
                /*console.log('getLoginStatus', success.status);

                // Check if we have our user saved
                var user = UserService.getUser('facebook');

                console.log(user);

                if(!user.userID){
                    getFacebookProfileInfo(success.authResponse)
                    .then(function(profileInfo) {
                        // For the purpose of this example I will store user data on local storage
                        UserService.setUser({
                            authResponse: success.authResponse,
                            userID: profileInfo.id,
                            name: profileInfo.name,
                            first_name: profileInfo.first_name,
                            last_name: profileInfo.last_name,
                            email: profileInfo.email,
                            picture : "http://graph.facebook.com/" + success.authResponse.userID + "/picture?type=(large)"
                        });

                        $state.go('auth.walkthrough');
                    }, function(fail){
                        // Fail get profile info
                        console.log('profile info fail', fail);
                    });
                }else{
                    $state.go('auth.walkthrough');
                    //$rootScope.goto('auth.signup_photo',{});
                }
                */
        } else {
            // If (success.status === 'not_authorized') the user is logged in to Facebook,
            // but has not authenticated your app
            // Else the person is not logged into Facebook,
            // so we're not sure if they are logged into this app or not.
            console.log('getLoginStatus', success.status);

            $ionicLoading.show({
                template: 'Logging in...'
            });
                // Ask the permissions you need. You can learn more about
                // FB permissions here: https://developers.facebook.com/docs/facebook-login/permissions/v2.4
                facebookConnectPlugin.login(['email', 'public_profile'], fbLoginSuccess, fbLoginError);
            }
        });
    }

    $scope.GoOut = function() {
        facebookConnectPlugin.logout(function(){
        });

        $scope.data = [];
        $scope.showmepls = 0;
        $scope.hideme = false;

    }

    function LoginSuccess(data){
              
        $rootScope.user_data = data.Data;
        data.Data['country_name'] = Country.getName(data.Data.country);
        window.localStorage['user_data'] = JSON.stringify(data.Data);
        window.localStorage['auth_key'] = data.Data.auth_key;
        window.localStorage['quipper_id'] = data.Data.quipper_id;
        //$rootScope.goto('app.home',{});
        $rootScope.startMySphereWebService();
        //Socket Chat
        $rootScope.me = JSON.parse(window.localStorage['user_data'] );
        $rootScope.me_quipperid = window.localStorage['quipper_id']  ;            
        $rootScope.me_name = $rootScope.me.fname + ' ' + $rootScope.me.lname;  
        //imageURI = Constant.QUIPSHERE_API_HOST+ '/GetImage.php?pictype=profile&file=' + window.localStorage['quipper_id'] +'.jpg?'+ new Date().getTime();
        imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' + window.localStorage['quipper_id'] ;
        $rootScope.me_avatar_url = imageURI;    
        socket.emit('adduser', $rootScope.me_name , $rootScope.me_quipperid, $rootScope.me_avatar_url);
        //io.connect(Constant.SOCKETSERVER,{'force new connection':true});
        

        if($rootScope.user_data.firstlogin == 0){
            $rootScope.openModalBadge('img/badges/apple.png', 'CONGRATULATIONS for signing up! <br/>You got a Green Apple badge.');

               var data = {
                quipper_id: $rootScope.user_data.quipper_id
            };
            API.firstLogin(data, cb_success, cb_error);
        }
        
        try {
            if (FileTransfer){
                //Download quipper image
                var fileTransfer = new FileTransfer();
                //var fileUri = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/' + data.Data.quipper_id + '.jpg' ;
                var fileUri = S3URL_PROFILEPIC_PATH + data.Data.quipper_id + '.jpg' ;
                
                //console.log(fileUri);
                var uri = encodeURI(fileUri);

                var fileURL = cordova.file.externalDataDirectory + '../../../../Quipsphere/' + data.Data.quipper_id + '.jpg';
                //console.log(fileURL);

                fileTransfer.download(
                uri,
                fileURL,
                function(entry) {
                    console.log("download complete: " + entry.toURL());
                    window.localStorage['quipper_profilepic'] = entry.toURL() ;
                    $rootScope.goto('app.home',{});
                },
                function(error) {
                    console.log("download error source " + error.source);
                    console.log("download error target " + error.target);
                    console.log("upload error code" + error.code);
                    window.localStorage.removeItem("quipper_profilepic");
                    $rootScope.goto('app.home',{});
                },
                false,
                {
                    // headers: {
                    //     "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
                    // }
                });
            }
        }
        catch(err) {
            console.log(err.message);
            $rootScope.goto('app.home',{});
        }
    }
})

// LOGIN
// .controller('LoginCtrl', function($scope, $state, $templateCache, $q, $rootScope, $http, $ionicLoading, Constant, API) {
//     var spinner = document.getElementById("login-spinner-container");
.controller('LoginCtrl', function($scope, $state, $templateCache, $q, $rootScope, $http, $ionicLoading, Constant, API, Country, $ionicModal, PushNotificationsService,deviceType, socket) {
    var spinner = document.getElementById("login-spinner-container");
    var btn = document.getElementById("login-btn-container");


    $scope.doLogIn = function(){

       /* if (navigator.onLine) {
          alert('online')
        } else {
          alert('offline');
        }*/
        
        //$ionicLoading.show();
        spinner.style.display = "block";
        btn.style.display = "none";
        var data = {email:$scope.user.email,password: $scope.user.password};

        API.login(data, function(data){
            if(data.Result == 1){
                // Success
                LoginSuccess(data);
                if($rootScope.user_data.quipper_id){
                    if (deviceType.isAny()) {
                        PushNotificationsService.register();
                    }
                }
            }else{
                // Error
                LoginError(data.Message[0]);
            }
            console.log(data);
        }, function(data){
            var msg = "Something went wrong please try again";
            LoginError(msg);
            console.log('err' + data);
        });
    }
    
    function LoginError(msg){
        //$ionicLoading.hide();

        spinner.style.display = "none";
        btn.style.display = "block";

        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
        }
        title = 'Login Failed';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }

    function LoginSuccess(data){
        //$ionicLoading.hide();

        //spinner.style.display = "none";
        //btn.style.display = "block";

        $rootScope.user_data = data.Data;
        data.Data['country_name'] = Country.getName(data.Data.country);
        window.localStorage['user_data'] = JSON.stringify(data.Data);
        window.localStorage['auth_key'] = data.Data.auth_key;
        window.localStorage['quipper_id'] = data.Data.quipper_id;
        //$rootScope.goto('app.home',{});

        $rootScope.startMySphereWebService();
        //Socket Chat
        $rootScope.me = JSON.parse(window.localStorage['user_data'] );
        $rootScope.me_quipperid = window.localStorage['quipper_id']  ;            
        $rootScope.me_name = $rootScope.me.fname + ' ' + $rootScope.me.lname;  
        //imageURI = Constant.QUIPSHERE_API_HOST+ '/GetImage.php?pictype=profile&file=' + window.localStorage['quipper_id'] +'.jpg?'+ new Date().getTime();
        imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' + window.localStorage['quipper_id'] ;
        $rootScope.me_avatar_url = imageURI;    
        socket.emit('adduser', $rootScope.me_name , $rootScope.me_quipperid, $rootScope.me_avatar_url);
        //io.connect(Constant.SOCKETSERVER,{'force new connection':true});
    

        //if(window.localStorage['showApple'] != 1){
            //window.localStorage['showApple'] = 1;
            if($rootScope.user_data.firstlogin == 0){
                $rootScope.openModalBadge('img/badges/apple.png', 'CONGRATULATIONS for signing up! <br/>You got a Green Apple badge.');

                   var data = {
                    quipper_id: $rootScope.user_data.quipper_id
                };
                API.firstLogin(data, cb_success, cb_error);
            }
            
        //}
        try {
            if (FileTransfer){
                //Download quipper image
                var fileTransfer = new FileTransfer();
                var fileUri = Constant.QUIPSHERE_API_HOST+'/uploads/profilepic/' + data.Data.quipper_id + '.jpg' ;
                //console.log(fileUri);
                var uri = encodeURI(fileUri);

                var fileURL = cordova.file.externalDataDirectory + '../../../../Quipsphere/' + data.Data.quipper_id + '.jpg';
                //console.log(fileURL);

                fileTransfer.download(
                    uri,
                    fileURL,
                    function(entry) {
                        console.log("download complete: " + entry.toURL());
                        window.localStorage['quipper_profilepic'] = entry.toURL() ;
                        $rootScope.goto('app.home',{});
                    },
                    function(error) {
                        console.log("download error source " + error.source);
                        console.log("download error target " + error.target);
                        console.log("upload error code" + error.code);
                        window.localStorage.removeItem("quipper_profilepic");
                        $rootScope.goto('app.home',{});
                    },
                    false,
                    {
                        // headers: {
                        //     "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
                        // }
                    }
                );
            }
        }catch(err) {
            console.log(err.message);
            $rootScope.goto('app.home',{});
        }

        function cb_success(data){
         
        }
        function cb_error(data){
       
        }

        
    }
    
    $scope.user = {};

    /*$scope.user.email = "orlydonx@gmail.com";
    $scope.user.password = "123456";*/

    $scope.user.email = "";
    $scope.user.password = "";

    // We need this for the form validation
    $scope.selected_tab = "";
    /*$scope.$on('my-tabs-changed', function (event, data) {
     $scope.selected_tab = data.title;
     });*/
    
    $scope.goBack = function() {
          return false;
          //ionicHistory.backView();
    };

})

// SIGN-UP
.controller('SignupCtrl', function($scope, $state,$rootScope, $ionicLoading, $http, $ionicLoading, Constant, API,deviceType) {
    var spinner = document.getElementById("signup-spinner-container");
    var btn = document.getElementById("signup-btn-container");

    $scope.user = {};
    $scope.user.firstname = "";
    $scope.user.lastname = "";
    $scope.user.password = "";
    $scope.user.handle = "";
    $scope.user.email = "";
    $scope.user.confirm_password = "";
    $rootScope.post_signup_msg = "";
    // $scope.user.gender = "Male";
    // $scope.genders = [
    //     { text: "Male", value: "Male", selected: true },
    //     { text: "Female", value: "Female" , selected: false  },
    // ];

    $scope.doSignUp = function(){
        spinner.style.display = "block";
        btn.style.display = "none";

        var data = {fname: $scope.user.firstname, 
                    lname: $scope.user.lastname,
                    handle: $scope.user.handle,
                    email: $scope.user.email,
                    password: $scope.user.password
                    };

        API.signup(data, function(data){
            if(data.Result == 1){
                // Success                
                SignupSuccess(data.Message[0], data.Data[0].quipper_id);
            }else{
                // Error
                SignupError(data.Message[0]);
            }
            console.log(data);
        }, function(data){
            var msg = "Something went wrong please try again";
            SignupError(msg);
            console.log('err' + data);
        });

        
    };

    function SignupSuccess(msg, quipper_id ){
        $rootScope.post_signup_msg = msg;        
        window.localStorage['quipper_id'] = quipper_id ;

        spinner.style.display = "none";
        btn.style.display = "block";

        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
            $rootScope.goto('auth.login',{});
        }

        $rootScope.goto('auth.signup_photo',{});
        
       
    }
    function SignupError(msg){
        spinner.style.display = "none";
        btn.style.display = "block";
        $ionicLoading.hide();
        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
        }
        title = 'Oops!';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }

    $scope.validateSignup = function(){
        if($scope.user.password != $scope.user.confirm_password){
            alert("Password didn't match");
        }else{
            $scope.doSignUp();
        }
    }
})

// SIGN-UP Photo
.controller('SignupPhotoCtrl', function($scope, $state,$rootScope, $ionicLoading, $timeout, $http, 
    $ionicLoading, $ionicActionSheet,$ionicHistory, $ionicPlatform, Constant, API, $cordovaFile, deviceType) {
    
    $scope.currentPhotoImg = "img/no_pic.png";
    $scope.submitDisabled = true;
    $scope.spinDisabled = true;

    $scope.varShowSubmitBtn = false;

    var spinner = document.getElementById("signup-spinner-container");
    var signupSubmit = document.getElementById("signup-submit-container");

    $ionicPlatform.registerBackButtonAction(function (event) {
                    event.preventDefault();
            }, 100);

    //Action Sheet
    $scope.updatePicture = function(){ 

           // Show the action sheet
       var hideSheet = $ionicActionSheet.show({
         buttons: [
           { text: 'Take Picture' },
           { text: 'Upload Picture' }
         ],
         /*destructiveText: 'Delete',*/
         titleText: 'Select Source',
         cancelText: 'Cancel',
         cancel: function() {
              // add cancel code..
            },
         buttonClicked: function(index) {

            if (index == 0){
              console.log("Take Picture");
              updatePicTake();
            }
            if (index == 1){
              console.log("Upload Picture");
              updatePicUpload();
            }
           return true;
         }
       });

       // For example's sake, hide the sheet after two seconds
       $timeout(function() {
         hideSheet();
       }, 2000);

       //**Update Picture by Taking a Picture Shot
       function updatePicTake(){
          /*navigator.camera.getPicture(onSuccessUpdatePicTake, onFailUpdatePicTake, { quality: 50,
          destinationType: Camera.DestinationType.FILE_URI });*/
          var args = new Array();
          args[0] = window.localStorage['quipper_id'] ;

          QuipsApi.photoShoot(args, onSuccessUpdatePicTake);
       }

      function onSuccessUpdatePicTake(imageURI) {
            console.log(imageURI);
            var image = document.getElementById('signup-picture');
            image.src = imageURI;
            $scope.currentPhotoImg =  imageURI;
           /* $scope.submitDisabled = false;*/           
            //signupSubmit.style.display = "block";
            $scope.varShowSubmitBtn = true;
            //$scope.$digest();
      }

      function onFailUpdatePicTake(message) {
          alert('Failed because: ' + message);
          $scope.varShowSubmitBtn = false;
      }

      //**Update Picture By Upload an image from photo gallery      
      function updatePicUpload(){
            $ionicLoading.show();
            navigator.camera.getPicture(onSuccessUpdatePicUpload, onFailUpdatePicUpload, {
                targetWidth: 720,
                targetHeight: 720,
                quality: 72,
                allowEdit: false,
                correctOrientation: true,
                saveToPhotoAlbum: true,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
            });
          /*var sourceType = Camera.PictureSourceType.PHOTOLIBRARY;        
          navigator.camera.getPicture(function(url){
              // the url contains selected image or a camera result
              var image = document.getElementById('signup-picture');
              image.src = url;
          }, function(message) {
              // handle error
              //alert('Failed because: ' + message);
          },
          {  //camera options
              quality: 50,
              destinationType: Camera.DestinationType.FILE_URI,
              sourceType: sourceType
          });*/
      }     
    };

    function onSuccessUpdatePicUpload(imageData) {
        $scope.varShowSubmitBtn = true;
        var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
        var qpUrlArr = imageData.split('/'); qpUrlArr.splice(-1,1); var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
        var newQpFile = "avatar_"+new Date().getTime()+'.jpg';
        // copy the file in quipsphere folder
        $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'Quipsphere/', newQpFile)
        .then(function (success) {
            var imageSource = cordova.file.externalRootDirectory+'Quipsphere/'+newQpFile;
            
            window.localStorage['quipper_profilepic'] = imageSource;           

            var image = document.getElementById('signup-picture');
            image.src = imageSource;
            $scope.currentPhotoImg =  imageSource;
           /* $scope.submitDisabled = false;*/           
            signupSubmit.style.display = "block";

            $timeout(function(){
                $ionicLoading.hide();
            },700);
        }, function (error) {
            $log.error('error: '+error);
            $ionicLoading.hide();
        });
    }
    function onFailUpdatePicUpload(message) {
        $ionicLoading.hide();
        $scope.varShowSubmitBtn = false;
        $log.error('Failed because: ' + message);
    }

    $scope.submitPhoto = function(){ 
        
        var imgEl = document.getElementById('signup-picture');
        fileURL = imgEl.src;
        var fileinput = fileURL.replace("file:", "");        

        /*$scope.spinDisabled  = false;
        $scope.submitDisabled = true;               */

        spinner.style.display = "block";
        signupSubmit.style.display = "none";

        var ontap_callback = function(e){
            $ionicHistory.clearCache();
            $ionicHistory.clearHistory();

            $rootScope.goto('auth.login',{});
        }    

        function uploadCallBack(result){         
            spinner.style.display = "none";
            signupSubmit.style.display = "block";
            $rootScope.goto('auth.login',{});

            //Prompt Message
            //title = 'Sign up request submitted! Pending Email Validation';
            title = 'Sign Up Success.';
            btn_text = 'Ok';
            msg = $rootScope.post_signup_msg;
            $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        }

        var args = new Array();
        args[0] = window.localStorage['quipper_id'] ;
        args[1] = ".jpg";

        QuipsApi.uploadFile(fileinput, args, uploadCallBack);   

         //$scope.$digest();    
    };

    
    $scope.skipPhotoUpload = function(){
        function ontap_callback(){
            $ionicHistory.clearCache();
            $ionicHistory.clearHistory();

            $rootScope.goto('auth.login',{});
        }
        //title = 'Pending Email Validation';
        title = 'Sign Up Success.';
        btn_text = 'Ok';
        msg = $rootScope.post_signup_msg;
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);

    };


})

// FORGOT PASSWORD
.controller('ForgotPasswordCtrl', function($scope, $rootScope, $state, API, $ionicLoading) {
    $scope.user = {};
    $scope.user.email = "";

    var spinner = document.getElementById("forgot-spinner-container");
    var btn = document.getElementById("forgot-btn-container");

    $scope.recoverPassword = function(){
        spinner.style.display = "block";
        btn.style.display = "none";
        var data = {email:$scope.user.email};

        API.forgotPassword(data, function(data){
            if(data.Result == 1){
                // Success
                ForgotSuccess(data.Message[0]);
            }else{
                // Error
                ForgotError(data.Message[0]);
            }
            
        }, function(data){
            var msg = "Something went wrong please try again";
            ForgotError(msg);
            console.log('err' + data);
        });
    };

    function ForgotSuccess(msg ){        

        spinner.style.display = "none";
        btn.style.display = "block";

        var status = "e";
        var ontap_callback = function(e){            
            $rootScope.goto('auth.login',{});
        }

        title = 'Check your mail';
        btn_text = 'Ok';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
        
       
    }
    function ForgotError(msg){
        spinner.style.display = "none";
        btn.style.display = "block";
        $ionicLoading.hide();
        var status = "e";
        var ontap_callback = function(e){
            console.log(e);
        }
        title = 'Oops!';
        btn_text = 'Try again';
        $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
    }

    
})