
var MaxCaptionCount = 150;

angular.module('quipsphere.editquip.controllers', [])

.constant('options', {
    range: {
        pitch: 7,
        tempo: 50
    },
    defaults: {
        pitch: 0,
        tempo: 100
    },
    consts: {
        pitchExp: 0.69314718056,
        EOF: 65535
    }
})
.constant('enums', {
    state: {
        init: 0,
        ready: 1,
        playing: 2,
        paused: 3,
        stopped: 4
    }
})

/*.controller('EditQuipCtrl', function($scope, $state,$ionicPopup, $state, $cordovaMedia, $timeout, $interval,
    $ionicLoading, MediaManager, $ionicModal, $log, $rootScope, API, $cordovaFile, $cordovaFileTransfer,
    QUIPSHERE_API_HOST) {*/
.controller('EditQuipCtrl', function($scope, $state,$ionicPopup, $state, $cordovaMedia, $timeout, $interval,
    $ionicLoading, $ionicModal, $log, $rootScope, API, $cordovaFile, $cordovaFileTransfer, QUIPSHERE_API_HOST, $sce,
    focus, AudioPlayer, $ionicSideMenuDelegate, $element, $ionicPopover, $ionicSlideBoxDelegate, $ionicScrollDelegate, 
    S3URL_AUDIO_PATH, S3URL_IMG_PATH, $cordovaToast, $cordovaNetwork ) {

    $ionicSideMenuDelegate.canDragContent(false);

    function editquipevent(e) {
        if (e.target !== e.currentTarget) {
            e.stopPropagation();
        }
    }

    $scope.initButtons = function() {
        angular.element(document.getElementsByClassName('btn-circle'))
            .on('click',function(e){
                var a = document.getElementsByClassName('btn-circle');
                for(i =0; i < a.length; i++){
                    a[i].className = "btn-circle";
                    //a[i].setAttribute();
                    switch(a[i].getAttribute('index')){
                        case 'Surprise': a[i].classList.add("turn-surprise"); break; // 7
                        case 'Bandwagon': a[i].classList.add("turn-bandwagon"); break; // 20

                        case 'Controversy': a[i].classList.add("turn-controversy"); break; // 19    
                        case 'Entertainment': a[i].classList.add("turn-entertainment"); break; // 17
                        case 'Guess': a[i].classList.add("turn-guess"); break; // 2
                        case 'Help': a[i].classList.add("turn-help"); break; // 3
                        case 'Inspirational': a[i].classList.add("turn-inspirational"); break; // 1
                        case 'Music': a[i].classList.add("turn-music"); break; // 16

                        case 'Controversy': a[i].classList.add("turn-controversy"); break; // 19
                        case 'Entertainment': a[i].classList.add("turn-entertainment"); break; // 17
                        case 'Guess': a[i].classList.add("turn-guess"); break; // 17
                        case 'Help': a[i].classList.add("turn-help"); break; // 17
                        case 'Inspirational': a[i].classList.add("turn-inspirational"); break; // 1
                        case 'Music': a[i].classList.add("turn-music"); break; // 1

                        case 'News': a[i].classList.add("turn-news"); break; // 16
                        case 'Observation': a[i].classList.add("turn-observation"); break; // 15
                        case 'Opinion': a[i].classList.add("turn-opinion"); break; // 14
                        case 'Preach': a[i].classList.add("turn-preach"); break; // 12

                        case 'Prediction': a[i].classList.add("turn-prediction"); break; // 13

                        case 'Prediction': a[i].classList.add("turn-prediction"); break; // 12
                        case 'Quotes': a[i].classList.add("turn-quotes"); break; // 2

                        case 'Rant': a[i].classList.add("turn-rant"); break; // 11
                        case 'Recommendation': a[i].classList.add("turn-recommendation"); break; // 10
                        case 'Shoutout': a[i].classList.add("turn-shoutout"); break; // 9
                        case 'Sports': a[i].classList.add("turn-sports"); break; // 8
                        case 'Status': a[i].classList.add("turn-status"); break; // 4

                        case 'Survey': a[i].classList.add("turn-survey"); break; // 5
                        case 'Tribute': a[i].classList.add("turn-tribute"); break; // 6
                        case 'Urgent': a[i].classList.add("turn-urgent"); break; // 6
                        case 'Warning': a[i].classList.add("turn-warning"); break; // 5
                        case 'Target': a[i].classList.add("turn-target"); break; // 5
                        

                        case 'Survey': a[i].classList.add("turn-survey"); break; // 6
                        case 'Tribute': a[i].classList.add("turn-tribute"); break; // 6
                        case 'Urgent': a[i].classList.add("turn-urgent"); break; // 5
                        case 'Warning': a[i].classList.add("turn-warning"); break; // 5

                        default:break;
                    }
                }

 
                this.classList.add("turn-active");
                $scope.category = this.getAttribute('index'); $log.info($scope.category);
                //quipcat = document.getElementById('quipcat');
                //quipcat.innerHTML = '#' + this.title;
                $scope.quipcat = '#'+this.href.split('#').pop();
            }
        );
    }

    $scope.quipcat = '#Surprise';
    $rootScope.quipPhotos = [];
    $rootScope.quipPhotoContainer = '';
    $rootScope.quipPhotoContainerArrSrc = [];
    $rootScope.quipPhotoContainerArrHgt = [];
    $rootScope.quipPhotoContainerArrWdt = [];
    $rootScope.quipPhotoContainerDiv = '';
    $scope.captionData = [];
    $scope.category = 'Surprise';
    $rootScope.currentMedia = null;
    $rootScope.currentTrack = null;
    $rootScope.tracks = [];
    $scope.audioPlayer1 = null;
    $scope.postButtonFlag = 0;

    $scope.trustSrc = function(src) {
        return $sce.trustAsResourceUrl(src);
    }
    $scope.quip = {};

    $rootScope.startEditQuipPage = function() {

        console.log('start edit quip');

        var a = document.querySelectorAll("#editquip");
        for(var i = 0; i < a.length; i++){
            a[i].addEventListener("click", editquipevent, false);
        }

        $log.info('QUIP UNIQUE ID: '+$rootScope.threadParentUniqueId);

        if($rootScope.postBackRoute != 'reply thread'){
            switch($rootScope.postBackRoute){
                case 'newsfeed':
                case 'view profile':
                    $rootScope.selectedtopics.hashtag = ''; 
                    $rootScope.threadParentUniqueId = ''; 
                    break;
                defualt:
                    $rootScope.selectedtopics.handler = '';
                    break;
            }  
        }

        if($rootScope.quip_caption == '' || $rootScope.quip_caption == null){
            document.getElementById('quip_caption').innerHTML = '';
            editDetailsHeight = window.screen.height - 225 - 140;
            document.getElementById('edit-details').style.height = editDetailsHeight+'px';
            if($rootScope.selectedtopics.hashtag != null && $rootScope.selectedtopics.hashtag != ''){
                document.getElementById('quip_caption').innerHTML = $rootScope.selectedtopics.hashtag+' ';
            }
            if($rootScope.selectedtopics.handler != null && $rootScope.selectedtopics.handler != ''){
                document.getElementById('quip_caption').innerHTML = document.getElementById('quip_caption').innerHTML+$rootScope.selectedtopics.handler+' ';
            }
        }else{

            document.getElementById('quip_caption').innerHTML = $rootScope.quip_caption;

        }
        $scope.getCaptionCount();

        /*if($rootScope.quip_current_images == '' || $rootScope.quip_current_images == null){
            document.getElementById('quip_photo_box_out').innerHTML = '';
        }else{
            document.getElementById('quip_photo_box_out').innerHTML = $rootScope.quip_current_images;
        }*/

        $rootScope.quipPhotosTempArr = [];
        if($rootScope.quip_current_images_array != '' && $rootScope.quip_current_images_array != null){
            $rootScope.quip_current_images_array.forEach(function(result){
                successPhotoCamera(result);
            });
        }else{
            document.getElementById('quip_photo_box_out').innerHTML = '';
            $rootScope.quip_current_images_array = [];
        }


        $scope.quipPhotos = [];
        $scope.quipPhotoContainer = '';
        $scope.quipPhotoContainerDiv = '';
        $rootScope.quipPhotoContainerArrSrc = [];
        $rootScope.quipPhotoContainerArrHgt = [];
        $rootScope.quipPhotoContainerArrWdt = [];
        //var filename = 'http://api.quipsphere.com/uploads/q/m/8Q8545W9XV_1454082048998.m4a';
        //var filename = 'file:///sdcard/Quipsphere/tempquip.m4a';
        //$rootScope.tempAudioFile = 'http://www.digitalmusiccards.com/music/Nighthawk.mp3';
        //$rootScope.tempAudioFile = 'http://api.quipsphere.com/uploads/q/m/s.cut.m4a';
        //var filename = cordova.file.externalRootDirectory+'Quipsphere/tempquip.m4a';
        var filename = $rootScope.tempAudioFile;
        $scope.quip = {
            src: filename,
            //title: filename.split('/').pop(),
            title: '&nbsp;',
            progress: '0.00',
            duration: $rootScope.quipDuration
        };

        $scope.initButtons();

        // init sound file
        var soundFile = $rootScope.tempAudioFile;
        $scope.audioPlayer1 = new AudioPlayer('1'+new Date().getTime(), soundFile);

        $("#quip_photo_box_out").click(function(e) {
            if($scope.quipPhotosTempArr.toString() != ''){
                $scope.showQpPhoto(e.target.title);
                $rootScope.slideIndex = e.target.title;
            }
        });
    }

    $scope.alertme = function(){
        var confirmPopup = $ionicPopup.confirm({
            title: 'Alert',
            template: 'Are you sure you want to cancel this quip?'
        });
        confirmPopup.then(function(res) {
            if(res) {
                $state.go('app.home');
            } else {
            }
        });
    }

    $rootScope.endEditQuipPage = function() {
        console.log('end edit quip');
        $rootScope.quip_current_images_array = $rootScope.quipPhotosTempArr;
        $rootScope.quip_current_images = document.getElementById('quip_photo_box_out').innerHTML;
        $rootScope.quip_caption = document.getElementById('quip_caption').innerHTML;
        $scope.audioPlayer1.stop();
        $scope.audioPlayer1.init();
    }

    $scope.cleanEditQuipCleanObject = function(){
        $rootScope.quip_current_images_array = [];
        $rootScope.quip_current_images = "";
        $rootScope.quip_caption = "";
    }

    // caption modal
    $ionicModal.fromTemplateUrl('views/record/modal-caption.html', {
        scope: $scope,
        animation: 'slide-in-up',
        controller: 'EditQuipCtrl'
    }).then(function(modal) {
        $scope.captionModal = modal;
    });
    $scope.openCaptionModal = function() {
        var captionHtml = document.getElementById('quip_caption').innerHTML;
        $scope.captionModal.show();
        $scope.captionData.message = captionHtml;
        document.getElementById('captionTextCount').innerHTML = MaxCaptionCount - captionHtml.length;
        elem = document.getElementById('quip_caption_textarea');
        focus('quip_caption_textarea')
    };
    $scope.updateCaptionModal = function() {
        var captionModifiedHtml = $scope.captionData.message;
        // count hashword
        var found = captionModifiedHtml.match(/#(\w+)/g);
        if(found){
            if(found.length > 1){
                $rootScope.popAlert('You cannot use more than one hash tag', 'e', 'Reminder', 'OK', function(){});
                return false;
            }
        }
        $scope.closeCaptionModal();
        document.getElementById('quip_caption').innerHTML = captionModifiedHtml;
        $scope.getCaptionCount();
    }
    $scope.closeCaptionModal = function() {
        event.preventDefault();
        $scope.captionModal.hide();
        $scope.removeCreateMessageModal();
    };
    $scope.removeCreateMessageModal = function() {
        $scope.captionModal.remove();
        // create again after remove
        $timeout(function() {
            $ionicModal.fromTemplateUrl('views/record/modal-caption.html', {
                scope: $scope,
                animation: 'slide-in-up',
                controller: 'EditQuipCtrl'
            }).then(function(modal) {
                $scope.captionModal = modal;
            });
        },500);
    }
    // caption modal
    $rootScope.getCaptionCount = function() {
        var captionHtml = document.getElementById('quip_caption').innerHTML;
        $scope.captioncount = MaxCaptionCount - captionHtml.length;
        if(captionHtml.length == 0){
            $scope.captionDisableFlag = 1;
        }else{
            $scope.captionDisableFlag = 0;
        }
    }

    $scope.postQuip2 = function() {
        $scope.goto('app.myprofile',{});
    }

    $scope.postQuip = function() {

        $scope.truePostQuip();

        /*ping("http://mobileapi.quipsphere.com").then(function(delta) {
            console.log('Ping time was ' + String(delta) + ' ms');
            if(delta < 60){
                $cordovaToast.showShortBottom("Please check you internet connection...");
            }else{
                if(delta  > 400){
                    $cordovaToast.showShortBottom("Please check you internet connection...");
                }else{
                    $scope.truePostQuip();
                }
            }
        }).catch(function(err) {
            console.error('Could not ping remote URL', err);
            $cordovaToast.showShortBottom("Please check you internet connection...");
        });*/
    }

    $scope.truePostQuip = function() {
        if($rootScope.isOnline == false){
            $cordovaToast.showShortCenter("Offline..."); return false;
        }
        $ionicLoading.show();
        $scope.postButtonFlag = 1;

        var quipTempFileName = $rootScope.tempAudioFile.split('/').pop();

        if(quipDebug == 1){

            rndFourA = Math.floor(Math.random()*7)+1;
            rndFourB = Math.floor(Math.random()*7)+1;
            rndFourC = Math.floor(Math.random()*7)+1;
            $scope.postToDatabase('s.cut','balesin'+rndFourA+'.jpg,balesin'+rndFourB+'.jpg,balesin'+rndFourC+'.jpg');

        }else{

            $cordovaFile.checkFile(cordova.file.externalRootDirectory+'Quipsphere/', quipTempFileName, true)
            .then(function (success) {
                var fileinput = cordova.file.externalRootDirectory+'Quipsphere/'+quipTempFileName;
                fileinput = fileinput.replace("file:", "");
                var strDate = new Date().getTime();
                var quipFileName = $rootScope.user_data.quipper_id+'_'+strDate;
                var args = new Array();
                args[0] = quipFileName;
                args[1] = ".m4a";

                QuipsApi.uploadQuipFile(
                    fileinput,
                    args,
                    function(message) {
                        console.log(message);
                        //var quipPhotos = window.localStorage['quip_photo'];
                        //quipPhotosString = quipPhotos == null ? '' : quipPhotos ;
                        var saveFlag = 0;
                        if($rootScope.quipPhotosTempArr.length != 0){
                            //var quipPhotosArr = quipPhotosString.split(',');
                            var uploadCount = 0;
                            var saveCount = 0;
                            var quipPhotosArr = $rootScope.quipPhotosTempArr;
                            $rootScope.quipPhotosTempArr = []; // empty it
                            quipPhotosArr.forEach(function(entry) {
                                // do upload
                                var filePhotoInput = quipPhotosArr[uploadCount];
                                testString = filePhotoInput.substring(0, 5);
                                if(testString == 'data:'){
                                    uploadCount++;
                                    var quipPhotoFileName = 'qp'+uploadCount+'_'+$rootScope.user_data.quipper_id+'_'+new Date().getTime()+'.gif';
                                    $scope.quipPhotos.push(S3URL_IMG_PATH + quipPhotoFileName); // add file name for database posting

                                    var formData = new FormData($('form')[0]);
                                    var blob = $scope.dataURItoBlob(filePhotoInput); // convert to binary
                                    formData.append('file_name',quipPhotoFileName);
                                    formData.append('uploaded_file',blob);
                                    $.ajax({
                                        type: 'POST',
                                        crossDomain:true,
                                        timeout: 60000,
                                        async : false,
                                        //url: 'http://localhost/uploading/upload.php',
                                        url: QUIPSHERE_API_HOST+'/quip/photo_upload_gif',
                                        data: formData,
                                        processData: false,
                                        contentType: false,
                                        success: function(data){
                                            if (data.success) {
                                                console.log('Your file was successfully uploaded!');
                                            } else {
                                                console.log('There was an error uploading your file!');
                                            }
                                        },
                                        error: function (data) {
                                            console.log('There was an error uploading your file!');
                                        }
                                    });
                                }else{
                                    filePhotoInput = filePhotoInput.replace("file:", "");
                                    var quipPhotoFileName = 'qp'+uploadCount+'_'+$rootScope.user_data.quipper_id+'_'+new Date().getTime();
                                    var argsP = new Array();
                                    argsP[0] = quipPhotoFileName;
                                    argsP[1] = ".jpg";
                                    argsP[2] = "quipphoto";
                                    $scope.quipPhotos.push(S3URL_IMG_PATH + quipPhotoFileName + argsP[1]);

                                    uploadCount++;
                                    QuipsApi.uploadQuipFile(
                                        filePhotoInput,
                                        argsP,
                                        function(message) {
                                            saveCount++;
                                            if(quipPhotosArr.length == uploadCount){
                                                if(saveFlag == 0){
                                                    saveFlag = 1;
                                                }
                                            }
                                        }
                                    );
                                }

                            }, this);
                            $timeout(function() {
                                $scope.postToDatabase(quipFileName,$scope.quipPhotos.toString());
                            },700);
                        }else{
                            if(saveFlag == 0){
                                $scope.postToDatabase(quipFileName,'');
                                saveFlag = 1;
                            }
                        }
                    }
                );

            }, function (error) {
                $ionicLoading.hide();
                $scope.postButtonFlag = 0;
                $timeout(function() {
                    //$rootScope.popAlert('Error on quip. Please record a new quip.', 'e', 'Post Quip Failed', 'OK', function(){ });
                    $cordovaToast.showShortCenter("Error on quip. Please record a new quip.");
                },300);
            });

        }
    }

    $scope.postToDatabase = function(quipFileName,quipImageFiles) {
        var fileLocation = S3URL_AUDIO_PATH + quipFileName + '.m4a';
        var parentUniqueId = $rootScope.threadParentUniqueId == null ? 0  : $rootScope.threadParentUniqueId ;
        var quipCaption = document.getElementById('quip_caption').innerHTML;
        var sphere_id = 0;
        if($rootScope.quipforsphere === true){
            sphere_id = $rootScope.routeParams.id;
        }

        if($rootScope.isprivate == 1){
            console.log($rootScope.threadPrvParentUniqueId);
            var parentUniqueIdPrv = $rootScope.threadPrvParentUniqueId == null ? 0  : $rootScope.threadPrvParentUniqueId ;
            var data = {
                'quipper_id':$rootScope.user_data.quipper_id,
                'parent_quipuniqueid':parentUniqueIdPrv,
                'sphere_id':0,
                'low_loc':fileLocation,
                'std_loc':fileLocation,
                'high_loc':fileLocation,
                'caption':quipCaption,
                'filters':'none',
                'quip_images':quipImageFiles,
                'category':$scope.category,
                'prv_to_quipperid':$rootScope.prv_to_quipperid

            };

            console.log(data);
            API.postprvQuip(data, function(data){
                //$scope.deleteQuipFilesAfterPostToDatabase(quipFileName,quipImageFiles);
                $timeout(function() {
                    $rootScope.closeEditQuipModal(1);
                    $ionicLoading.hide();
                    $scope.postButtonFlag = 0;
                    $rootScope.dontToast = 1;
                    $rootScope.goto('app.privatequipitem',{id:$rootScope.prv_to_quipperid});
                    $rootScope.$broadcast("getlatestprivate");
                    $rootScope.reRoute('go','privatequip thread');
                    if(data.Result == 1){
                        //$rootScope.threadParentUniqueId = null;
                    }
                    $scope.cleanEditQuipCleanObject();
                },0);
            }, function(data){
                $ionicLoading.hide();
                $scope.postButtonFlag = 0;
                $cordovaToast.showShortCenter("Server error. Please try again later...."); return false;
            });
        }else{
            var data = {
                'quipper_id':$rootScope.user_data.quipper_id,
                'parent_quipuniqueid':parentUniqueId,
                'sphere_id':sphere_id,
                'low_loc':fileLocation,
                'std_loc':fileLocation,
                'high_loc':fileLocation,
                'caption':quipCaption,
                'filters':'none',
                'quip_images':quipImageFiles,
                'category':$scope.category

            };
            API.postQuip(data, function(data){
                //$scope.deleteQuipFilesAfterPostToDatabase(quipFileName,quipImageFiles);
                $timeout(function() {
                    $rootScope.closeEditQuipModal(1);
                    $ionicLoading.hide();
                    $scope.postButtonFlag = 0;
                    $rootScope.dontToast = 1;
                    if($rootScope.threadParentUniqueId != null && $rootScope.threadParentUniqueId !=  "") {
                        $rootScope.routeStack.pop();
                        $rootScope.routeStack.pop();
                        switch($rootScope.postBackRoute){
                            case 'newsfeed':
                            case 'quippers':
                            case 'reply thread':
                            case 'view profile':
                                $rootScope.$broadcast("updaterreplylatestquip",{unique_id:$rootScope.threadParentUniqueId});
                                $rootScope.openTopicThreadModal($rootScope.threadParentUniqueId);
                                break;
                            case 'topic thread':
                                $rootScope.openTopicThreadModal($rootScope.threadParentUniqueId);
                                $rootScope.reRoute('go','reply thread',$rootScope.selectedtopics.hashtag.substring(1),$rootScope.selectedtopics.handler,$rootScope.threadParentUniqueId);
                                break;
                            case 'app.edit-sphere':
                            case 'app.edit-sphere-event':
                            case 'app.invite-sphere-members':
                            case 'app.sphere-events':
                            case 'app.add-sphere-event':
                            case 'app.sphereaddcollection':
                            case 'app.editcollection':
                            case 'app.spherecollections':
                            case 'app.createcollections':
                            case 'app.collectionitems':
                            case 'app.sphere':
                            case 'app.sphere-members':
                            case 'app.sphere-followers':
                                $rootScope.goto('app.sphere',$rootScope.routeParams);
                                $rootScope.reRoute('go','app.mysphere');
                                $rootScope.reRoute('go','app.sphere', 0, $rootScope.routeParams);
                                $rootScope.$broadcast('getSphereThreads');
                                $rootScope.lasturlarray = [];
                                $rootScope.lasturlarray.push({url:'app.mysphere',params:{}});
                                break;
                            case 'app.sphere-reply':
                                console.log('postBackRoute');
                                console.log($rootScope.routeParams);
                                $rootScope.reRoute('go','app.sphere', 0, {id:$rootScope.routeParams.id, handler:$rootScope.routeParams.handler, quipper_handler:$rootScope.routeParams.quipper_handler});
                                $rootScope.reRoute('go','app.sphere-reply',0, {id:$rootScope.routeParams.id, handler:$rootScope.routeParams.handler, quipper_handler:$rootScope.routeParams.quipper_handler});
                                $rootScope.selectedtopics.handler = $rootScope.routeParams.handler + " " +$rootScope.routeParams.quipper_handler;
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:parentUniqueId});
                                $rootScope.$broadcast('getSphereThreads');
                                break;
                            case 'privatequip thread':
                                $rootScope.goto('app.privatequipitem',{id:$rootScope.threadParentUniqueId});
                                $rootScope.$broadcast("getlatestprivate");
                                $rootScope.reRoute('go','privatequip thread');
                                break;
                            default:break;
                        }
                    }else{
                        switch($rootScope.postBackRoute){
                            case 'app.edit-sphere':
                            case 'app.edit-sphere-event':
                            case 'app.invite-sphere-members':
                            case 'app.sphere-events':
                            case 'app.add-sphere-event':
                            case 'app.sphereaddcollection':
                            case 'app.spherecollections':
                            case 'app.createcollections':
                            case 'app.collectionitems':
                            case 'app.sphere':
                            case 'app.sphere-members':
                            case 'app.editcollection':
                            case 'app.sphere-followers':
                                $rootScope.goto('app.sphere',{id : $rootScope.routeParams.id});
                                $rootScope.reRoute('go','app.mysphere');
                                $rootScope.reRoute('go','app.sphere', 0, $rootScope.routeParams);
                                $rootScope.$broadcast('getSphereThreads');
                                $rootScope.lasturlarray = [];
                                $rootScope.lasturlarray.push({url:'app.mysphere',params:{}});
                                break;
                            case 'app.sphere-reply':
                                console.log('postBackRoute');
                                console.log($rootScope.routeParams);
                                $rootScope.reRoute('go','app.sphere', 0, {id:$rootScope.routeParams.id, handler:$rootScope.routeParams.handler, quipper_handler:$rootScope.routeParams.quipper_handler});
                                $rootScope.reRoute('go','app.sphere-reply',0, {id:$rootScope.routeParams.id, handler:$rootScope.routeParams.handler, quipper_handler:$rootScope.routeParams.quipper_handler});
                                $rootScope.selectedtopics.handler = $rootScope.routeParams.handler + " " +$rootScope.routeParams.quipper_handler;
                                $rootScope.goto('app.sphere-reply',{sphere_id:$rootScope.routeParams.id, quip_id:parentUniqueId});
                                break;
                            case 'topic thread':
                                $rootScope.routeStack.pop();
                                $rootScope.routeStack.pop();
                                $rootScope.goto('app.home-topics',{id:$rootScope.selectedtopics.hashtag.substring(1)});
                                $rootScope.reRoute('go','topic thread');
                                break;
                            case 'app.create-sphere':
                            case 'app.mysphere':
                            case 'applist':
                            case 'home':
                            case 'privatequip':
                            case 'view profile':
                            default:
                                $rootScope.goto('app.myprofile',{});
                                $rootScope.reRoute('go','my profile');
                                break;
                        }
                    }
                    $scope.cleanEditQuipCleanObject();
                },0);
            }, function(data){
                // if error just continue
                //$scope.deleteQuipFilesAfterPostToDatabase(quipFileName,quipImageFiles);
                $ionicLoading.hide();
                $scope.postButtonFlag = 0;
                $rootScope.dontToast = 1;
            });
        }
    }

    $scope.deleteQuipFilesAfterPostToDatabase = function(strQuipFile, strPhotoFiles){
        if(strQuipFile != null && strQuipFile != ""){
            $cordovaFile.removeFile(cordova.file.externalRootDirectory+'Quipsphere/', strQuipFile+'.m4a')
                .then(function (success) {
                    console.log('success');
                }, function (error) {
                    console.log(error);
                });
        }

        if(strPhotoFiles != null && strPhotoFiles != "") {
            arrPhotoFile = strPhotoFiles.split(',');
            arrPhotoFile.forEach(function(entry){
                // get the actual file name
                strPhotoFile = entry.split('/').pop();
                $cordovaFile.removeFile(cordova.file.externalRootDirectory+'Quipsphere/', strPhotoFile)
                    .then(function (success) { }, function (error) { });
            });
        }
    }

    $scope.uploadPhoto = function(uploadType){

        if(quipDebug == 0){
            if($scope.quipPhotosTempArr.length > 2 ){
                $rootScope.popAlert(
                    'You can only add maximum of three(3) photos.', null,'Quip Capture Photo', 'OK',function() {}
                );
            }else{
                if(uploadType == 'gallery'){
                    navigator.camera.getPicture(onSuccessGalleryPhoto, onFailGalleryPhoto, {
                        targetWidth: 720,
                        targetHeight: 720,
                        quality: 72,
                        allowEdit: false,
                        correctOrientation: true,
                        saveToPhotoAlbum: true,
                        destinationType: Camera.DestinationType.FILE_URI,
                        sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM
                    });
                }else if(uploadType == 'gif'){
                    // open gif file uploader
                    $('#fileGifUpload').click();
                }else{
                    var args = new Array();
                    args[0] = 'qpc_';
                    QuipsApi.photoShoot(args, successPhotoCamera, errorUpdloadPhoto);
                }
            }
        }else{
            if($scope.quipPhotosTempArr.length == 2){ successPhotoCamera('img/spheres_img/1.jpg'); }
            if($scope.quipPhotosTempArr.length == 1){ successPhotoCamera('img/spheres_img/2.jpg'); }
            if($scope.quipPhotosTempArr.length == 0){ successPhotoCamera('img/spheres_img/3.jpg'); }
        }
    }


    function onSuccessGalleryPhoto(imageData,imageType) {
        if(imageType == 'gif'){
            $rootScope.quipPhotosTempArr.push(imageData);
            var imageIndex = $scope.quipPhotosTempArr.length-1;
            $scope.addQuipPhotos(imageData,imageIndex);
        }else{
            // format url and filename
            var qp = imageData.split('/').pop(); var qpFile = qp.split('?'); // get the file
            var qpUrlArr = imageData.split('/'); qpUrlArr.splice(-1,1); var qpUrl = qpUrlArr.join('/')+'/'; // get the folder
            var newQpFile = "qpl_"+new Date().getTime()+'.jpg';
            // copy the file in quipsphere folder
            $cordovaFile.copyFile(qpUrl, qpFile[0], cordova.file.externalRootDirectory+'Quipsphere/', newQpFile)
                .then(function (success) {
                    // display in form
                    var imageSource = cordova.file.externalRootDirectory+'Quipsphere/'+newQpFile;
                    $rootScope.quipPhotosTempArr.push(imageSource);
                    var imageIndex = $scope.quipPhotosTempArr.length-1;
                    //var qpPhotoSrc = '<img src="'+imageSource+'">';
                    var qpPhotoSrc = '<div class="qppd_'+(imageIndex)+'"><img src="'+imageSource+'" class="qpp_'+imageIndex+'" ></div>';
                    $scope.quipPhotoContainer = $scope.quipPhotoContainer + qpPhotoSrc;
                    $scope.quipPhotoContainerDiv = $scope.quipPhotoContainer;
                    $scope.addQuipPhotos(imageSource,imageIndex);
                }, function (error) {
                    $log.error('error: '+error);
                });
        }
    }

    var successPhotoCamera = function (imageURI) {
        var qp = imageURI.split('/').pop();
        $scope.quipPhotosTempArr.push(imageURI);
        var imageIndex = $scope.quipPhotosTempArr.length-1;

        var qpPhotoSrc = '<div class="qppd_'+(imageIndex)+'"><img src="'+imageURI+'" class="qpp_'+imageIndex+'" ></div>';
        $scope.quipPhotoContainer = $scope.quipPhotoContainer + qpPhotoSrc;
        $scope.quipPhotoContainerDiv = $scope.quipPhotoContainer;
        $scope.addQuipPhotos(imageURI,imageIndex);
    }

    var errorUpdloadPhoto = function(){
        $ionicLoading.hide();
        $scope.postButtonFlag = 0;
        $cordovaToast.showShortCenter('There was an unexpected error with your request. Please try again.');
    }

    function onFailGalleryPhoto(message) {
        $ionicLoading.hide();
        $scope.postButtonFlag = 0;
        $cordovaToast.showShortCenter('There was an unexpected error with your request. Please try again.');
    }

    $scope.addQuipPhotos = function(imageURI,imageIndex){
        $timeout(function() {
            xht = $('.qpp_'+imageIndex).height();
            xwd = $('.qpp_'+imageIndex).width();
            if(xht <= xwd){
                /*$rootScope.quipPhotoContainerArrHgt.push('auto');
                $rootScope.quipPhotoContainerArrWdt.push($('.qppd_'+imageIndex).width()+'px');*/
                $rootScope.quipPhotoContainerArrHgt.push('100%');
                $rootScope.quipPhotoContainerArrWdt.push('auto');
            }else{
                /*$rootScope.quipPhotoContainerArrHgt.push('100%');
                $rootScope.quipPhotoContainerArrWdt.push($('.qpp_'+imageIndex).width()+'px');*/
                $rootScope.quipPhotoContainerArrHgt.push('auto');
                $rootScope.quipPhotoContainerArrWdt.push('100%');
            }
            $rootScope.quipPhotoContainerArrSrc.push(imageURI);
            $('#quip_photo_box_out').html('');
            ctr = 0;
            $rootScope.quipPhotoContainerArrSrc.forEach(function(entry){
                //var qpPhotoSrc = '<div class="qppd_'+(ctr)+'" title="'+ctr+'"><span class="helper"></span><img src="'+entry+'" class="qpp_'+ctr+'" style="width:'+$rootScope.quipPhotoContainerArrWdt[ctr]+';height:'+$rootScope.quipPhotoContainerArrHgt[ctr]+';" title="'+ctr+'"></div>';
                var qpPhotoSrc = '<div class="qppd_'+(ctr)+'" title="'+ctr+'"><img src="'+entry+'" class="qpp_'+ctr+'" style="width:'+$rootScope.quipPhotoContainerArrWdt[ctr]+';height:'+$rootScope.quipPhotoContainerArrHgt[ctr]+';" title="'+ctr+'"></div>';
                $('#quip_photo_box_out').append(qpPhotoSrc);
                ctr++;
            });
        },500);
    }

    $scope.removePhoto = function() {
        $('.qppd_'+$rootScope.slideIndex).remove();
        $scope.quipPhotosTempArr.splice($rootScope.slideIndex,1);
        $scope.quipPhotoContainerArrSrc.splice($rootScope.slideIndex,1);
        $scope.quipPhotoContainerArrHgt.splice($rootScope.slideIndex,1);
        $scope.quipPhotoContainerArrWdt.splice($rootScope.slideIndex,1);
        $scope.quipPhotoContainer = '';
        $('#quip_photo_box_out').html('');
        ctr = 0;
        $scope.quipPhotoContainerArrSrc.forEach(function(entry) {
            var qpPhotoSrc = '<div class="qppd_'+(ctr)+'" title="'+ctr+'"><img src="'+entry+'" class="qpp_'+ctr+'" style="width:'+$rootScope.quipPhotoContainerArrWdt[ctr]+';height:'+$rootScope.quipPhotoContainerArrHgt[ctr]+';" title="'+ctr+'"></div>';
            //var qpPhotoSrc = '<div class="qppd_'+(ctr)+'" title="'+ctr+'"><span class="helper"></span><img src="'+entry+'" class="qpp_'+ctr+'" style="width:'+$rootScope.quipPhotoContainerArrWdt[ctr]+';height:'+$rootScope.quipPhotoContainerArrHgt[ctr]+';" title="'+ctr+'"></div>';
            $('#quip_photo_box_out').append(qpPhotoSrc);

            //var qpPhotoSrc = '<img src="'+entry+'" title="'+ctr+'" class="qpp_'+ctr+'">'
            //var qpPhotoSrc = '<div class="qppd_'+(ctr)+'"><img src="'+entry+'" class="qpp_'+ctr+'" ></div>';

            //$scope.quipPhotoContainerDiv = $scope.quipPhotoContainerDiv + $scope.quipPhotoContainerArr[ctr];
            //$scope.addQuipPhotos(entry,ctr);
            ctr++;
        });
        $scope.closePhotoModal();
        $timeout(function() {
            $ionicLoading.hide();
        },500);
        /*$scope.quipPhotosTempArr.splice($rootScope.slideIndex,1);
         // arrange items
         ctr = 0;

         $("#quip_photo_box_out").off();
         $("#quip_photo_box_out").click(function(e) {
         if($scope.quipPhotosTempArr.toString() != ''){
         $scope.showQpPhoto(e.target.title);
         $rootScope.slideIndex = e.target.title;
         }
         });
         $log.debug($scope.quipPhotosTempArr);
         $scope.closePhotoModal();*/
    }

    //** Audio Player Part **/
    $rootScope.players = [];
    $rootScope.$on('edit-modal.shown', function($scope) {
        });

    /*$scope.data = { "airlines" : [], "search" : '' };
     $scope.search = function() {
     FlightDataService.searchAirlines($scope.captionData.message).then(
     function(matches) {
     $scope.data.airlines = matches;
     }
     )
     }*/
    $scope.photopopover = $ionicPopover.fromTemplateUrl('photo-popover.html', {
            scope: $scope
        }).then(function(popover) {
            $scope.photopopover = popover;
        });
    $scope.openPhotoPopover = function($event) {
            $scope.photopopover.show($event);
        };
    $scope.closePhotoPopover = function() {
            $scope.photopopover.hide();
        };

    // photo slide show
    $scope.showQpPhoto = function(index) {
            $rootScope.slideIndex = index;
            $ionicSlideBoxDelegate.slide(0);
            $scope.photoModal.show();
            $timeout(function() {
                $ionicSlideBoxDelegate.slide(index);
                $timeout(function() {
                    //$scope.viewJobData.mtphotoflag = 1;
                },500);
            },300);
            //$scope.formatPhotoModal(index);
        }
    $scope.slideChanged = function($index) {
            $rootScope.slideIndex = $index;
            //$scope.formatPhotoModal($index);
        };
    // photo slide show
    // photo modal
    $scope.createPhotoModal = function() {
            $ionicModal.fromTemplateUrl('views/record/modal-photo.html', {
                scope: $scope,
                animation: 'slide-in-up',
                controller: 'EditQuipCtrl'
            }).then(function(modal) {
                $scope.photoModal = modal;
            });
        };
    $scope.openPhotoModal = function() {
            $scope.photoModal.show();
        };
    $scope.closePhotoModal = function() {
        event.preventDefault();
        $scope.photoModal.hide();
        $scope.photoModal.remove();
        $scope.createPhotoModal();
    };
    $scope.createPhotoModal();
    $scope.formatPhotoModal = function(index) {
            phtHgt = $('.qpp_'+index).height();
            phtWdt = $('.qpp_'+index).width();
            hgtPftn = (phtHgt/phtWdt)*$(window).width();
            wdtPftn = (phtWdt/phtHgt)*$(window).height();
            //$('#qpphoto-scroll div div').attr('style','display:table-cell;vertical-align:middle;');
            if(phtWdt >= phtHgt){
                $('#qpphoto-scroll div div').css('width',$(window).width()+'px');
                $('#qpphoto-scroll div div').css('height',hgtPftn+'px');
                $('#qpphoto-scroll div div img').css('width',$(window).width()+'px');
                $('#qpphoto-scroll div div img').css('height',hgtPftn+'px');
            }else{
                $('#qpphoto-scroll div div').css('width',wdtPftn+'px');
                $('#qpphoto-scroll div div').css('height',$(window).height()+'px');
                $('#qpphoto-scroll div div img').css('width',wdtPftn+'px');
                $('#qpphoto-scroll div div img').css('height',$(window).height()+'px');
                $('#qpphoto-scroll div div').css('margin','0 auto');
            }

            $('#qpphoto-scroll .scroll').attr('style','');
        }

    $scope.updatePhoto= function(index) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandleimg'+index).getScrollPosition().zoom;
        if (zoomFactor == 1) {
            $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(true);
        } else {
            $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(false);
        }
    }
    // photo modal

    //Scrolling Icons
    $scope.category = "Urgent";

    function isWithinRange(n, min, max) {
          /*n = parseFloat(str);*/
          return ( n >= min && n <= max);
    }

    function tooltipShowHide(el){
        $(el).tooltipster('show');       
        $timeout(function() {
            $(el).tooltipster('hide');                           
        }, 2000);       
    }

    $scope.timeStartDrag = false;
    //$scope.timeStopDrag = 0;
    
    $scope.onDrag = function(){
        $scope.timeStartDrag = true;
        //console.log($scope.timeStartDrag);
    }
    
    $scope.snapToCat = function(){
        //console.log($scope.category);

        //console.log($scope.timeStartDrag);

        if ($scope.timeStartDrag != true){
            $scope.timeStartDrag = false;
            return;
        }else{
            $scope.timeStartDrag = false;
        }

        //console.log($scope.timeStopDrag);        

        switch($scope.category){
            case "Urgent":
                tooltipShowHide("a.turn-urgent");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1, 167, true);
            break;
            case "Status":  
                tooltipShowHide("a.turn-status");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(62.5, 167, true);
            break;
            case "News":                
                tooltipShowHide("a.turn-news");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(124, 167, true);
            break;
            case "Help":
                tooltipShowHide("a.turn-help");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(186.5, 167, true);
            break;
            case "Opinion":                
                tooltipShowHide("a.turn-opinion");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(248.5, 167, true);
            break;
            case "Bandwagon":                
                tooltipShowHide("a.turn-bandwagon");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(310, 167, true);
            break;
            case "Controversy":
                tooltipShowHide("a.turn-controversy");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(372, 167, true);
            break;

            case "Rant":          
                tooltipShowHide("a.turn-rant");      
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(434, 167, true);
            break;
            case "Recommendation":  
                tooltipShowHide("a.turn-recommendation");              
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(497, 167, true);
            break;
            case "Shoutout":
                tooltipShowHide("a.turn-shoutout");              
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(559, 167, true);
            break;
            case "Tribute":    
                tooltipShowHide("a.turn-tribute");            
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(621, 167, true);
            break;
            case "Preach":       
                tooltipShowHide("a.turn-preach");          
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(682, 167, true);
            break;
            case "Inspirational":
                tooltipShowHide("a.turn-inspirational");  
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(745, 167, true);
            break;
            case "Prediction":           
                tooltipShowHide("a.turn-prediction");       
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(807, 167, true);
            break;
            case "Observation":                
                tooltipShowHide("a.turn-observation");       
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(868, 167, true);
            break;
            case "Warning":
                tooltipShowHide("a.turn-warning");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(931, 167, true);
            break;
            case "Survey":                
                tooltipShowHide("a.turn-survey");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(993, 167, true);
            break;
            case "Entertainment":                
                tooltipShowHide("a.turn-entertainment");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1055, 167, true);
            break;
            case "Sports":
                tooltipShowHide("a.turn-sports");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1117, 167, true);
            break;
            case "Music":                
                tooltipShowHide("a.turn-music");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1178, 167, true);
            break;

            case "Surprise":                
                tooltipShowHide("a.turn-surprise");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1241, 167, true);
            break;
            case "Target":                
                tooltipShowHide("a.turn-target");
                $ionicScrollDelegate.$getByHandle('caticonsel').scrollTo(1302, 167, true);
            break;

        }

    }

    //$("#fileUpload").on('change', function() {

    $scope.fileupload = null;

    $scope.uploadGif = function() {
        //$('#fileGifUpload').click();
    }

    $scope.triggerGifFileUpload = function(){
        var countFiles = $('#fileGifUpload')[0].files.length;
        var imgPath = $('#fileGifUpload')[0].value;
        var extn = imgPath.substring(imgPath.lastIndexOf('.') + 1).toLowerCase();
        if (extn == "gif") {
            if (typeof(FileReader) != "undefined") {
                for (var i = 0; i < countFiles; i++)
                {
                    var reader = new FileReader();
                    reader.onload = function(e) {
                        var QuipGifDataUri = e.target.result;
                        var QuipGifBlob = $scope.dataURItoBlob(QuipGifDataUri);
                        if(QuipGifBlob.size > 1000000){
                            //$rootScope.popAlert('GIF image can\'t exceed 400Kb in file size.', 'e', 'Upload GIF', 'OK', function(){});
                            $cordovaToast.showShortCenter("GIF image can\'t exceed 400Kb in file size.");
                        }else{
                            onSuccessGalleryPhoto(e.target.result,'gif');
                        }
                    }
                    reader.readAsDataURL($('#fileGifUpload')[0].files[i]);
                }
            } else {
                console.log("Alx: This browser does not support FileReader.");
            }
        } else {
            //$rootScope.popAlert('Please select GIF image only.', 'e', 'Upload GIF', 'OK', function(){});
            $cordovaToast.showShortCenter("Please select GIF image only.");
        }
    }

    $scope.dataURItoBlob = function(dataURI) {
        var byteString;
        if (dataURI.split(',')[0].indexOf('base64') >= 0)
            byteString = atob(dataURI.split(',')[1]);
        else
            byteString = unescape(dataURI.split(',')[1]);

        var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

        var ia = new Uint8Array(byteString.length);
        for (var i = 0; i < byteString.length; i++) {
            ia[i] = byteString.charCodeAt(i);
        }

        return new Blob([ia], {type:'image/*'});
    }
})


.directive('myMaxlength', ['$compile', '$log', function($compile, $log, $scope) {
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, elem, attrs, ctrl) {
            attrs.$set("ngTrim", "false");
            var maxlength = parseInt(attrs.myMaxlength, 10);
            ctrl.$parsers.push(function (value) {
                document.getElementById('captionTextCount').innerHTML = MaxCaptionCount - value.length;
                if (value.length > maxlength)
                {
                    value = value.substr(0, maxlength);
                    ctrl.$setViewValue(value);
                    ctrl.$render();
                }
                return value;
            });
        }
    };
}])
.factory('focus', function($timeout, $window) {
    return function(id) {
        // timeout makes sure that is invoked after any other event has been triggered.
        // e.g. click events that need to run before the focus or
        // inputs elements that are in a disabled state but are enabled when those events
        // are triggered.
        $timeout(function() {
            var element = $window.document.getElementById(id);
            if(element)
                element.focus();
        });
    };
})
.directive('tooltip', function () {
    return {
        restrict: 'C',
        link: function (scope, element, attrs) {
            if (attrs.title) {
                var $element = $(element);
                $element.attr("title", attrs.title)
                $element.tooltipster({
                    animation: "fade",
                    trigger: "click",
                    position: "top",
                    positionTracker: true,
                    maxWidth: 500,
                    contentAsHTML: false,
                    autoClose: true
                });
            }
        }
    };
})

;