angular.module('quipsphere.newsfeed.controllers', [])



.controller('VsrepeatCtrl', function( API, $scope, $timeout, $state,$ionicPopup, $state,$stateParams,$rootScope, $ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicBackdrop, $ionicPopover, $log) {


            var i, items = [];
            for (i = 0; i < 1000; i++) {
                items.push({height: i * 92397.0 % 61 + 50});
            }
            $scope.items = items;

})

.controller('NewsFeedCtrl', function( API, $scope, $timeout, $state,$ionicPopup, $state,$stateParams,$rootScope, 
    $ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicBackdrop, $ionicPopover, $log, $cordovaGoogleAnalytics) {
    $scope.quippers = {};
    $scope.tag = {};
    $scope.showModal = {};
    $scope.userdata = {};
    $scope.showloadingnwsf = false;
    $scope.stoploading = true;
    $scope.getwhat = "refresh";

    $scope.$on('$ionicView.beforeEnter', function() {

        //--- parent function
        var parentmenutab = document.querySelector("#nf-container");
        parentmenutab.addEventListener("click", NewsfeedEvent, false);

        
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {

        //--- parent function
        var parentmenutab = document.querySelector("#nf-container");
        parentmenutab.removeEventListener("click", NewsfeedEvent, false);
        function NewsfeedEvent(e) {}
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){


        if(toState.name == 'app.newsfeed'){
            $rootScope.reRoute('go','newsfeed');
            if($scope.newsfeeds.length == 0){
               //$scope.showloadingnwsf = true;
               document.getElementById("nfloadingcontainer").innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
               //getNewsfeedsdata()
               $timeout(function(){
                    document.querySelector(".nfnodataerror").classList.remove("showloading");
                    getNewsfeedsdata();

                    /*if(getNewsfeedsInitialdata() == "done"){
                        if($scope.newsfeeds.length > 0){
                            $scope.stoploading = false;
                        }
                        $scope.showloadingnwsf = false;
                        NewsfeedPullToRefresh.init({
                            contentEl:"nf-content",
                            ptrEl:"nf-ptr",
                            limittrigger:'nf-container',
                            bodyId:'nf-bodycontainer',
                            loadingFunction: getNewsfeedsdata
                        });
                    }*/
                },100);

                function _waitForAnalytics(){ 
                    if(typeof analytics !== 'undefined'){
                        $cordovaGoogleAnalytics.startTrackerWithId('UA-76820046-1'); 
                        $cordovaGoogleAnalytics.trackView('Newsfeeds Screen');
                        $cordovaGoogleAnalytics.setUserId($rootScope.user_data.quipper_id);
                    }else{ 
                        setTimeout(function(){ 
                            _waitForAnalytics(); 
                        },250); 
                    } 
                }; 
                _waitForAnalytics();
                
            }else{
                $scope.stoploading = false;
                NewsfeedPullToRefresh.init({
                    contentEl:"nf-content",
                    ptrEl:"nf-ptr",
                    limittrigger:'nf-container',
                    bodyId:'nf-bodycontainer',
                    loadingFunction: getNewsfeedsdata
                });
            }
            
            
        }
    });

    function getNewsfeedsInitialdata (){
        if ( window.localStorage['newsf_data'] ){
            var tempData= JSON.parse( window.localStorage['newsf_data'] );
            //console.log(tempData.Data);
            $scope.newsfeeds = tempData.Data ;
            return "done";
        }else{
            getNewsfeedsdata();
            return "waiting";
        }
    }

    function getNewsfeedsdata(){
        $scope.stoploading = true;
        return new Promise( function( resolve, reject ) {
            if (true) {
                if($scope.newsfeeds.length > 0){
                    var start = $scope.newsfeeds[0].nfid;
                }
                else{
                    var start = 0;
                }
                API.getNewsfeeds({quipper_id:$rootScope.user_data.quipper_id, action: "refresh", start: start}, function(data){
                    $scope.newsfeeds = data.Data.concat($scope.newsfeeds);
                    $scope.stoploading = false;
                    resolve("done");
                    $scope.$broadcast('doneinitialize');
                }, function(err){
                    resolve("done");
                    $scope.$broadcast('doneinitialize');
                    $scope.getwhat = "firstload";
                    if($scope.newsfeeds.length > 0){
                      $scope.getwhat = "refresh";
                      $('.nferrorfetch').hide().fadeIn(function(){
                            document.querySelector(".nferrorfetch").classList.add("showloading");
                      });
                    }else{
                      // $('.errorfetch').hide().fadeIn(function(){
                      //       document.querySelector(".errorfetch").classList.add("showloading");
                      // });
                        document.querySelector(".nfnodataerror").classList.add("showloading");
                    }
                    
                },10000);
            } else {
                reject();
            }
        } );
    }
    $scope.loadMoreNewsfeed = function(){
        if($scope.stoploading === false){
            $scope.stoploading = true;
            document.querySelector(".nfloadingbar").classList.add("showloading");
            var endnfid = $scope.newsfeeds[$scope.newsfeeds.length - 1].nfid;
            API.getNewsfeeds({quipper_id:$rootScope.user_data.quipper_id, action: "showmore", end: endnfid}, function(data){
                if(data.Data.length > 0){
                    for(i = 0; i < data.Data.length; i++){
                        $scope.newsfeeds.push(data.Data[i]);
                    }
                    $scope.stoploading = false;
                }else{
                    $scope.stoploading = true;
                }
                
                document.querySelector(".nfloadingbar").classList.remove("showloading");
                
            }, function(err){
                document.querySelector(".nfloadingbar").classList.remove("showloading");
                $scope.getwhat = "loadmore";
                $('.nferrorfetch').hide().fadeIn(function(){
                    document.querySelector(".nferrorfetch").classList.add("showloading");
                });
                $scope.stoploading = true;
            },10000);
        }
    }

    

    $scope.$on('doneinitialize', function(event, args) {
        if($scope.newsfeeds.length > 0){
            $scope.stoploading = false;
        }
        //$scope.showloadingnwsf = false;
        document.getElementById("nfloadingcontainer").innerHTML = '';
               
        NewsfeedPullToRefresh.init({
            contentEl:"nf-content",
            ptrEl:"nf-ptr",
            limittrigger:'nf-container',
            bodyId:'nf-bodycontainer',
            loadingFunction: getNewsfeedsdata
        });
    });

    $scope.$on('updaterequipnf', function(event, args) {
            var unique_id = args.unique_id;
            var id_val = args.id_val;
            for(var i =0; i < $scope.newsfeeds.length; i++){
                if($scope.newsfeeds[i].unique_id == unique_id){
                    if(id_val == "requip_"){
                        $scope.newsfeeds[i].is_requipped_img = "img/done-requip-icon.png";
                        $scope.newsfeeds[i].quip_count = $scope.newsfeeds[i].quip_count + 1;
                        $scope.newsfeeds[i].is_requipped_id = 'undorequip_'+unique_id;
                    }else{
                        $scope.newsfeeds[i].is_requipped_img = "img/requip-quip.png";
                        $scope.newsfeeds[i].quip_count = $scope.newsfeeds[i].quip_count - 1;
                        $scope.newsfeeds[i].is_requipped_id = 'requip_'+unique_id;
                    }
                    window.localStorage['newsf_data'] = JSON.stringify($scope.newsfeeds);
                }
            }
    });

    $scope.$on('updateratenf', function(event, args) {
        var unique_id = args.unique_id;
        var counted = args.counted;
        var rating = args.rating;
        for(var i =0; i < $scope.newsfeeds.length; i++){
            if($scope.newsfeeds[i].unique_id == unique_id){
                $scope.newsfeeds[i].is_favorited = 1;
                var currentave = $scope.newsfeeds[i].average_stars;
                var ratedvalue = rating;
                if(currentave == 0){
                    var countdev = 1;
                }else{
                    var countdev = 2;
                }
                var latest_ave = (currentave + ratedvalue) / countdev;
                $scope.newsfeeds[i].average_stars = Math.round(latest_ave);
                $scope.newsfeeds[i].is_favorited_img = "img/star-quiped.png";
            }
        }
        window.localStorage['newsf_data'] = JSON.stringify($scope.newsfeeds);
    });

    $scope.$on('updatenfblock', function(event, args) {
        var quipper_blockid = args.quipper_id;
        var arr_itm = []; 
        for(var i =0; i < $scope.newsfeeds.length; i++){
            if($scope.newsfeeds[i].quipper_id != quipper_blockid){
                arr_itm.push($scope.newsfeeds[i]);
            }
        }
        $scope.newsfeeds = arr_itm;
    });

        //--- media variables
        playedicon = 'img/newsfeed/quip_play_icon_1.png';
        pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
        var loadingicon = 'img/quip_loading_icon.gif';
        $rootScope.media = document.getElementById('quip_audio_src');
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = ''; var mediaLoadedFlag = 0;
        $rootScope.newsfeedUniqueId = '';
        //--- media variables
        function NewsfeedEvent(e) {
            if (e.target !== e.currentTarget) {
                
                var classtarget = e.target.classList;
                for(var i = 0; i < classtarget.length; i++){
                    splitedclass = classtarget[i].split("_"); 
                    if(splitedclass[0] == 'global'){
                        switch(splitedclass[1]){
                            case "viewtopic":
                                    $rootScope.selectedtopics.hashtag = '#'+splitedclass[2];
                                    $rootScope.reRoute('go','topic thread');
                                    $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                                    break;
                            case 'viewprofile':
                                    $rootScope.reRoute('go','view profile');
                                    $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                                    break;
                            case "viewsphere":
                                    $rootScope.reRoute('go','app.sphere');
                                    $rootScope.goto('app.sphere',{id:splitedclass[2]});
                                    break;
                            default:break;
                        }
                    }else if(splitedclass[0] == 'viewlink'){
                        var a = classtarget[1];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }
                
                var checktarget = e.target.id;
                splited = checktarget.split("_");
                switch(splited[0]){
                    case "requip":
                    $rootScope.globalEventHandler(e,function(s){
                    });
                    break;
                    case "undorequip":
                    $rootScope.globalEventHandler(e,function(s){
                    });
                    break;
                    case "imgslider":
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                            if($scope.newsfeeds[i].newsfeed_unique_id == splited[1]){
                                var imgs = $scope.newsfeeds[i].quip_images;
                                $scope.showImages(imgs);
                                return;
                            }
                        }
                        break;
                    case "player":
                        //insert here
                        break;
                    case "quipmedia":
                        thisClass = e.target.className.split(' ');
                        if($rootScope.currentMediaId == thisClass[0]){
                            if($rootScope.mediaPausedFlag == 0){
                                e.target.src = playedicon;
                                $rootScope.media.pause();
                            }else{
                                e.target.src = pausedicon;
                                $rootScope.media.play();
                            }
                        }else{
                            e.target.src = loadingicon;
                            e.target.classList.remove('play_0');
                            e.target.classList.add('play_1');
                            if($rootScope.currentMediaId != '' && $rootScope.currentMediaId != null){
                                var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                for(var i=0;i<currentPlayerImage.length;i++){
                                    currentPlayerImage[i].setAttribute('src',playedicon);

                                }
                            }
                            $rootScope.currentMediaId = thisClass[0];
                            $rootScope.media = document.getElementById('quip_audio_src');
                            $rootScope.media.pause();
                            $rootScope.media.src = e.target.name;
                            $rootScope.media.load();
                            //e.target.src = pausedicon;
                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                            // update
                            $rootScope.newsfeedUniqueId = splited[2];
                            var data = {'newsfeed_unique_id':splited[2]};

                            API.updateNewsfeedPlay(data, function(data){
                                for(var i = 0; i < $scope.newsfeeds.length; i++){
                                    if($scope.newsfeeds[i].newsfeed_unique_id == splited[2]){
                                        //$scope.newsfeeds[i].is_played = 1;

                                    }
                                }
                            }, function(data){
                                $log.info('error on played update');
                            });
                        }
                        break;
                    case "quippermodal":
                        $rootScope.selectedtopics.hashtag = '';
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                            if($scope.newsfeeds[i].newsfeed_unique_id == splited[1]){
                                $rootScope.selectedtopics.handler = $scope.newsfeeds[i].quipper_name;
                                $rootScope.lasttempurl.id = $scope.newsfeeds[i].quipper_id;
                                var quipperid = window.localStorage['quipper_id'];
                                if(quipperid == $scope.newsfeeds[i].quipper_id){
                                    $rootScope.lasttempurl.url = 'app.myprofile';
                                    $rootScope.goto('app.myprofile',{id:$scope.newsfeeds[i].quipper_id});
                                    $rootScope.reRoute('go','my profile');
                                }else{
                                    $rootScope.lasttempurl.url = 'app.view-profile';
                                    $rootScope.goto('app.view-profile', {id:$scope.newsfeeds[i].quipper_id});
                                    $rootScope.reRoute('go','view profile');
                                }
                                return;
                            }
                        }
                        break;
                    case "thread":
                        $rootScope.threadParentUniqueId = splited[1];
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                            if($scope.newsfeeds[i].newsfeed_unique_id == splited[2]){
                                $rootScope.selectedtopics.handler = $scope.newsfeeds[i].quipper_name;
                                $rootScope.openTopicThreadModal(splited[1]);
                                $rootScope.reRoute('go','reply thread');
                                return;
                            }
                        }
                        
                        break;
                    case 'replythread':
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                            if($scope.newsfeeds[i].newsfeed_unique_id == splited[2]){
                                $rootScope.selectedtopics.handler = $scope.newsfeeds[i].quipper_name;
                                $rootScope.threadParentUniqueId = splited[1];
                                $rootScope.openRecorderModal();
                                $rootScope.reRoute('go','recorder',1);
                                return;
                            }
                        }

                        break;
                    case 'ratequip':
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                           if($scope.newsfeeds[i].newsfeed_unique_id == splited[1]){ 
                               $rootScope.ratedata.selecteddata = $scope.newsfeeds[i];
                               $rootScope.openPopoverRate(e,$scope.newsfeeds[i].unique_id,splited[2]);
                               return;
                           }
                       }
                    break;
                    case "sharequip":
                        var uid = splited[2];
                        console.log(uid);
                        window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                        break;

                    case 'report':
                        for(var i = 0; i < $scope.newsfeeds.length; i++){
                           if($scope.newsfeeds[i].newsfeed_unique_id == splited[1]){ 
                               $rootScope.reportdata.r_qpr = $scope.newsfeeds[i].quipper_id;
                               $rootScope.reportdata.r_qpid = $scope.newsfeeds[i].unique_id;
                               $rootScope.reportdata.rqtype = "Quip";
                               $rootScope.$apply();
                               $rootScope.openpopoverreportblock(e,$rootScope.reportdata.r_qpr,$rootScope.reportdata.r_qpid);
                               return;
                           }
                       }
                    break;

                    default:break;
                }
            }
            e.stopPropagation();
        }

        $rootScope.goDeleteQuipByBlock = function() {
            API.deleteQuip({
                unique_id : $rootScope.delete_quip_unique_id
            },function(data){},function(err){});
            $scope.newsfeeds.forEach(function(entry,index){
                if(entry.unique_id == $rootScope.delete_quip_unique_id){
                    $scope.newsfeeds.splice(index,1);
                }
            });
            $rootScope.closepopoverreportblock();
        }

        $scope.doerror = function(val){
            var val = $scope.getwhat;
            console.log(val);
            switch(val){
                case "firstload":
                      document.getElementById("nfloadingcontainer").innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
                      getNewsfeedsdata();
                      document.querySelector(".nfnodataerror").classList.remove("showloading");
                        break;
                case "refresh":
                        getNewsfeedsdata();
                        break;
                case 'loadmore':
                        $scope.stoploading = false;
                        $scope.loadMoreNewsfeed();
                        break;
                default:break;
            }
            $('.nferrorfetch').hide().fadeOut(function(){
                document.querySelector(".nferrorfetch").classList.remove("showloading");
            });
        }

})