angular.module('quipsphere.topic.controllers', [])

.controller('HomeTopicsCtrl', function($scope, $ionicHistory, $timeout, $ionicHistory, $stateParams, $rootScope, $log,
    API, $rootScope , $cordovaGoogleAnalytics) {

    $scope.selectedQuipTopics = [];
    $scope.s_htloading = false;
    $scope.s_htlm = false;
    $scope.$on('$ionicView.beforeEnter', function() {
        $scope.selectedQuipTopics = [];
        //document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        
        var a = document.querySelectorAll("#topic-modal");
        for(var i = 0; i < a.length; i++){
            a[i].addEventListener("click", modaltopicevent, false);
        }
    });
    $scope.$on('$ionicView.beforeLeave', function() {
        //document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        var a = document.querySelectorAll("#topic-modal");
        for(var i = 0; i < a.length; i++){
            a[i].removeEventListener("click", modaltopicevent, false);
        }
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams, $q){

        if(toState.name == 'app.home-topics'){
            $scope.sphere = {};
            val = $stateParams.id;
            $scope.crrhashtag = "#"+val;
            $rootScope.selectedtopics.hashtag = "#"+val;
            $scope.s_htloading = true;
            var timercheckhometopic = "";
            getQuipTopicsHash(val);
            var timercheckhometopic = setInterval(function(){ checkhometopicdata() }, 500);
            function checkhometopicdata(){
                if($scope.selectedQuipTopics.length > 0){
                    $scope.s_htloading = false;
                    $scope.s_htlm = false;
                    $scope.$apply();
                    TopicModalPullToRefresh.init({
                        contentEl:"tm-content",
                        ptrEl:"tm-ptr",
                        limittrigger:'tm-container',
                        bodyId:'tm-bodycontainer',
                        loadingFunction: getQuipTopicsHash,
                        getvalue:val
                    });
                    clearInterval(timercheckhometopic);
                }
            }
            $scope.g = [];
            function getQuipTopicsHash(val){
                return new Promise( function( resolve, reject ) {
                    if (true) {
                        resolve();
                        if($scope.selectedQuipTopics.length > 0){
                            var start = $scope.selectedQuipTopics[0].quipid;
                        }
                        else{
                            var start = 0;
                        }
                        API.searchTopic({
                            start: start,
                            hash: val,
                            action:"refresh"
                        },function(data){
                            $scope.selectedQuipTopics = data.Data.concat($scope.selectedQuipTopics);
                        },function(err){
                        });
                    } else {
                        reject();
                    }
                } );
            }

            function _waitForAnalytics(){ 
                    if(typeof analytics !== 'undefined'){
                        $cordovaGoogleAnalytics.startTrackerWithId('UA-76820046-1'); 
                        $cordovaGoogleAnalytics.trackView('Android Topics Thread');
                        $cordovaGoogleAnalytics.setUserId($rootScope.user_data.quipper_id);
                    }else{ 
                        setTimeout(function(){ 
                            _waitForAnalytics(); 
                        },250); 
                    } 
                }; 
                _waitForAnalytics();

        }
    });

    $scope.loadMoreModalTopics = function(){
        if($scope.s_htlm == false){
            $scope.s_htlm = true;
            var endquipid = $scope.selectedQuipTopics[$scope.selectedQuipTopics.length - 1].quipid;
            API.searchTopic({
                end: endquipid,
                hash: $stateParams.id,
                action:"showmore"
            },function(data){
                if(data.Data.length > 0){
                    for(i = 0; i < data.Data.length; i++){
                        $scope.selectedQuipTopics.push(data.Data[i]);
                    }
                    $scope.s_htlm = false;
                }else{
                    $scope.s_htlm = true;
                }
            },function(err){
            });
        }
        
    }

    //--- media variables
    playedicon = 'img/newsfeed/quip_play_icon_1.png';
    pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.media = document.getElementById('quip_audio_src');
    $rootScope.mediaPausedFlag = 0;
    $rootScope.currentMediaId = '';
    var mediaLoadedFlag = 0;
    //--- media variables
    function modaltopicevent(e) {
        if (e.target !== e.currentTarget) {
            var classtarget = e.target.classList;
                for(var i = 0; i < classtarget.length; i++){
                    splitedclass = classtarget[i].split("_");
                    if(splitedclass[0] == 'global'){
                        switch(splitedclass[1]){
                            case "viewtopic":
                                    $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                                    //$rootScope.reRoute('go','topic thread',param.id);
                                    break;
                            case 'viewprofile':
                                    $rootScope.selectedtopics.hashtag = "";
                                    $rootScope.selectedtopics.handler = splitedclass[3];
                                    $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                                    break;
                            case "viewsphere":
                                    $rootScope.goto('app.sphere',{id:splitedclass[2]});
                                    break;
                            default:break;
                        }
                    }else if(splitedclass[0] == 'viewlink'){
                        var a = classtarget[1];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }


            var checktarget = e.target.id;
            splited = checktarget.split("_");
            switch(splited[0]){
                case "requip":
                    $rootScope.globalEventHandler(e,function(s){
                        for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                            if($scope.selectedQuipTopics[i].unique_id == s[3]){
                                $scope.selectedQuipTopics[i].is_requipped = true;
                            }
                        }
                    });
                    break;
                case "undorequip":
                    $rootScope.globalEventHandler(e,function(s){
                        for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                            if($scope.selectedQuipTopics[i].unique_id == s[3]){
                                $scope.selectedQuipTopics[i].is_requipped = false;
                            }
                        }
                    });
                    break;
                case "quipmedia":
                    if($rootScope.currentMediaId == e.target.className){
                        if($rootScope.mediaPausedFlag == 0){
                            e.target.src = playedicon;
                            $rootScope.media.pause();
                        }else{
                            e.target.src = pausedicon;
                            $rootScope.media.play();
                        }
                    }else{
                        e.target.src = loadingicon;
                        if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                        }else{
                            var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                            for(var i=0;i<currentPlayerImage.length;i++){
                                currentPlayerImage[i].setAttribute('src',playedicon);
                            }
                        }
                        $rootScope.currentMediaId = e.target.className;
                        $rootScope.media = document.getElementById('quip_audio_src');
                        $rootScope.media.pause();
                        $rootScope.media.src = e.target.name;
                        $rootScope.media.load();
                        $rootScope.quipPlayerItem = e.target; // assign the object to play
                    }
                    break;
                case "imgslider":
                    for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                        if($scope.selectedQuipTopics[i].unique_id == splited[1]){
                            var imgs = $scope.selectedQuipTopics[i].quip_images;
                        }
                    }
                    $rootScope.showImages(imgs);
                    break;
                case "popover":
                    $rootScope.openPopover2($event);
                    break;
                case "replytopicthread":
                    for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                        if($scope.selectedQuipTopics[i].unique_id == splited[1]){
                            $rootScope.selectedtopics.handler = $scope.selectedQuipTopics[i].quipper_name;
                        }
                    }
                    $rootScope.threadParentUniqueId = splited[1]; //
                    $rootScope.openRecorderModal(); //
                    $rootScope.reRoute('go','recorder',1); //
                    break;
                case "thread":
                    for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                        if($scope.selectedQuipTopics[i].unique_id == splited[1]){
                            $rootScope.selectedtopics.handler = $scope.selectedQuipTopics[i].quipper_name;
                        }
                    }
                    $rootScope.threadParentUniqueId = splited[1];
                    $rootScope.openTopicThreadModal(splited[1]);
                    $rootScope.reRoute('go','reply thread');
                    break;
                case "quippermodal":
                    $rootScope.hideAllModal();
                    $rootScope.selectedtopics.hashtag = '';
                    for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                        if($scope.selectedQuipTopics[i].unique_id == splited[1]){
                            $rootScope.selectedtopics.handler = $scope.selectedQuipTopics[i].quipper_name;
                        }
                    }
                    $rootScope.lasttempurl.id = splited[1];
                    $rootScope.viewProfileUniqueId = splited[1];
                    var quipperid = window.localStorage['quipper_id'];
                    if(quipperid == splited[1]){
                        $rootScope.lasttempurl.url = 'app.myprofile';
                        $rootScope.goto('app.myprofile',{id:splited[1]});
                        $rootScope.reRoute('go','my profile');
                    }else{
                        $rootScope.lasttempurl.url = 'app.view-profile';
                        $rootScope.goto('app.view-profile', {id:splited[1]});
                        $rootScope.reRoute('go','view profile');
                    }
                    break;
                case "ratequip":
                    for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                       if($scope.selectedQuipTopics[i].unique_id == splited[1]){
                           $rootScope.ratedata.selecteddata = $scope.selectedQuipTopics[i];
                           $rootScope.openPopoverRate(e,splited[1],splited[2]);
                       }
                   }
                    break;
                case "sharequip":
                    var uid = splited[2];
                    console.log(uid);
                    window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                    break;
                case 'report':
                        for(var i = 0; i < $scope.selectedQuipTopics.length; i++){
                           if($scope.selectedQuipTopics[i].unique_id == splited[1]){ 
                               $rootScope.reportdata.r_qpr = $scope.selectedQuipTopics[i].quipper_id;
                               $rootScope.reportdata.r_qpid = $scope.selectedQuipTopics[i].unique_id;
                               $rootScope.reportdata.rqtype = "Quip";
                               $rootScope.$apply();
                               $rootScope.openpopoverreport(e,$rootScope.reportdata.r_qpr,$rootScope.reportdata.r_qpid);
                           }
                       }
                break;
                default: break;
            }
        }
        e.stopPropagation();
    }

    $rootScope.goDeleteQuip = function() {
        API.deleteQuip({
            unique_id : $rootScope.delete_quip_unique_id
        },function(data){},function(err){});
        $scope.selectedQuipTopics.forEach(function(entry,index){
            if(entry.unique_id == $rootScope.delete_quip_unique_id){
                $scope.selectedQuipTopics.splice(index,1);
            }
        });
        $rootScope.closepopoverreport();
    }

    $scope.$on('updateratetopic', function(event, args) {
        var unique_id = args.unique_id;
        var counted = args.counted;
        var rating = args.rating;
        for(var i =0; i < $scope.selectedQuipTopics.length; i++){
            if($scope.selectedQuipTopics[i].unique_id == unique_id){
                $scope.selectedQuipTopics[i].is_favorited = 1;
                var currentave = $scope.selectedQuipTopics[i].average_stars;
                var ratedvalue = rating;
                if(currentave == 0){
                    var countdev = 1;
                }else{
                    var countdev = 2;
                }
                var latest_ave = (currentave + ratedvalue) / countdev;
                $scope.selectedQuipTopics[i].average_stars = Math.round(latest_ave);
                $scope.selectedQuipTopics[i].is_favorited_img = "img/star-quiped.png";
            }
        }
    });

    $scope.$on('updaterequiptopic', function(event, args) {
        var unique_id = args.unique_id;
        var id_val = args.id_val;
        for(var i =0; i < $scope.selectedQuipTopics.length; i++){
            if($scope.selectedQuipTopics[i].unique_id == unique_id){
                if(id_val == "requip_"){
                    $scope.selectedQuipTopics[i].is_requipped_img = "img/done-requip-icon.png";
                    $scope.selectedQuipTopics[i].quips_count = $scope.selectedQuipTopics[i].quips_count + 1;
                    $scope.selectedQuipTopics[i].is_requipped_id = 'undorequip_'+unique_id;
                }else{
                    $scope.selectedQuipTopics[i].is_requipped_img = "img/requip-quip.png";
                    $scope.selectedQuipTopics[i].quips_count = $scope.selectedQuipTopics[i].quips_count - 1;
                    $scope.selectedQuipTopics[i].is_requipped_id = 'requip_'+unique_id;
                }
            }
        }
    });
})