this.inputData = '';

this.onmessage = function (params) {
	sendAjax(params);
}

var sendAjax = function(params){
	this.apiUrl = params.data.apiUrl;	
	this.callParams = params.data.callParams;
	this.callHeaders = params.data.callHeaders;

	ajax(this.apiUrl, this.callParams , function(data) {
	   //do something with the data like:
	   self.postMessage(data);
	   setTimeout(function(){
	   	sendAjax(params);
	   },5000)
	}, 
	'GET', 
	this.callHeaders);
}

var ajax = function(url, data, callback, type, callHeaders) {
	  var data_array, data_string, idx, req, value;
	  if (data == null) {
	    	data = {};
	  }
	  if (callback == null) {
	    callback = function() {};
	  }
	  if (type == null) {
	    //default to a GET request
	    type = 'GET';
	  }
	  data_array = [];
	  for (idx in data) {
	    value = data[idx];
	    data_array.push("" + idx + "=" + value);
	  }
	  data_string = data_array.join("&");
	  req = new XMLHttpRequest();
	  
	  url = url + '?' + data_string;

	  req.open(type, url, false);
	  //req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  req.setRequestHeader("devtoken", callHeaders.devtoken );
	  req.setRequestHeader("userlang", callHeaders.userlang );
	  req.setRequestHeader("cache-control", callHeaders.cachecontrol );
	  
	  req.onreadystatechange = function() {
	    if (req.readyState === 4 && req.status === 200) {
	      return callback(req.responseText);
	    }
	  };	 

	  req.send(data_string);
	  return req;
};