// Ionic Starter App// Ionic Starter App

/*angular.module('underscore', [])
.factory('_', function() {
return window._; // assumes underscore has already been loaded on the page
});*/

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('quipsphere', [
    'ionic',
    'ionic-datepicker',
    'ionic-timepicker',
    'angularMoment',
    'quipsphere.controllers',
    'quipsphere.auth.controllers',
    'quipsphere.topic.controllers',
    'quipsphere.msngr.controllers',
    'quipsphere.record.controllers',
    'quipsphere.editquip.controllers',
    'quipsphere.profile.controllers',
    'quipsphere.newsfeed.controllers',
    'quipsphere.sphere.controllers',
    'quipsphere.privatequip.controllers',
    'quipsphere.tab.controllers',
    'quipsphere.searchpage.controllers',
    'quipsphere.directives',
    'quipsphere.filters',
    'quipsphere.services',
    'quipsphere.factories',
    'quipsphere.services.api',
    'quipsphere.services.player',
    'quipsphere.config',
    'quipsphere.views',
    'ngResource',
    'ngCordova',
    'sphere.ionSpherecoverHeader',
    'dbaq.ionCoverHeader',
    'btford.socket-io',
    'vs-repeat'
    //'quipsphere.ionic.audio'
])

.constant('$ionicLoadingConfig', {
    template: '<ion-spinner icon="lines"></ion-spinner>',
    hideOnStateChange: true,
    duration: 5000
})


.run(function($ionicPlatform, PushNotificationsService, $rootScope, $ionicConfig, $ionicPopup,$timeout,
    $cordovaNetwork, $ionicHistory, $state, DEVTOKEN, $ImageCacheFactory, $ionicScrollDelegate, $ionicModal,
    GetData, API, Country, SecuredPopups,$ionicSlideBoxDelegate, $ionicPopover, $ionicLoading, $log, deviceType, 
    Constant, Toast, socket, $window, NewsfeedService, MysphereService, SphereService, $cordovaMedia,
    $cordovaSplashscreen, $cordovaToast, PrvService, ClockSrv, $cordovaPush, $cordovaDevice, $cordovaAppVersion ) {
    
    
    //For Fast Click
    //FastClick.attach(document.body);

    //For Virtual Scroll
    $rootScope.viewportheight = $window.innerHeight - 60 - 45;

    //socket events
    $rootScope.currentstate = '';
    $rootScope.me_socketid = '';
    $rootScope.countNewChatMsgs = 0;
    $rootScope.showchatbadge = false;
    $rootScope.countryList = Country.list;
    $rootScope.searchselected = "topic";
    $rootScope.reportdata = [];
    $rootScope.currentquipperfollower = "";
    $rootScope.currentquipperfollowing = "";
    
    
    if (window.localStorage['quipper_id']!= 'undefined' 
        && window.localStorage['quipper_id']!= undefined 
        && window.localStorage['quipper_id']!= '' 
        && window.localStorage['quipper_id']!= 'null'){    
        if (window.localStorage['user_data']!= 'undefined' 
            && window.localStorage['user_data']!= undefined 
            && window.localStorage['user_data']!= '' 
            && window.localStorage['user_data']!= 'null'){        
            $rootScope.me = JSON.parse(window.localStorage['user_data'] );
            $rootScope.me_quipperid = window.localStorage['quipper_id']  ;            
            $rootScope.me_name = $rootScope.me.fname + ' ' + $rootScope.me.lname;  
            imageURI = Constant.QUIPSHERE_API_HOST+ '/quipper/getprofilepic?quipperid=' + window.localStorage['quipper_id'];
            $rootScope.me_avatar_url = imageURI;  
        }      
    }

    socket.on('connect', function(){
            //console.log('check 2', socket.connected);
            socket.emit('adduser', $rootScope.me_name , $rootScope.me_quipperid, $rootScope.me_avatar_url);
    });    

    socket.on('hellochatter', function(name, msg, me_socketid) {                  
                $rootScope.me_socketid = me_socketid;
    });     

    socket.on('unreadmsg', function(objid, from_quipperid, from_name, from_handle, from_avatarurl, rcvr_socketid,  sentmsg) {               
           var countNewChats = 0;
           var showToast = false;

           /*for toast*/
           var toastVerticalPosition = 0;
            
            if(window.screen.height < 640){
                toastVerticalPosition = -150;
            }else{
                toastVerticalPosition = (Math.round(window.screen.height/2)-20)*(-1);
                //toastVerticalPosition = -300;
            }

           if ($rootScope.currentstate != 'msngr.prv_msg' &&
                $rootScope.currentstate != 'app.chathome'){

                showToast = true;

                if (window.localStorage['unreadmsg'] ) {
                var objids = window.localStorage['unreadmsg'];
                var tmpobjids = objids.split('|');
                if (tmpobjids.length > 0){
                    countNewChats = tmpobjids.length +1 ; 
                    window.localStorage['unreadmsg'] = objids + '|' + objid;
                }else{
                    window.localStorage['unreadmsg'] = objid;  countNewChats = 1;                     
                }
                
            }else{
                window.localStorage['unreadmsg'] = objid; countNewChats = 1;    
                showToast = false;      
            }

            if (countNewChats > 0){
                $rootScope.countNewChatMsgs = countNewChats;
                $rootScope.showchatbadge = true;
            }else{
                $rootScope.showchatbadge = false;
            }
            

            if (showToast == true){
                 if(Constant.DEVELOPER_MODE == false){                    
                    Toast.show("You have a new chat message","short","bottom",
                            toastVerticalPosition,function(success){
                        },function(error){});     
                    
                }
            }
            
           }

    });

     //**--------end of socket chat -- **//
    $rootScope.flagsplash = 0;
    $rootScope.canQuip = true;
    $rootScope.currenturl = "app.home";
    $rootScope.allImages = [];
    $rootScope.lasturl = {};
    $rootScope.selectedtopics = {};
    $rootScope.newsfeeds = [];
    $rootScope.isOnline = true;
    $rootScope.isOffline = false;
    $rootScope.zoomMin = 1;
    $rootScope.routeStack = ['home'];
    $rootScope.postBackRoute = '';
    $rootScope.isprivate = 0;
    $rootScope.prv_to_quipperid = [];
    $rootScope.hastopicsearch = '';
    $rootScope.selectedrate = {};
    $rootScope.userdata = {};
    $rootScope.ratedata = {};
    $rootScope.uniqueid = {};
    $rootScope.routeParams = {};
    $rootScope.quipforsphere = false;

    //console.log("DEVELOPER MODE " + Constant.DEVELOPER_MODE);
    $rootScope.rateRecordset = [];

        if (deviceType.isAny()) {
           //$rootScope.online = navigator.onLine;
           $rootScope.isOnline = $cordovaNetwork.isOnline();
           $rootScope.isOffline = $cordovaNetwork.isOffline();
           // listen for Online event
           $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
               console.log("Online")
               $rootScope.isOnline = true;
               $rootScope.isOffline = false;
           })

           // listen for Offline event
           $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
               console.log("Offline")
               $rootScope.isOnline = false;
               $rootScope.isOffline = true;
           })
       }

        $rootScope.CannotQuip = function(){
            $rootScope.$broadcast("checkCanQuip");
        }
        $rootScope.checkbroadcast = function(value){
            // console.log(value);
        }

        window.addEventListener('native.keyboardshow', function(){
            document.body.classList.add('keyboard-open');
        });

        /*if($rootScope.user_data.firstlogin == 0){
            $rootScope.openModalBadge('img/badges/apple.png', 'CONGRATULATIONS for signing up! <br/>You got a Green Apple badge.');

               var data = {
                quipper_id: $rootScope.user_data.quipper_id
            };
            API.firstLogin(data, cb_success, cb_error);
        }*/


        //Place here all OnDeviceReady functions
        $ionicPlatform.on("deviceready", function(){

            $cordovaAppVersion.getAppVersion().then(function (version) {
                window.localStorage['quipsphere_app_version'] = version;
            });

            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if(window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if(window.StatusBar) {
                StatusBar.styleDefault();
            }

            $ionicPlatform.ready(function() {
                /*
                // then override any default you want
                window.plugins.nativepagetransitions.globalOptions.duration = 500;
                window.plugins.nativepagetransitions.globalOptions.iosdelay = 150;
                window.plugins.nativepagetransitions.globalOptions.androiddelay = 150;
                window.plugins.nativepagetransitions.globalOptions.winphonedelay = 150;
                window.plugins.nativepagetransitions.globalOptions.slowdownfactor = 4;
                // these are used for slide left/right only currently
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop = 0;
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsBottom = 0;
                */
                setTimeout(function() {
                    $cordovaSplashscreen.hide();
                }, 500);

            });
            if($rootScope.user_data.quipper_id){
                PushNotificationsService.register();
            }
        });

        $ionicPlatform.registerBackButtonAction(function (event) {
            switch($state.current.name){
                case 'app.newsfeed':
                case 'app.list':
                case 'app.mysphere':
                case 'app.myprofile':
                    $rootScope.reRoute('go','home');
                    $rootScope.goto('app.home');
                    break;
                case 'app.home':
                case 'auth.walkthrough':
                    event.preventDefault();
                    event.stopPropagation();
                    $rootScope.popUp(
                        'Are you sure you want to close this app?',
                        's',
                        'Quipsphere',
                        function(e) {
                            event.preventDefault();
                            ionic.Platform.exitApp();
                        }
                    );
                    break;
                default:
                    $rootScope.goback();
                    break;
            }
        }, 100);

        $rootScope.global =  {
            'devtoken':DEVTOKEN,
            'userlang':'en'
        };
        var user_data = window.localStorage['user_data'];
        if(user_data == '' || user_data == null || user_data == 'null'){
            $rootScope.user_data = {}; 
        }else{
            $rootScope.user_data = JSON.parse(user_data); 
        }

        $rootScope.lasttempurl = {url:'',id:''}; 
        $rootScope.lasturlarray = [];
        $rootScope.triggerbygoback = false;
        $rootScope.tempAudioFile = '';

        $rootScope.trend = {};
        $rootScope.trend['topic'] = {};
        $rootScope.trend.topic['images'] = [];
        $rootScope.trend['quippers'] = {};
        $rootScope.trend['spheres'] = {};
        $rootScope.topicdata = [];
        $rootScope.threadParentUniqueId = '';
        $rootScope.viewProfileUniqueId = '';

        $rootScope.threadparent = [];
        $rootScope.threadchild = [];
        $rootScope.showthreadloading = false;
        $rootScope.showloadmoreloading = false;

        var playedicon = 'img/quip_play_icon.png';
        var pausedicon = 'img/quip_pause_icon.png';
        var loadingicon = 'img/quip_loading_icon.gif';

        /** media **/
        $rootScope.media = document.getElementById('quip_audio_src');
        var mediaLoadedFlag = 0;
        $rootScope.mediaPausedFlag = 0;
        $rootScope.currentMediaId = '';
        $rootScope.quipPlayerItem = null;

        $rootScope.media.addEventListener('ended', function(e) {
            $rootScope.mediaPausedFlag = 1;
            var currentPlayerImage = document.querySelectorAll("#quipmedia");
            if ($rootScope.routeStack[0] == 'newsfeed'){
                currentPlayerImage = document.querySelectorAll("#quipmedia_"+$rootScope.newsfeedUniqueId);
            }
            for(var i=0;i<currentPlayerImage.length;i++){
                currentPlayerImage[i].setAttribute('src',playedicon);
            }
            //console.log($rootScope.routeStack);
            //console.log($rootScope.sphereQuipUniqueId);
            $rootScope.quipPlayerItem.src = playedicon;
            if ($rootScope.routeStack[1] == 'app.sphere'){
                currentPlayerImage = document.querySelectorAll("#quipmedia_"+$rootScope.sphereQuipUniqueId);
                for(var i=0;i<currentPlayerImage.length;i++){
                    currentPlayerImage[i].setAttribute('src','img/newsfeed/quip_play_icon_1.png');
                }
            }
  
            $rootScope.$broadcast("sphereRunQueueEnded");
        } );

        $rootScope.media.addEventListener('pause', function() {
            $rootScope.mediaPausedFlag = 1;
            $rootScope.$broadcast("sphereRunQueuePaused");
        });
        $rootScope.media.addEventListener('play', function() {
            //console.log(window.localStorage['quipper_id']+' & '+$rootScope.currentMediaId);
            var qdata = {'quip_unique_id':$rootScope.currentMediaId,'quipper_id':window.localStorage['quipper_id']};
            API.updateHeared(qdata, function(data){
            }, function(data){
                $log.info('error on played update');
            });
            $rootScope.mediaPausedFlag = 0;
        });
        $rootScope.media.addEventListener('canplaythrough', function() {
            //console.log('ready to play');
            $rootScope.media.play();
            mediaLoadedFlag = 1;
            // changee icon to paused
            $rootScope.quipPlayerItem.src = pausedicon;
        }, false);
        $rootScope.media.addEventListener("load", function() {
            //console.log('loaded');
        }, true);
        /** media **/


        //Initialize Workers Multi Threading
        //For Newsfeed Worker
        // $rootScope.newsfeeds = [];
        // var apiUrl = Constant.QUIPSHERE_API_HOST + "/newsfeed/get";
        // var callParams = {'get': 'true', 'quipper_id': $rootScope.user_data.quipper_id , 'action' : 'refresh', 
        //                     'start': 0, 'root_country_code' : '', 'root_quipper_id' : $rootScope.user_data.quipper_id };
        //  var callHeaders = {
        //         'devtoken': $rootScope.global.devtoken, 
        //         'userlang' : $rootScope.global.userlang,
        //         'cachecontrol' : 'no-cache'            
        //     }
        // var nfsParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
        // NewsfeedService.doWork(nfsParams);


        // $rootScope.prvcount = "";

        // $rootScope.startMyPrvService = function(){
        //     $rootScope.Prvservice = new PrvService();
        //     $rootScope.Prvservice.params.callParams.quipper_id = $rootScope.user_data.quipper_id;
        //     $rootScope.Prvservice.params.callParams.root_quipper_id = $rootScope.user_data.quipper_id;
        //     $rootScope.Prvservice.params.callHeaders.devtoken = $rootScope.global.devtoken;
        //     $rootScope.Prvservice.params.callHeaders.userlang = $rootScope.global.userlang;
        //     $rootScope.Prvservice.doWork($rootScope.Prvservice.params, function(data){
        //         console.log(data);
        //     });
        // }

        //$rootScope.startMyPrvService();
        //******** Web workers

        // var apiUrl = Constant.QUIPSHERE_API_HOST + "/sphere/getunreadcountbysphereid";
        // var callParams = {
        //     'get': 'true', 
        //     'quipper_id': $rootScope.user_data.quipper_id , 
        //     'root_country_code' : '', 
        //     'root_quipper_id' : $rootScope.user_data.quipper_id 
        // };
        // var callHeaders = {
        //     'devtoken': $rootScope.global.devtoken, 
        //     'userlang' : $rootScope.global.userlang,
        //     'cachecontrol' : 'no-cache'            
        // }
        // var mssParams = {apiUrl : apiUrl, callParams: callParams, callHeaders: callHeaders };
        $rootScope.spbadgeTimer = new ClockSrv();
        $rootScope.startMySphereWebService = function(){
            $rootScope.Mservice = new SphereService();
            $rootScope.Mservice.params.callParams.quipper_id = $rootScope.user_data.quipper_id;
            $rootScope.Mservice.params.callParams.root_quipper_id = $rootScope.user_data.quipper_id;
            $rootScope.Mservice.params.callHeaders.devtoken = $rootScope.global.devtoken;
            $rootScope.Mservice.params.callHeaders.userlang = $rootScope.global.userlang;
            $rootScope.Mservice.doWork($rootScope.Mservice.params);
            $rootScope.spbadgeTimer.startClock(function(){
                var _spb = document.querySelector("#divNavSpheres img");
                //console.log(_spb)
                if(_spb != null){
                    var _rect = _spb.getBoundingClientRect();
                    //var _top = _rect.top+20;
                    var _top = 30;
                    var _left = _rect.left+20;
                    document.querySelector(".myfooter").style.top = "30px";
                    document.querySelector(".myfooter").style.left = _left+"px";
                    //$rootScope.spbadgeTimer.stopClock();              
                }
                var _spb = document.querySelector("#divNavSpheres2 img");
                //console.log(_spb)
                if(_spb != null){
                    var _rect = _spb.getBoundingClientRect();
                    //var _top = _rect.top+20;
                    var _top = 30;
                    var _left = _rect.left+20;
                    document.querySelector(".myfooter2").style.top = "30px";
                    document.querySelector(".myfooter2").style.left = _left+"px";
                    //$rootScope.spbadgeTimer.stopClock();              
                }
            },500);
        }

        $rootScope.startMySphereWebService();

        $ImageCacheFactory.Cache([
            "img/record-bg.jpg",
            "img/record-bg2.jpg",
            "img/record-mic-on.png",
            "img/record-button-unpressed.png",
            "img/record-button-pressed.png",
            "img/quippers_img/1.jpg",
            "img/quippers_img/2.jpg",
            "img/quippers_img/3.jpg",
            "img/topic_img/1.jpg",
            "img/topic_img/2.jpg",
            "img/topic_img/3.jpg"

        ]).then(function(){
            // console.log("Images done loading!");
            },function(failed){
                // console.log("An image filed: "+failed);
        });
        $rootScope.changeCountry = function(country){
            var user_data = JSON.parse(window.localStorage['user_data']);
            user_data.country = country;
            user_data.country_name = Country.getName(country);
            window.localStorage['user_data'] = JSON.stringify(user_data);
            $rootScope.user_data = JSON.parse(window.localStorage['user_data']);
            //console.log($rootScope.user_data);
        }
        $rootScope.goBackFromViewProfile = function(){
            $rootScope.reRoute('back');
        }

        /* modified goto and goback */
        $rootScope.goback = function(){
            var getid = "";
            getid = $rootScope.lasturl.paramid;
            $rootScope.triggerbygoback = true;
            var luac = $rootScope.lasturlarray.length - 1;
            $rootScope.goto($rootScope.lasturlarray[luac].url,$rootScope.lasturlarray[luac].params);
            delete $rootScope.lasturlarray[$rootScope.lasturlarray.length--];
            //console.log($rootScope.lasturlarray);
            $rootScope.reRoute('back');
        }

        $rootScope.navchangeButton = function(elId, imgId, direction){
            //remove active class first
            /*var elems = document.getElementsByClassName('.navbtn');
            for(i =0; i < elems.length; i++){                
                elems[0].classList.remove("activefooter");                  
            }*/

            var elems = document.querySelectorAll(".col.navbtn");
            [].forEach.call(elems, function(el) {
                el.className = el.className.replace(/\activefooter\b/, "");
            });

            var el = document.getElementById(elId);
            el.classList.add("activefooter");

           /* var elems = document.querySelectorAll("img.footer-icon");
            [].forEach.call(elems, function(el) {
                el.className = el.classList.add("invert");                
            });

            var imgEl = document.getElementById(imgId);                        
            imgEl.className = imgEl.className.replace(/\invert\b/, "");
*/
            switch(direction){
                case 'app.home':
                    $rootScope.reRoute('go','home');
                    $rootScope.goto('app.home',{});
                break;
                case 'app.newsfeed':
                    $rootScope.reRoute('go','newsfeed');
                    $rootScope.goto('app.newsfeed',{});                    
                break;
            }

            

            return;

            //{{currenturl === \'app.home\'? \'activefooter\': \'\' }}
            // {{currenturl === \'app.newsfeed\'? \'activefooter\': \'\' }}
            // {{currenturl === \'app.chathome\'? \'activefooter\': \'\' }}
            // {{currenturl === \'app.mysphere\'? \'activefooter\': \'\' }}
        }

        $rootScope.goto = function(url, param, transitiontype, direction){
            $ionicHistory.nextViewOptions({
                disableAnimate: true
            });

            //$rootScope.modalnewsfeed.hide();

            //$ionicHistory.clearCache();
            //$ionicHistory.clearHistory();
            // if(url === $state.current.name){
            //     return;
            // }



            $rootScope.currenturl = url;
            $state.go(url, param);
        }
        /* modified goto and goback */


        // This fixes transitions for transparent background views
        $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
            
            if(!$rootScope.triggerbygoback){
                // console.log('not triggerbygoback ' +$rootScope.triggerbygoback);
                // console.log('adding ' +JSON.stringify({url:fromState.name,id:fromParams.id}));
                $rootScope.lasturlarray.push({url:fromState.name,params:fromParams})
                $rootScope.triggerbygoback = false;
            }else{
                // console.log('triggerbygoback ' +$rootScope.triggerbygoback);
                $rootScope.triggerbygoback = false;
            }
            if(toState.name.indexOf('auth.walkthrough') > -1)
            {
                // set transitions to android to avoid weird visual effect in the walkthrough transitions
                $timeout(function(){
                    $ionicConfig.views.transition('android');
                    $ionicConfig.views.swipeBackEnabled(false);
                    // console.log("setting transition to android and disabling swipe back");
                    }, 0);
            }
        });
        $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams){
            
            //record the current state change globally
            $rootScope.currentstate  = toState.name;

            if(toState.name.indexOf('app.feeds-categories') > -1)
            {
                // Restore platform default transition. We are just hardcoding android transitions to auth views.
                $ionicConfig.views.transition('platform');
                // If it's ios, then enable swipe back again
                if(ionic.Platform.isIOS())
                {
                    $ionicConfig.views.swipeBackEnabled(true);
                }
                //console.log("enabling swipe back and restoring transition to platform default", $ionicConfig.views.transition());
            }
        });


        $rootScope.popAlert = function(msg, status, title, btn_text, ontap_callback) {
            var txt_color = "";
            if(status=="e"){
                txt_color = "red";
            }
            if(status=="s"){
                txt_color = "blue";
            }
            if(title == null){
                title = '';
            }
            if(btn_text == null){
                btn_text = 'OK';
            }

            var alertPopup =SecuredPopups.show('alert',{
                title: title,
                //template: '<p style="color:'+txt_color+'">'+msg+'</p>',
                template: '<p>'+msg+'</p>',
                buttons: [
                    {
                        text: btn_text,
                        type: 'button',
                        onTap: function(e) {
                            ontap_callback(e);
                        }
                    }
                ]
            });
        };
        $rootScope.popUp = function(msg, status, title, ontap_callback) {
            var txt_color = "";
            if(status=="e"){
                txt_color = "red";
            }
            if(status=="s"){
                txt_color = "blue";
            }
            var myPopup = SecuredPopups.show('show',{
                title: title,
                template: '<p>'+msg+'</p>',
                buttons: [
                    {
                        text: 'YES',
                        type: 'button button-dark text-white',
                        onTap: function(e) {
                            ontap_callback(e);
                        }
                    },
                    { text: 'NO' }
                ]
            });
        };

        $rootScope.popShow = function() {
            $rootScope.sphere_test = {}
        
              // Custom popup
              var myPopup =  SecuredPopups.show('show',{
                 template: '<input type = "text" ng-model = "data.model">',
                 title: 'Title',
                 subTitle: 'Subtitle',
                 scope: $rootScope,                    
                 buttons: [
                    { text: 'Cancel' }, {
                       text: '<b>Save</b>',
                       type: 'button-positive',
                          onTap: function(e) {
                                
                             if (!$rootScope.sphere_test.model) {
                                //don't allow the user to close unless he enters model...
                                   e.preventDefault();
                             } else {
                                return $rootScope.sphere_test.model;
                             }
                          }
                    }
                 ]
              });

              myPopup.then(function(res) {
                 //console.log('Tapped!', res);
              }); 
        };
        
        // $ionicPlatform.on("resume", function(){
        //     if($rootScope.user_data.quipper_id){
        //         PushNotificationsService.register();
        //     }
        // });

        angular.element(document).on("click", function(e) {
            $rootScope.$broadcast("documentClicked", angular.element(e.target));
        });

        /*modals*/
          $rootScope.openModalBadge = function(badge_image, badge_message) {
            $rootScope.modalBadge = $ionicModal.fromTemplate( 
                '<div class="modal"  style="background-color:rgba(0,0,0,0.5); text-align:center;" >' +
                     '<img style="width:200px;margin-top:25%;" ng-src="'+badge_image+'"/><br/>' +
                     '<p style="color:#fff; font-size:20px; margin-top:20px;">'+badge_message+'</p>' +
                     '<button class="button button-assertive" style="color:#fff; font-size:16px;" on-tap="closeModalBadge()">OK</button>' +
               '</div>'
               , {
                scope: $rootScope,
                animation: 'slide-in-up'
            })  
            $rootScope.modalBadge.show();
          }

          $rootScope.closeModalBadge = function() {
            $rootScope.modalBadge.hide();
            $rootScope.modalBadge.remove();
          };
          

        /*images modal*/
        $rootScope.showImages = function(images) {
            $rootScope.allImages = [];
            for(i = 0; i < images.length; i++ ){
                $rootScope.allImages.push({src: images[i].img } );
            }
            $rootScope.showModalImggallery();
        };     
        $rootScope.showModalImggallery = function() {
            $ionicModal.fromTemplateUrl('views/modals/modal-image-slider.html', {
                scope: $rootScope
            }).then(function(modal) {
                $rootScope.modalImggallery = modal;
                $rootScope.modalImggallery.show();
            });
        }

        $rootScope.closeModalImggallery = function() {
            $rootScope.modalImggallery.hide();
            $rootScope.modalImggallery.remove();
        };

        $rootScope.updateSlideStatus = function(slide) {
            var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandleimg'+slide).getScrollPosition().zoom;
            if (zoomFactor == 1) {
              $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(true);
            } else {
              $ionicSlideBoxDelegate.$getByHandle("imghandle").enableSlide(false);
            }
        };

        /* edit quip */
        $ionicModal.fromTemplateUrl('views/modals/modal-edit-quip.html', {
            id: 'modal-edit-quip',
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.modaleditquip = modal
        });

        $rootScope.openEditQuipModal = function() {
            if($rootScope.canQuip){
                $rootScope.reRoute('go','editquip');
                $rootScope.modaleditquip.show();
                $rootScope.startEditQuipPage();
            }else{
                $rootScope.CannotQuip();
            }
        };
        $rootScope.closeEditQuipModal = function(postedFlag) {
            $rootScope.modaleditquip.hide();
            $rootScope.dontToast = 1;
            $rootScope.endEditQuipPage();
            if(postedFlag == 0){
                $rootScope.openRecorderModal();
                $rootScope.reRoute('back');
            }
            /*$rootScope.modaleditquip.remove();
            $ionicModal.fromTemplateUrl('views/modals/modal-edit-quip.html', {
                id: 'modal-edit-quip',
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $rootScope.modaleditquip = modal
            });*/
        };

        $ionicModal.fromTemplateUrl('views/modals/modal-gallery.html', {
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.modalgallery = modal
        });

        $rootScope.openGalleryModal = function() {
            $rootScope.modalgallery.show();
        };
        $rootScope.closeGalleryModal = function() {
            $rootScope.modalgallery.hide();
        };

        $ionicModal.fromTemplateUrl('views/modals/modal-quipper.html', {
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.modalquipper = modal
        });
        $rootScope.openQuipperModal = function(val) {
            if($rootScope.cur_quipperselected != ""){
                if($rootScope.cur_quipperselected != val){
                    $rootScope.showloading = true;
                    API.viewProfille({
                        quipper_id:$rootScope.user_data.quipper_id,
                        target_quipper_id: val
                        },function(data){
                            $rootScope.selectedquippers = [];
                            window.localStorage['selectedquippers'] = JSON.stringify(data.Data);
                            $rootScope.selectedquippers = JSON.parse(window.localStorage['selectedquippers']);
                            $timeout(function(){
                                $rootScope.showloading = false;
                                },3000);
                        },function(err){
                            $rootScope.showloading = false;
                    });
                }
            }
            else{
                $rootScope.showloading = true;
                API.viewProfille({
                    quipper_id:$rootScope.user_data.quipper_id,
                    target_quipper_id: val
                    },function(data){
                        $rootScope.selectedquippers = [];
                        window.localStorage['selectedquippers'] = JSON.stringify(data.Data);
                        $rootScope.selectedquippers = JSON.parse(window.localStorage['selectedquippers']);
                        $timeout(function(){
                            $rootScope.showloading = false;
                            },3000);
                    },function(err){
                        $rootScope.showloading = false;
                });
            }
            $rootScope.cur_quipperselected = val;
            $rootScope.modalquipper.show();
        };
        $rootScope.closeQuipperModal = function() {
            $rootScope.modalquipper.hide();
        };

        $ionicModal.fromTemplateUrl('views/modals/modal-topic-thread.html', {
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modal) {
            $rootScope.modaltopicthread = modal
        });
        $rootScope.stoploadingthreadtopic = true;
        $rootScope.openTopicThreadModal = function(val) {

            $rootScope.showthreadloading = true;
            $rootScope.quip_uniqueid = val;
            $rootScope.modaleditquip.hide();
            $rootScope.modaltopicthread.show();
            $rootScope.threadparent = [];
            $rootScope.threadchild = [];
             if($rootScope.routeStack[0] == 'newsfeed' ||
                    $rootScope.routeStack[0] == 'quippers'){
                    API.getThreadParent({
                        root_quipper_id:$rootScope.user_data.quipper_id,
                        get: true,
                        unique_id:val
                    },function(data){
                        $rootScope.threadparent = data.Data;

                        API.getThreadChild({
                            get: true,
                            start: 0,
                            unique_id:val,
                            action:'refresh'
                        },function(data){
                            $rootScope.threadchild = data.Data;
                            $rootScope.stoploadingthreadtopic = false;
                            var parentelement = document.querySelector("#threadcontainer");
                            parentelement.addEventListener("click", modalthreadevent, false);
                            PullToRefresh.init({
                                contentEl:"th-content",
                                ptrEl:"th-ptr",
                                limittrigger:'th-container',
                                bodyId:'th-bodycontainer',
                                loadingFunction: getnewerquipth,
                                scrollpoint: 20
                            });
                            $ionicLoading.hide();
                        },function(err){
                            $rootScope.showthreadloading = false;
                        });
                        $rootScope.showthreadloading = false;
                    },function(err){});
                }else{
                    API.getThreadParent({
                        root_quipper_id:$rootScope.threadParentUniqueId,  //$rootScope.user_data.quipper_id,
                        get: true,
                        unique_id:val
                    },function(data){
                        $rootScope.threadparent = data.Data;
                        API.getThreadChild({
                            get: true,
                            unique_id:val,
                            start:0,
                            action:'refresh'
                        },function(data){
                            $rootScope.threadchild = data.Data;
                            $rootScope.stoploadingthreadtopic = false;
                            $rootScope.showthreadloading = false;
                            var parentelement = document.querySelector("#threadcontainer");
                            parentelement.addEventListener("click", modalthreadevent, false);
                            PullToRefresh.init({
                                contentEl:"th-content",
                                ptrEl:"th-ptr",
                                limittrigger:'th-container',
                                bodyId:'th-bodycontainer',
                                loadingFunction: getnewerquipth,
                                scrollpoint: 20
                            });
                        },function(err){
                            $rootScope.showthreadloading = false;
                        });

                    },function(err){

                    });
                }
        };
        function getnewerquipth(){
            return new Promise( function( resolve, reject ) {
                if (true) {
                    resolve();
                    var unique_id = $rootScope.quip_uniqueid;

                    //console.log($rootScope.threadchild[0].quipid);
                    API.getThreadChild({
                        get: true,
                        unique_id:unique_id,
                        start: $rootScope.threadchild[0].quipid,
                        action:'refresh'
                    },function(data){
                        $rootScope.threadchild = data.Data.concat($rootScope.threadchild);
                        
                    },function(err){
                        $rootScope.showthreadloading = false;
                    });0
                     
                } else {
                    reject();
                }
            } );
        }

        $rootScope.get_oldreply = function(){
            if($rootScope.stoploadingthreadtopic == false){
                //console.log($rootScope.threadchild[$rootScope.threadchild.length - 1].quipid);
                API.getThreadChild({
                    get: true,
                    limit: 1,
                    unique_id:$rootScope.threadparent.unique_id,
                    end: $rootScope.threadchild[$rootScope.threadchild.length - 1].quipid,
                    action:"showmore"
                    },function(data){
                        if(data.Data.length > 0){
                            for(var i = 0; i < data.Data.length; i++){

                            $rootScope.threadchild.push(data.Data[i]);
                            }
                        }else{
                            $rootScope.stoploadingthreadtopic = true;
                        }
                        $rootScope.$broadcast('scroll.infiniteScrollComplete');
                    },function(err){
                        $rootScope.$broadcast('scroll.infiniteScrollComplete');
                });
                var loadinginficon = document.getElementsByClassName("loading-inf2");
                loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
            }
        }

        $rootScope.closeTopicThreadModal = function() {
            $rootScope.$broadcast("topicthreadclosed");
            $rootScope.$broadcast("activePullToRefresh");
            $rootScope.modaltopicthread.hide();
            var parentelement = document.querySelector("#threadcontainer");
            if(parentelement){
                parentelement.removeEventListener("click", modalthreadevent, false);
            }
        };
        $rootScope.$on('topicthreadclosed',function(){
            //$rootScope.reRoute('back');
        });

        $ionicModal.fromTemplateUrl('views/modals/modal-sphere.html', {
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.modalsphere = modal
        });
        $rootScope.openSphereModal = function(val) {
            if($rootScope.cur_sphereselected != ""){
                if($rootScope.cur_sphereselected != val){
                    $rootScope.showloading = true;
                    $rootScope.selectedsphere = GetData.Spheres(val);
                    if($rootScope.selectedsphere){
                        $timeout(function(){
                            $rootScope.showloading = false;
                            },3000);
                    }
                }
            }
            else{
                $rootScope.showloading = true;
                $rootScope.selectedsphere = GetData.Spheres(val);
                if($rootScope.selectedsphere){
                    $timeout(function(){
                        $rootScope.showloading = false;
                        },3000);
                }

            }
            $rootScope.cur_sphereselected = val;
            $rootScope.modalsphere.show();
        };
        $rootScope.closeSphereModal = function() {
            $rootScope.modalsphere.hide();
        };

        /*record studio*/
        $ionicModal.fromTemplateUrl('views/modals/modal-record.html', {
            scope: $rootScope,
            animation: 'none'
        }).then(function(modal) {
            $rootScope.modalrecord = modal
        });

        $rootScope.openRecorderModal = function(val) {
            if(val == 0){
                $rootScope.isprivate = 0;
            }
            $rootScope.hideAllModal();
            $rootScope.modalrecord.show();
            $rootScope.$broadcast('record-modal.shown');
        };

        $rootScope.closeRecorderModal = function(cmdType) {
            // $rootScope.closeTopicsSearchModal();
            // $rootScope.closeQuippersSearchModal();
            // $rootScope.closeSpheresSearchModal();
            $rootScope.closeSearchModals();
            $timeout(function(){
                $rootScope.modalrecord.hide();
                //$rootScope.modalrecord.remove();
                /*$ionicModal.fromTemplateUrl('views/modals/modal-record.html', {
                    scope: $rootScope,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $rootScope.modalrecord = modal
                });*/
                $rootScope.$broadcast('record-modal.hide');
                if(cmdType == 'editquip'){
                }else{
                    $rootScope.quip_current_images_array = [];
                    $rootScope.quip_current_images = '';
                    $rootScope.quip_caption = '';
                    previousRoute = $rootScope.routeStack[$rootScope.routeStack.length-2];
                    if(previousRoute == 'reply thread'){
                        $rootScope.openTopicThreadModal($rootScope.threadParentUniqueId);
                    }else{

                    }
                    $rootScope.reRoute('back');
                }
            },200);
        };
        $rootScope.destroymodal = function(){
            $rootScope.modaleditquip.remove();
            $rootScope.modalrecord.remove();

            $ionicModal.fromTemplateUrl('views/modals/modal-edit-quip.html', {
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $rootScope.modaleditquip = modal
            });

            $ionicModal.fromTemplateUrl('views/modals/modal-record.html', {
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $rootScope.modalrecord = modal
            });
        }

        // Execute action on shown modal
        $rootScope.$on('modal.shown', function(event, modal) {
            // Execute action
            //Check Id of Modal
            if (modal.id == 'modal-edit-quip'){                 
                $rootScope.$broadcast('edit-modal.shown');
            }
        });
        $rootScope.globalFollowEvent = function(e) {
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.title;
                splited = checktarget.split("_");
                switch(splited[0]){
                    case "item":
                        $rootScope.goto('app.view-profile',{id:splited[1]})
                        $rootScope.destroyall();
                        break;
                    case "viewprofile":
                        $rootScope.goto('app.view-profile',{id:splited[1]})
                        $rootScope.destroyall();
                        break;
                    case "follow":
                        //console.log('.follow_'+splited[1]+'_class');
                        var follow_class = document.querySelectorAll('.follow_'+splited[1]+'_class');
                        var unfollow_class = document.querySelectorAll('.unfollow_'+splited[1]+'_class');
                        
                        for(var i = 0; i < follow_class.length; i++){
                            follow_class[i].classList.add("hide-follow");
                        }
                        for(var i = 0; i < unfollow_class.length; i++){
                            unfollow_class[i].classList.remove("hide-unfollow");
                        }
                        API.followQuipper({
                            quipper_id: $rootScope.user_data.quipper_id,
                            target_quipper_id: splited[1]
                            },function(data){console.log(data);
                            },function(err){
                                //console.log(err)
                        });
                        break;
                    case "unfollow":
                        //console.log('.follow_'+splited[1]+'_class');
                        var name = document.querySelector('.fullname_'+splited[1]+'_class').innerText;
                        var msg  = "Stop following "+name+"?";
                        var status = "e";     
                        var title = "Unfollow this Quipper";   
                        $rootScope.popUp(msg, status, title,  function(e){
                            var follow_class = document.querySelectorAll('.follow_'+splited[1]+'_class');
                            var unfollow_class = document.querySelectorAll('.unfollow_'+splited[1]+'_class');
                            
                            for(var i = 0; i < follow_class.length; i++){
                                follow_class[i].classList.remove("hide-follow");
                            }
                            for(var i = 0; i < unfollow_class.length; i++){
                                unfollow_class[i].classList.add("hide-unfollow");
                            }
                            API.unfollowQuipper({
                                quipper_id: $rootScope.user_data.quipper_id,
                                target_quipper_id: splited[1]
                                },function(data){
                                    //console.log('unfollow_'+splited[1]+'_followinglist2');
                                },function(err){
                                    //console.log(err)
                            });
                        });
                        break;
                    default:
                        break;
                }
            }
            e.stopPropagation();
        }
        var globalFollowEventHandler = function(e){
            $rootScope.globalFollowEvent(e);
        }
        
        $rootScope.globalEventHandler = function(e, callback){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.id;
                splited = checktarget.split("_");
                switch(splited[0]){
                    case "requip":
                        var msg = "Would you like to Requip?";
                        var status = "s";
                        var title = "Requip";
                        $rootScope.popUp(msg, status, title,  function(e){
                            callback(splited);
                            var id_val = 'requip_';
                            $rootScope.$broadcast('updaterequipprofile',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequipnf',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequiptopic',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequipqq',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequipvp',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequipvp',{unique_id: splited[1], id_val: id_val});
                            $rootScope.$broadcast('updaterequiplatestquip',{unique_id: splited[1], id_val: id_val});

                            $rootScope.threadparent.is_requipped_img = "img/done-requip-icon.png";
                            $rootScope.threadparent.quip_count = $rootScope.threadparent.quip_count + 1;
                            $rootScope.threadparent.is_requipped_id = 'undorequip_'+splited[1];

                            API.Requip({unique_id:splited[1]},function(data){},function(err){});
                        });
                    break;
                    case "undorequip":
                        var id_val = 'undorequip_';
                        $rootScope.$broadcast('updaterequipprofile',{unique_id: splited[1], id_val: id_val});
                        $rootScope.$broadcast('updaterequipnf',{unique_id: splited[1], id_val: id_val});
                        $rootScope.$broadcast('updaterequiptopic',{unique_id: splited[1], id_val: id_val});
                        $rootScope.$broadcast('updaterequipqq',{unique_id: splited[1], id_val: id_val});
                        $rootScope.$broadcast('updaterequipvp',{unique_id: splited[1], id_val: id_val});
                        $rootScope.$broadcast('updaterequiplatestquip',{unique_id: splited[1], id_val: id_val});

                        $rootScope.threadparent.is_requipped_img = "img/requip-quip.png";
                        $rootScope.threadparent.quip_count = $rootScope.threadparent.quip_count - 1;
                        $rootScope.threadparent.is_requipped_id = 'requip_'+splited[1];
                        
                        API.UndoRequip({unique_id:splited[1]},function(data){},function(err){});
                    break;
                }
                           
            }
        }


        $ionicModal.fromTemplateUrl('views/modals/modal-stars.html', {
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modal) {
            $rootScope.modalstars = modal;
        });

        $rootScope.openStarsModal = function(quipper_id) {

            if(quipper_id){
                //$rootScope.showloading = true;

                API.getStars({
                    quipper_id: $rootScope.user_data.quipper_id,
                    target_quipper_id: quipper_id
                    },function(data){
                        $rootScope.showloading = false;
                        if(data.Result == 1){
                            window.localStorage['modalStars'] = JSON.stringify(data.Data);
                        }          
                        $rootScope.modalStars= JSON.parse(window.localStorage['modalStars']);
                        //console.log(quipper_id);
                        $rootScope.modalStars.show();
                        //console.log(data);

                        var starList = document.querySelector("#star-list");
                        starList.addEventListener("click", globalStarEventHandler, false);

                    },function(err){
                        //$rootScope.showloading = false;
                        //console.log(err);
                });
            }
        };

        $rootScope.closeStarsModal = function() {
            $rootScope.modalstars.hide();
            var starList = document.querySelector("#star-list");
            starList.removeEventListener("click", globalStarEventHandler, false);
        };


        $ionicModal.fromTemplateUrl('views/modals/modal-follower.html', {
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modal) {
            $rootScope.modalfollower = modal;
        });

        $rootScope.openFollowerModal = function(quipper_id) {

            if(quipper_id){
                //$rootScope.showloading = true;
                API.getFollowers({
                    quipper_id: $rootScope.user_data.quipper_id,
                    target_quipper_id: quipper_id
                    },function(data){
                        $rootScope.showloading = false;
                        if(data.Result == 1){
                            window.localStorage['modalFollowers'] = JSON.stringify(data.Data);
                        }          
                        $rootScope.modalFollowers = JSON.parse(window.localStorage['modalFollowers']);
                        //console.log(quipper_id);
                        $rootScope.modalfollower.show();
                        //console.log(data);

                        var followerList = document.querySelector("#follower-list");
                        followerList.addEventListener("click", globalFollowEventHandler, false);

                    },function(err){
                        //$rootScope.showloading = false;
                        //console.log(err);
                });
            }
        };

        $rootScope.closeFollowerModal = function() {
            $rootScope.modalfollower.hide();
            var followerList = document.querySelector("#follower-list");
            followerList.removeEventListener("click", globalFollowEventHandler, false);
        };

        $ionicModal.fromTemplateUrl('views/modals/modal-following.html', {
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modal) {
            $rootScope.modalfollowing = modal;
        });

        $rootScope.openFollowingModal = function(quipper_id) {
            $rootScope.modalfollowing.show();
            if(quipper_id){
                $rootScope.showloadingflw = true;
                API.getFollowings({
                    quipper_id: $rootScope.user_data.quipper_id,
                    target_quipper_id: quipper_id
                    },function(data){
                        $rootScope.showloadingflw = false;
                        if(data.Result == 1){
                            window.localStorage['modalFollowings'] = JSON.stringify(data.Data);
                        }          
                        $rootScope.modalFollowings = JSON.parse(window.localStorage['modalFollowings']);
                        //console.log($rootScope.modalFollowings);

                        var followingList = document.querySelector("#following-list");
                        followingList.addEventListener("click", globalFollowEventHandler, false);

                    },function(err){
                        $rootScope.showloadingflw = false;
                        //console.log(err);
                });
            }
        };

        $rootScope.closeFollowingModal = function() {
            $rootScope.modalfollowing.hide();
            var followingList = document.querySelector("#following-list");
            followingList.removeEventListener("click",globalFollowEventHandler, false);
        };

        $ionicModal.fromTemplateUrl('views/modals/modal-search-page.html', {
            scope: $rootScope,
            animation: 'slide-up',
            focusFirstInput : true
        }).then(function(modal) {
            $rootScope.modalsearchpage = modal;
        });
        $rootScope.openSearchModals = function(){
            $rootScope.modalsearchpage.show();
            $rootScope.$broadcast('updateslide');
        }
        $rootScope.closeSearchModals = function(){
            $rootScope.modalsearchpage.hide();
        }

        // $rootScope.searchfor = 0;
        // $rootScope.searchTopics = [];
        // $rootScope.searchForTopicsText = '';
        // $rootScope.searchForQuippersText = '';
        // $rootScope.searchForSpheresText = '';
        // $rootScope.searchTopicsShowLoading = false;
        // $rootScope.searchQuippersShowLoading = false;
        // $rootScope.searchSpheresShowLoading = false;
        // $rootScope.openSearchModals = function(){
        //     console.log('current slide : ' +$ionicSlideBoxDelegate.$getByHandle('homeslide').currentIndex())
        //     var currentIndex = $ionicSlideBoxDelegate.$getByHandle('homeslide').currentIndex();
        //     if(currentIndex == 0){
        //         $rootScope.openTopicsSearchModal();
        //     }
        //     if(currentIndex == 1){
        //         $rootScope.openQuippersSearchModal();
        //     }
        //     if(currentIndex == 2){
        //         $rootScope.openSpheresSearchModal();
        //     }
        // }
        // $rootScope.btnRemoveSearchFor = function(){
        //     var currentIndex = $ionicSlideBoxDelegate.$getByHandle('homeslide').currentIndex();
        //     if(currentIndex == 0){
        //         $rootScope.searchForTopicsText = '';
        //         window.localStorage['searchTopics'] = JSON.stringify([]);
        //         $rootScope.searchTopics = []; 
        //     } 
        //     if(currentIndex == 1){
        //         $rootScope.searchForQuippersText = '';
        //         window.localStorage['searchQuippers'] = JSON.stringify([]);
        //         $rootScope.searchQuippers = []; 
        //     }
        //     if(currentIndex == 2){
        //         $rootScope.searchForSpheresText = '';
        //         window.localStorage['searchSpheres'] = JSON.stringify([]);
        //         $rootScope.searchSpheres = []; 
        //     } 
        // }
        // $rootScope.btnSearchFor = function(hashhandle){
        //     var currentIndex = $ionicSlideBoxDelegate.$getByHandle('homeslide').currentIndex();
        //     if(currentIndex == 0){
        //         $rootScope.searchTopicsShowLoading = true;
        //         console.log("search for topics");
        //         API.searchTopics({hash:hashhandle},function(data){
        //             $rootScope.searchTopicsShowLoading = false;
        //             if(data.Result==1){
        //                 window.localStorage['searchTopics'] = JSON.stringify(data.Data);
        //                 $rootScope.searchTopics = data.Data;  
        //                 console.log($rootScope.searchTopics);
        //             }else{

        //             }
        //             console.log(data);
        //             },function(err){
        //                 $rootScope.searchTopicsShowLoading = false;
        //                 console.log(err);
        //         });
        //     }
        //     if(currentIndex == 1){
        //         $rootScope.searchQuippersShowLoading = true;
        //         console.log("search for quippers");
        //         API.searchQuippers({hash:hashhandle},function(data){
        //             $rootScope.searchQuippersShowLoading = false;
        //             if(data.Result==1){
        //                 window.localStorage['searchQuippers'] = JSON.stringify(data.Data);
        //                 $rootScope.searchQuippers = data.Data;  
        //                 console.log($rootScope.searchQuippers);
        //             }else{

        //             }
        //             console.log(data);
        //             },function(err){
        //                 $rootScope.searchQuippersShowLoading = false;
        //                 console.log(err);
        //         });
        //     }
        //     if($rootScope.searchfor == 2){
        //         $rootScope.searchSpheresShowLoading = true;
        //         console.log("search for quippers");
        //         API.searchSpheres({hash:hashhandle},function(data){
        //             $rootScope.searchSpheresShowLoading = false;
        //             if(data.Result==1){
        //                 window.localStorage['searchSpheres'] = JSON.stringify(data.Data);
        //                 $rootScope.searchSpheres = data.Data;  
        //                 console.log($rootScope.searchSpheres);
        //             }else{

        //             }
        //             console.log(data);
        //             },function(err){
        //                 $rootScope.searchSpheresShowLoading = false;
        //                 console.log(err);
        //         });
        //     }
        // }
        // var topicEventHandler = function(e){
        //     if (e.target !== e.currentTarget) {

        //         var classtarget = e.target.classList;
        //           for(var i = 0; i < classtarget.length; i++){
        //             splitedclass = classtarget[i].split("_");

        //             //console.log(splitedclass);
        //             if(splitedclass[0] == 'global'){
        //                 switch(splitedclass[1]){
        //                     case "viewtopic":
        //                     $rootScope.goto('app.home-topics',{id:splitedclass[2]});
        //                      $rootScope.closeTopicThreadModal();
        //                     break;
        //                     case 'viewprofile':

        //                     $rootScope.goto('app.view-profile',{id:splitedclass[2]});
        //                     $rootScope.closeTopicThreadModal();
                          

        //                     break;
        //                     case "viewsphere":
        //                     $rootScope.goto('app.sphere',{id:splitedclass[2]});
        //                      $rootScope.closeTopicThreadModal();
        //                     break;
        //                     default:break;
        //                 }
        //             }
        //         }

        //         var checktarget = e.target.title;
        //         splited = checktarget.split("_");
        //         switch(splited[0]){
        //             case "topicmodal":
        //                 $rootScope.openTopicModal(splited[1].substring(1));
        //                 break;
        //             case "requip":
        //                 $rootScope.globalEventHandler(e);
        //             break;
        //             case "undorequip":
        //                 $rootScope.globalEventHandler(e);
        //             break;

        //         }
        //     }
        // }
        // $ionicModal.fromTemplateUrl('views/modals/modal-search-topics.html', {
        //     scope: $rootScope,
        //     animation: 'slide-up',
        //     focusFirstInput : true
        // }).then(function(modal) {
        //     $rootScope.modalsearchtopics = modal;
        // });
        // $rootScope.openTopicsSearchModal = function(){
        //     $rootScope.modalsearchtopics.show();
        //     var searchTopics = document.querySelector("#search-topics");
        //     searchTopics.addEventListener("click",topicEventHandler, false);
        // }
        // $rootScope.closeTopicsSearchModal = function(){
        //     var searchTopics = document.querySelector("#search-topics");
        //     if(searchTopics){
        //         searchTopics.removeEventListener("click",topicEventHandler, false);
        //     }
        //     $rootScope.modalsearchtopics.hide();
        // }

        // $ionicModal.fromTemplateUrl('views/modals/modal-search-quippers.html', {
        //     scope: $rootScope,
        //     animation: 'slide-up',
        //     focusFirstInput : true
        // }).then(function(modal) {
        //     $rootScope.modalsearchquippers = modal;
        // });
        // $rootScope.openQuippersSearchModal = function(){
        //     $rootScope.modalsearchquippers.show();
        //     var searchQuippers = document.querySelector("#search-quippers");
        //     console.log(searchQuippers)
        //     searchQuippers.addEventListener("click",globalFollowEventHandler, false);
        // }
        // $rootScope.closeQuippersSearchModal = function(){
        //     $rootScope.modalsearchquippers.hide();
        //     var searchQuippers = document.querySelector("#search-quippers");
        //     if(searchQuippers){
        //         searchQuippers.removeEventListener("click", globalFollowEventHandler, false);
        //     }
        // }

        // var searchSphereEventHandler = function(e){
        //     if (e.target !== e.currentTarget) {
        //         var checktarget = e.target.classList;
        //         for(var i = 0; i < checktarget.length; i++){
        //             splited = checktarget[i].split("_");
        //             console.log(splited);
        //             if(splited[0] == "sphere"){
        //                 switch(splited[1]){
        //                     case "viewsphere":
        //                         //console.log(splited[2]);
        //                         $rootScope.modalsearchspheres.hide();
        //                         $rootScope.goto('app.sphere',{id:splited[2]});
        //                     break;
        //                     default:
        //                     break;
        //                 }
        //             }
        //         }

        //     }
        // }


        // $ionicModal.fromTemplateUrl('views/modals/modal-search-spheres.html', {
        //     scope: $rootScope,
        //     animation: 'slide-up',
        //     focusFirstInput : true
        // }).then(function(modal) {
        //     $rootScope.modalsearchspheres = modal;
        // });
        // $rootScope.openSpheresSearchModal = function(){
        //     $rootScope.modalsearchspheres.show();
        //     var searchFollowers = document.querySelector("#search-spheres");
        //     console.log('adding searchSphereEventHandler');
        //     searchFollowers.addEventListener("click",searchSphereEventHandler, false);
        // }
        // $rootScope.closeSpheresSearchModal = function(){
        //     $rootScope.modalsearchspheres.hide();
        //     var searchFollowers = document.querySelector("#search-spheres");
        //     console.log('removing searchSphereEventHandler');
        //     if(searchFollowers){
        //         searchFollowers.removeEventListener("click", searchSphereEventHandler, false);
        //     }
        // }

        //Chat - Search Quippers to chat
        /*$ionicModal.fromTemplateUrl('views/modals/modal-chat-search-quippers.html', {
            scope: $rootScope,
            animation: 'slide-up',
            focusFirstInput : true
        }).then(function(modal) {
            $rootScope.modalchatsearchquippers = modal;
        });
        $rootScope.openChatSearchQuippershModal = function(){
            $rootScope.searchfor = 3; //Search for Quippers for chat
            $rootScope.modalchatsearchquippers.show();
        }
        $rootScope.closenChatSearchQuippershModal = function(){
            $rootScope.modalchatsearchquippers.hide();
        }*/




        $rootScope.destroyall = function(){
            $rootScope.modaltopicthread.hide();
            $rootScope.modalquipper.hide();
            $rootScope.modalsphere.hide();
            $rootScope.modalsearchquippers.hide();
            $rootScope.modalsearchtopics.hide();

            // window.plugins.nativepagetransitions.fade({},function(){},function(){});
        }

        function modaltopicevent(e) {
            if (e.target !== e.currentTarget) {

                var classtarget = e.target.classList;
                  for(var i = 0; i < classtarget.length; i++){
                    splitedclass = classtarget[i].split("_");
                    if(splitedclass[0] == 'global'){
                        switch(splitedclass[1]){ //jhe
                            case "viewtopic":
                            $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                             $rootScope.closeTopicThreadModal();
                            break;
                            case 'viewprofile':
                            $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                            $rootScope.closeTopicThreadModal();
                           
                            break;
                            case "viewsphere":
                            $rootScope.goto('app.sphere',{id:splitedclass[2]});
                             $rootScope.closeTopicThreadModal();
                            break;
                            default:break;
                        }
                    }
                }

                var checktarget = e.target.id;
                splited = checktarget.split("_");

                switch(splited[0]){
                    case "requip":
                        $rootScope.globalEventHandler(e,function(s){
                            console.log(s)
                        });
                    break;
                    case "undorequip":
                        $rootScope.globalEventHandler(e,function(s){
                            //console.log(s)
                        });
                    break;
                    case "quipmedia":
                        if($rootScope.currentMediaId == e.target.className){
                            if($rootScope.mediaPausedFlag == 0){
                                e.target.src = playedicon;
                                $rootScope.media.pause();
                            }else{
                                e.target.src = pausedicon;
                                $rootScope.media.play();
                            }
                        }else{
                            e.target.src = loadingicon;
                            if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                            }else{
                                var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                for(var i=0;i<currentPlayerImage.length;i++){
                                    currentPlayerImage[i].setAttribute('src',playedicon);
                                }
                            }
                            $rootScope.currentMediaId = e.target.className;
                            $rootScope.media = document.getElementById('quip_audio_src');
                            $rootScope.media.pause();
                            $rootScope.media.src = e.target.name;
                            $rootScope.media.load();
                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                        }
                        $rootScope.loadMediaEvents(e);
                        break;
                    case "imgslider":
                        var imgs = $rootScope.selectedtopics.data[splited[1]].quip_images;
                        //console.log(imgs);
                        $rootScope.showImages(imgs);
                        break;
                    case "popover":
                        $rootScope.openPopover2($event);
                        break;
                    case "replytopicthread":
                        $rootScope.selectedtopics.handler = $rootScope.selectedtopics.data[splited[2]].quipper_name;
                        $rootScope.threadParentUniqueId = splited[1];
                        $rootScope.reRoute('go','recorder','',$rootScope.selectedtopics.data[splited[2]].quipper_name,splited[1]);
                        $rootScope.openRecorderModal();
                        break;
                    case "thread":
                        $rootScope.reRoute('go','reply thread',$rootScope.selectedtopics.hashtag.substring(1),$rootScope.selectedtopics.data[splited[2]].quipper_name,splited[1]);
                        $rootScope.openTopicThreadModal(splited[1]);
                        break;
                    case "profile":
                        break;
                    case "quippermodal":
                        $rootScope.reRoute('go','view profile',splited[1]);
                        break;
                    case "ratequip":
                        $rootScope.openPopoverRate(e,splited[1],splited[2],splited[3]);
                        break;
                    default: break;
                }
            }
            e.stopPropagation();
        }

        function modalthreadevent(e) {
            if (e.target !== e.currentTarget) {


                var classtarget = e.target.classList;
                  for(var i = 0; i < classtarget.length; i++){
                    splitedclass = classtarget[i].split("_");
                    if(splitedclass[0] == 'global'){
                        switch(splitedclass[1]){
                            case "viewtopic":
                            $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                             $rootScope.closeTopicThreadModal();
                            break;
                            case 'viewprofile':
                            $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                            $rootScope.closeTopicThreadModal();
                           
                            break;
                            case "viewsphere":
                            $rootScope.goto('app.sphere',{id:splitedclass[2]});
                             $rootScope.closeTopicThreadModal();
                            break;
                            default:break;
                        }
                    }else if(splitedclass[0] == 'viewlink'){
                        var a = classtarget[1];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                    }
                }


                var checktarget = e.target.id;
                splited = checktarget.split("_");
                switch(splited[0]){
                    case "requip":
                        $rootScope.globalEventHandler(e,function(s){});
                    break;
                    case "undorequip":
                        $rootScope.globalEventHandler(e,function(s){});
                    break;
                    case "quipmedia":
                        if($rootScope.currentMediaId == e.target.className){
                            if($rootScope.mediaPausedFlag == 0){
                                e.target.src = playedicon;
                                $rootScope.media.pause();
                            }else{
                                e.target.src = pausedicon;
                                $rootScope.media.play();
                            }
                        }else{
                            e.target.src = loadingicon;
                            if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                            }else{
                                var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                                for(var i=0;i<currentPlayerImage.length;i++){
                                    currentPlayerImage[i].setAttribute('src',playedicon);
                                }
                            }
                            $rootScope.currentMediaId = e.target.className;
                            $rootScope.media = document.getElementById('quip_audio_src');
                            $rootScope.media.pause();
                            $rootScope.media.src = e.target.name;
                            $rootScope.media.load();
                            $rootScope.quipPlayerItem = e.target; // assign the object to play
                        }
                        break;
                    case "imgsliderP":
                        var imgs = $rootScope.threadparent.quip_images;
                        //console.log(imgs);
                        $rootScope.showImages(imgs);
                        break;
                    case "imgsliderC":
                        //console.log($rootScope.threadchild);
                        var imgs = $rootScope.threadchild[splited[1]].quip_images;
                        //console.log(imgs);
                        $rootScope.showImages(imgs);
                        break;
                    case "replythread":
                        $rootScope.threadParentUniqueId = splited[1];
                        $rootScope.openRecorderModal();
                        $rootScope.reRoute('go','recorder');
                        break;
                    case "quippermodal":
                        $rootScope.modaltopicthread.hide();
                        var quipperid = window.localStorage['quipper_id'];
                        if(quipperid == splited[1]){
                            $rootScope.lasttempurl.url = 'app.myprofile';
                            $rootScope.goto('app.myprofile',{id:splited[1]});
                            $rootScope.reRoute('go','my profile');
                        }else{
                            $rootScope.lasttempurl.url = 'app.view-profile';
                            $rootScope.goto('app.view-profile', {id:splited[1]});
                            $rootScope.reRoute('go','view profile');
                        }
                        break;
                    case "ratequip":
                        $rootScope.ratedata.selecteddata = $rootScope.threadparent;
                        $rootScope.openPopoverRate(e,splited[1],splited[2]);
                        break;
                    case "sharequip":
                        var uid = splited[2];
                        //console.log(uid);
                        window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                        break;
                    case 'report':
                        $rootScope.reportdata.r_qpr = $rootScope.threadparent.quipper_id;
                        $rootScope.reportdata.r_qpid = $rootScope.threadparent.unique_id;
                        $rootScope.reportdata.rqtype = "Quip";
                        $rootScope.$apply();
                        $rootScope.openpopoverreport(e);
                    break;
                    default: break;
                }
            }
            e.stopPropagation();
        }

    //rating
    $ionicPopover.fromTemplateUrl('views/rate/popoverRate.html', {
       scope: $rootScope
   }).then(function(popoverRate) {
       $rootScope.popoverRate = popoverRate;
   });
    $rootScope.openPopoverRate = function($event,uniqueid,page,params) {
        $rootScope.ratedata.page = page;
        $rootScope.uniqueid = uniqueid;
        $rootScope.params = params; 
        if($rootScope.user_data.quipper_id ==  $rootScope.ratedata.selecteddata.quipper_id){
                var status = "e";
                var ontap_callback = function(e){}
                var title = 'Alert';
                var btn_text = 'Okay';
                var msg = 'You can\'t rate your own post!'; 
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);

        }else{
            if($rootScope.ratedata.selecteddata.is_favorited == 0){
                $rootScope.popoverRate.show($event);
            }else{
                //console.log("You already rate it!");
            }
        }
    };
    $rootScope.closePopoverRate = function() {
        $rootScope.popoverRate.hide();
        $rootScope.rating = 1;
        $rootScope.ratings = [{
            current: -1,
            max: 5
        }];
        // $rootScope.popoverRate.remove();
        // $ionicPopover.fromTemplateUrl('views/rate/popoverRate.html', {
        //     scope: $rootScope
        // }).then(function(popoverRate) {
        //     $rootScope.popoverRate = popoverRate;
        // });

    };
    $rootScope.rating = 1;
    $rootScope.ratings = [{
        current: -1,
        max: 5
    }];

    $rootScope.getSelectedRating = function (rating, quipid, quipper_id) {
        if(!rating || rating == 0){
            $rootScope.submitRate = "";
            return;
        }
        $rootScope.selectedrate = [];
        $rootScope.selectedrate['quipid'] = quipid;
        $rootScope.selectedrate['rating'] = rating;
        $rootScope.selectedrate['quipper_id'] = quipper_id;
        setTimeout(function(){
            $rootScope.submitRate();
        },250);
    }
    $rootScope.submitRate = function() {
        var rating = $rootScope.selectedrate.rating;
        if(!rating|| rating==0){
            return;
            die();
        }
        switch($rootScope.ratedata.page){
            case "app.latest-quip":
                //console.log($rootScope.ratedata.selecteddata);
                //console.log(rating);
                $rootScope.$broadcast('updateratelatestquip',{unique_id: $rootScope.ratedata.selecteddata.unique_id, rating:rating})
            break;
            case "home":

            break;
            case "topic":
                var counted = $rootScope.ratedata.selecteddata.quip_favorited  + rating;
                $rootScope.$broadcast('updateratetopic',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
            break;
            case "threadparent":

                $rootScope.threadparent.is_favorited = 1;
                var currentave = $rootScope.threadparent.average_stars;
                var ratedvalue = rating;
                if(currentave == 0){
                    var countdev = 1;
                }else{
                    var countdev = 2;
                }
                var latest_ave = (currentave + ratedvalue) / countdev;
                $rootScope.threadparent.average_stars = Math.round(latest_ave);
                $rootScope.threadparent.is_favorited_img = "img/star-quiped.png";
                
                $rootScope.$broadcast('updateratenf',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
                $rootScope.$broadcast('updateratetopic',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
                $rootScope.$broadcast('updaterateqq',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
                $rootScope.$broadcast('updateratevp',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
            break;
            case "threadchild":
                
                for(var i = 0; i < $rootScope.threadchild.length; i++){
                    if($rootScope.uniqueid == $rootScope.threadchild[i].unique_id){
                        $rootScope.threadchild[i].is_favorited = 1;
                        $rootScope.threadchild[i].quip_favorite = $rootScope.threadchild[i].quip_favorite + rating;

                        var favorites_count = $rootScope.threadchild[i].favorites_count;
                        favorites_count = parseInt(favorites_count) + 1; 
                        var favorites_sum = $rootScope.threadchild[i].favorites_sum;
                        favorites_sum = parseInt(favorites_sum) + rating;
                        var latest_ave =  favorites_sum / favorites_count;
                        latest_ave = parseInt(latest_ave);
                        $rootScope.threadchild[i].average_stars = latest_ave;
                        $rootScope.ratedata.selecteddata.average_stars = latest_ave;
                    }
                }
            break;
            case "newsfeed":
                var counted = $rootScope.ratedata.selecteddata.quip_favorite  + rating;
                $rootScope.$broadcast('updateratenf',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
            break;
            case "viewprofile":
                 var counted = $rootScope.ratedata.selecteddata.quip_favorite  + rating;
                $rootScope.$broadcast('updateratevp',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
            break;
            case "quippersquip":
                var counted = $rootScope.ratedata.selecteddata.quip_favorited  + rating;
                $rootScope.$broadcast('updaterateqq',{unique_id: $rootScope.uniqueid, counted: counted, rating:rating});
            break;
            default:break;
        }
        
        var quipid = $rootScope.ratedata.selecteddata.quipid;
        var unique_id = $rootScope.ratedata.selecteddata.unique_id;
        var quipperid = $rootScope.ratedata.selecteddata.quipper_id;
        console.log($rootScope.ratedata.selecteddata);
        API.rateQuip({
            unique_id: unique_id,
            rating:rating,
        }, function(data){
            $rootScope.selectedrate.rating = 0;
            $rootScope.ratedata.selecteddata =[];
        }, function(err){
                console.log(err);
        });

        $rootScope.closePopoverRate();

    }

    $rootScope.starsgotoreply = function(val,val2,val3){
       console.log($rootScope.qp_modalStars);
       $rootScope.selectedtopics.handler = val;
       $rootScope.threadParentUniqueId = val3;
       $rootScope.openTopicThreadModal(val3);
       $rootScope.reRoute('go','reply thread');       
    }

    $rootScope.$on('topicopen', function(event, args) {
        $rootScope.hastopicsearch = args.topicname;
    });

        // $ionicModal.fromTemplateUrl('views/modals/modal-splash.html', {
        //     scope: $rootScope,
        //     animation: 'fade-in',
        //     focusFirstInput : true
        // }).then(function(modal) {
        //     $rootScope.splash = modal;
        // });
        // $rootScope.opensplashModal = function(){
        //      $rootScope.splash.show();
        // }
        // $rootScope.closesplashModal = function(){
        //     $rootScope.splash.hide();
        //     $rootScope.splash.remove();
        // }

        $rootScope.gotScrolled = function() {

            var scrollingval = $ionicScrollDelegate.$getByHandle('scrollthread').getScrollPosition().top;
            var parentheight = document.getElementById("parentthread_con").offsetHeight;
            if(document.getElementById("th-content").style.length == 5){
                    document.getElementById("stickheader").style.display = "none";
            }else{
                if(scrollingval == 0){
                    document.getElementById("stickheader").style.display = "none";
                }else{
                    document.getElementById("stickheader").style.display = "block";
                }
            }
      }
        $rootScope.hideAllModal = function() {
            $rootScope.modaleditquip.hide();
            $rootScope.closeTopicThreadModal();
        }

        $rootScope.reRoute = function(strCommand,strRoute,replyThreadFlag, params) {
            switch(strCommand){
                case 'go':
                    previousRoute = $rootScope.routeStack[$rootScope.routeStack.length-1];
                    switch(strRoute){
                        case 'recorder':
                            if(replyThreadFlag == 1){
                                if($rootScope.isprivate == 1){
                                    $rootScope.postBackRoute = 'privatequip thread';
                                }else{
                                    $rootScope.postBackRoute = 'reply thread';
                                }
                            }else{
                                $rootScope.postBackRoute = previousRoute;
                            }
                            $rootScope.routeStack.push(strRoute);
                            break;
                        case 'app.edit-sphere':
                        case 'app.edit-sphere-event':
                        case 'app.invite-sphere-members':
                        case 'app.sphere-events':
                        case 'app.add-sphere-event':
                        case 'app.sphereaddcollection':
                        case 'app.spherecollections':
                        case 'app.createcollections':
                        case 'app.editcollection':
                        case 'app.collectionitems':
                        case 'app.sphere':
                        case 'app.sphere-members':
                        case 'app.sphere-followers':
                            $rootScope.quipforsphere = true;
                            $rootScope.routeParams = params;
                            //$rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            $rootScope.routeStack.push(strRoute);
                            break;
                        case 'app.sphere-reply':
                            $rootScope.quipforsphere = true;
                            $rootScope.routeParams = params;
                            //$rootScope.threadParentUniqueId = $rootScope.routeParams.id;
                            $rootScope.selectedtopics.handler = $rootScope.routeParams.handler;
                            $rootScope.routeStack.push(strRoute);
                            break;
                        case 'app.create-sphere':
                        case 'app.latest-quip':
                        case 'editquip':
                        case 'reply thread':
                        case 'topic thread':
                        case 'view profile':
                        case 'view my profile':
                            $rootScope.routeStack.push(strRoute);
                            break;
                        case 'applist':
                        case 'home':
                        case 'my profile':
                        case 'privatequip':
                        case 'newsfeed':
                        case 'app.mysphere':
                        default:
                            $rootScope.quipforsphere = false;
                            $rootScope.threadParentUniqueId = '';
                            $rootScope.selectedtopics.hashtag = '';
                            $rootScope.selectedtopics.handler = '';
                            $rootScope.postBackRoute = '';
                            $rootScope.routeStack = [strRoute];
                            break;
                    }
                    break;
                case 'back':
                    previousRoute = $rootScope.routeStack[$rootScope.routeStack.length-1];
                    backRoute = $rootScope.routeStack[$rootScope.routeStack.length-1];
                    $rootScope.routeStack.pop();
                    switch(strRoute){
                        case 'editquip':
                            break;
                        case 'recorder':
                            break; 
                        default:                            
                            break;
                    }
                    break;
                default:break;
            }
            $log.warn($rootScope.routeStack);
            $log.info('parent unique id: '+$rootScope.threadParentUniqueId);
            $log.info('current handler: '+$rootScope.selectedtopics.handler);
            $log.info('current hashtag: '+$rootScope.selectedtopics.hashtag);
            $log.warn('postback page: '+$rootScope.postBackRoute);
        }


        if(ionic.Platform.isAndroid()){

            $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
                console.log(notification);
                switch(notification.event)
                {
                    case 'registered':
                        if (notification.regid.length > 0 ) {
                            console.log('registration ID = ' + notification.regid);
                            console.log('device id length = ' + notification.regid.length);
                            var device_uuid = $cordovaDevice.getUUID();
                            API.registerDevice({
                                'device':'android', 
                                'device_id': notification.regid,
                                'quipper_id': $rootScope.user_data.quipper_id,
                                'device_uuid': device_uuid
                            },function(data){
                                console.log("registered!")
                            }, function(err){
                                console.log("failed to registered!")
                            })
                            //NodePushServer.storeDeviceToken("android", notification.regid);
                        }
                        break;

                    case 'message':
                        if(notification.foreground == "1")
                        {
                            console.log(notification);
                            console.log("Notification received when app was opened (foreground = true)");
                            if(notification.message != window.localStorage['notification_message']){
                                window.localStorage['notification_message'] = notification.message;
                                switch(notification.payload.quip_page){
                                    case 'app.notification':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            var toastVerticalPosition = -150;               
                                           Toast.show(notification.message,"short","bottom",
                                                   toastVerticalPosition,function(success){
                                               },function(error){});     
                                           
                                       }
                                    break;
                                    case 'app.sphere':
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message, status, title, function(){
                                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, handler: notification.payload.quip_params.sphere_handle});
                                                $rootScope.goto('app.sphere',{id:notification.payload.quip_params.sphere_unique_id});
                                            });
                                        }
                                    break;
                                    case 'app.privatequipitem':

                                        if(Constant.DEVELOPER_MODE == false){   
                                        var toastVerticalPosition = -150;               
                                           Toast.show(notification.message,"short","bottom",
                                                   toastVerticalPosition,function(success){
                                               },function(error){});     
                                           
                                       }
                                    break;
                                    case 'app.push-sphere-invitation':
                                        // if(Constant.DEVELOPER_MODE == false){   
                                        // var toastVerticalPosition = -150;               
                                        //    Toast.show("You have been added to "+notification.payload.title,"short","bottom",
                                        //            toastVerticalPosition,function(success){
                                        //        },function(error){});     
                                        // }

                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.mysphere');
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                            });
                                        }
                                    break;
                                    case 'app.push-sphere-quip':
                                        if(Constant.DEVELOPER_MODE == false){   
                                        }
                                    break;
                                    case 'app.reply-to-sphere-thread':
                                        if(Constant.DEVELOPER_MODE == false){   
                                         
                                        }
                                    break;
                                    case "app.push-new-topic":
                                    break; 
                                    case "app.push-join-topic":
                                    break; 
                                    case "app.push-topic-thread-reply":
                                    return;
                                    default:
                                    break;
                                }
                            }else{
                                switch(notification.payload.quip_page){
                                    case 'app.notification':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            var toastVerticalPosition = -150;               
                                           Toast.show(notification.message,"short","bottom",
                                                   toastVerticalPosition,function(success){
                                               },function(error){});     
                                           
                                       }
                                    break;
                                    case 'app.privatequipitem':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            var toastVerticalPosition = -150;                 
                                               Toast.show(notification.message,"short","bottom",
                                                       toastVerticalPosition,function(success){
                                                   },function(error){});     
                                               
                                           }
                                    break;
                                    case 'app.sphere':
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.quip_params.sphere_handle, status, title, function(){
                                                $rootScope.threadParentUniqueId = notification.payload.quip_params.sphere_unique_id;
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.quip_params.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                            });
                                        }
                                    break;
                                    case 'app.push-sphere-invitation':
                                        // if(Constant.DEVELOPER_MODE == false){   
                                        // var toastVerticalPosition = -150;               
                                        //    Toast.show("You have been added to "+notification.payload.title,"short","bottom",
                                        //            toastVerticalPosition,function(success){
                                        //        },function(error){});     
                                        // }
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.mysphere');
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                            });
                                        }
                                    break;
                                    case 'app.push-sphere-quip':
                                        if(Constant.DEVELOPER_MODE == false){   
                                       }
                                    break;
                                    case 'app.reply-to-sphere-thread':
                                        if(Constant.DEVELOPER_MODE == false){ 
                                        }
                                    break;
                                    case "app.push-new-topic":
                                    break; 
                                    case "app.push-join-topic":
                                    break; 
                                    case "app.push-topic-thread-reply":
                                    return;



                                    default:
                                    break;
                                }
                            }
                            
                        }
                        else
                        {
                            if(notification.coldstart == "1")
                            {
                                switch(notification.payload.quip_page){
                                    case 'app.notification':
                                        setTimeout(function(){
                                            if(Constant.DEVELOPER_MODE == false){   
                                                var toastVerticalPosition = -150;               
                                               Toast.show(notification.message,"short","bottom",
                                                       toastVerticalPosition,function(success){
                                                   },function(error){});     
                                               
                                           } 
                                        },1000);
                                    break;
                                    case 'app.privatequipitem':
                                        $rootScope.goto('app.privatequipitem', {id:notification.payload.prvquipid});
                                        setTimeout(function(){
                                            title = 'Notification';
                                            btn_text = 'OK';
                                            $rootScope.popAlert(notification.message, status, title, btn_text, function(){
                                                
                                            });
                                        },1000);
                                    break;
                                    case 'app.sphere':
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                            });
                                        }
                                    break;  
                                    case 'app.push-sphere-invitation':
                                       //  if(Constant.DEVELOPER_MODE == false){   
                                       //      $rootScope.reRoute('go','app.mysphere');
                                       //      $rootScope.reRoute('go','app.sphere', 0, {
                                       //          id: notification.payload.sphere_unique_id, 
                                       //          handler: notification.payload.sphere_handle
                                       //      });
                                       //      $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                       // }

                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.mysphere');
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                            });
                                        }
                                    break;  
                                    case 'app.push-sphere-quip':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            $rootScope.reRoute('go','app.mysphere');
                                            $rootScope.reRoute('go','app.sphere', 0, {
                                                id: notification.payload.sphere_unique_id, 
                                                handler: notification.payload.sphere_handle
                                            });
                                            $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                           
                                       }
                                    break; 
                                    case 'app.reply-to-sphere-thread':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            $rootScope.goto('app.sphere-reply',{sphere_id:notification.payload.sphere_unique_id, quip_id:notification.payload.parent_quipid});
                                            $rootScope.reRoute('go','app.mysphere');
                                            $rootScope.reRoute('go','app.sphere', 0, {
                                                id: notification.payload.sphere_unique_id, 
                                                handler: notification.payload.sphere_handle
                                            });
                                            $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                            $rootScope.selectedtopics.handler = notification.payload.sphere_handle + " " +notification.payload.quipper_handle;
                                            $rootScope.threadParentUniqueId = notification.payload.parent_quipid;
                                            $rootScope.postBackRoute = 'app.sphere-reply';
                                            $rootScope.routeParams.id = notification.payload.sphere_unique_id;
                                            $rootScope.routeParams.handler = notification.payload.sphere_handle;
                                            $rootScope.routeParams.quipper_handler = notification.payload.quipper_handle;
                                        }
                                    break;
                                    case "app.push-new-topic":
                                    case "app.push-join-topic":
                                        $rootScope.selectedtopics.hashtag = notification.payload.hashtag;
                                        $rootScope.reRoute('go','home');
                                        $rootScope.reRoute('go','topic thread');
                                        $rootScope.goto('app.home-topics',{id:notification.payload.hashtag.replace('#','')});
                                    break; 
                                    case "app.push-topic-thread-reply":
                                        $rootScope.selectedtopics.handler = notification.payload.quipper_handle;
                                        $rootScope.openTopicThreadModal(notification.payload.parent_quipid);
                                        $rootScope.reRoute('go','home');
                                        $rootScope.reRoute('go','view profile', 0, {id:notification.payload.quipper_id});
                                        $rootScope.reRoute('go','reply thread');
                                    return;
                                    default:
                                        $rootScope.goto(notification.payload.quip_page, notification.payload.params);
                                    break;
                                }
                                console.log("Notification received when app was closed (not even in background, foreground = false, coldstart = true)");
                            }
                            else
                            {
                                switch(notification.payload.quip_page){
                                    case 'app.notification':
                                        /*$rootScope.goto('app.newsfeed', {});
                                        setTimeout(function(){
                                            title = 'Notification';
                                            btn_text = 'OK';
                                            $rootScope.popAlert(notification.message, status, title, btn_text, function(){
                                                
                                            });
                                        },1000);*/

                                        if(Constant.DEVELOPER_MODE == false){   
                                            var toastVerticalPosition = -150;               
                                           Toast.show(notification.message,"short","bottom",
                                                   toastVerticalPosition,function(success){
                                               },function(error){});     
                                           
                                        } 
                                    break;

                                    case 'app.privatequipitem':
                                        $rootScope.goto('app.privatequipitem', {id:notification.payload.prvquipid});
                                        setTimeout(function(){
                                            title = 'Notification';
                                            btn_text = 'OK';
                                            $rootScope.popAlert(notification.message, status, title, btn_text, function(){
                                                
                                            });
                                        },1000);
                                    break;
                                    case 'app.sphere':
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                            });
                                        }
                                    break;   
                                    case 'app.push-sphere-invitation':
                                        var audio = new Audio('sounds/checkout_beep.mp3');
                                        audio.play();
                                        if(notification.payload.sphere_command == 'INVITE'){
                                            title = notification.payload.title;
                                            $rootScope.popUp(notification.message+"<br/>Goto to "+notification.payload.sphere_handle, status, title, function(){
                                                $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                                $rootScope.threadParentUniqueId = notification.payload.sphere_unique_id;
                                                $rootScope.reRoute('go','app.mysphere');
                                                $rootScope.reRoute('go','app.sphere', 0, {id:notification.payload.sphere_unique_id, 
                                                    handler: notification.payload.sphere_handle});
                                            });
                                        }
                                    break;
                                    case 'app.push-sphere-quip':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            $rootScope.reRoute('go','app.mysphere');
                                            $rootScope.reRoute('go','app.sphere', 0, {
                                                id: notification.payload.sphere_unique_id, 
                                                handler: notification.payload.sphere_handle
                                            });
                                            $rootScope.goto('app.sphere',{id:notification.payload.sphere_unique_id});
                                           
                                       }
                                    break; 
                                    case 'app.reply-to-sphere-thread':
                                        if(Constant.DEVELOPER_MODE == false){   
                                            $rootScope.goto('app.sphere-reply',{sphere_id:notification.payload.sphere_unique_id, quip_id:notification.payload.parent_quipid});
                                            $rootScope.reRoute('go','app.mysphere');
                                            $rootScope.reRoute('go','app.sphere', 0, {
                                                id: notification.payload.sphere_unique_id, 
                                                handler: notification.payload.sphere_handle
                                            });
                                            $rootScope.reRoute('go','app.sphere-reply', 0, $rootScope.routeParams);
                                            $rootScope.selectedtopics.handler = notification.payload.sphere_handle + " " +notification.payload.quipper_handle;
                                            $rootScope.threadParentUniqueId = notification.payload.parent_quipid;
                                            $rootScope.postBackRoute = 'app.sphere-reply';
                                            $rootScope.routeParams.id = notification.payload.sphere_unique_id;
                                            $rootScope.routeParams.handler = notification.payload.sphere_handle;
                                            $rootScope.routeParams.quipper_handler = notification.payload.quipper_handle;
                                        }
                                    break;
                                    case "app.push-new-topic":
                                    case "app.push-join-topic":
                                        $rootScope.selectedtopics.hashtag = notification.payload.hashtag;
                                        $rootScope.reRoute('go','home');
                                        $rootScope.reRoute('go','topic thread');
                                        $rootScope.goto('app.home-topics',{id:notification.payload.hashtag.replace('#','')});
                                    break; 
                                    case "app.push-topic-thread-reply":
                                        $rootScope.selectedtopics.handler = notification.payload.quipper_handle;
                                        $rootScope.openTopicThreadModal(notification.payload.parent_quipid);
                                        $rootScope.reRoute('go','home');
                                        $rootScope.reRoute('go','view profile', 0, {id:notification.payload.quipper_id});
                                        $rootScope.reRoute('go','reply thread');
                                    return;

                                    default:
                                        $rootScope.goto(notification.payload.quip_page, notification.payload.params);
                                    break;
                                }
                                console.log("Notification received when app was in background (started but not focused, foreground = false, coldstart = false)");
                            }
                        }
                        console.log(notification.payload);
                        console.log(notification.payload.quip_page);
                        // this is the actual push notification. its format depends on the data model from the push server
                        console.log('message = ' + notification.message);
                        break;

                    case 'error':
                        console.log('GCM error = ' + notification.msg);
                        break;

                    default:
                        console.log('An unknown GCM event has occurred');
                        break;
                }
            });
        }

        $ionicPopover.fromTemplateUrl('views/popover/report.html', {
           scope: $rootScope
       }).then(function(popoverreport) {
           $rootScope.popoverreport = popoverreport;
       });
       
       $rootScope.openpopoverreport = function($event,qpr_id,qp_id) {
            $rootScope.popoverreport.show($event);
            if(qpr_id == $rootScope.user_data.quipper_id){
                $("#popover-deletex-btn").show();
                $("#popover-reportx-btn").hide();
                $rootScope.delete_quip_unique_id = qp_id;
            }else{
                $("#popover-deletex-btn").hide();
                $("#popover-reportx-btn").show();
            }
        };
        $rootScope.closepopoverreport = function() {
            $rootScope.popoverreport.hide();
        };

        $ionicPopover.fromTemplateUrl('views/popover/reportblock.html', {
           scope: $rootScope
       }).then(function(popoverreportblock) {
           $rootScope.popoverreportblock = popoverreportblock;
       });
       
       $rootScope.openpopoverreportblock = function($event,qpr_id,qp_id) {
            $rootScope.popoverreportblock.show($event);
            if(qpr_id == $rootScope.user_data.quipper_id){
                $("#popover-delete-btn").show();
                $("#popover-block-btn").hide();
                $("#popover-report-btn").hide();
                $rootScope.delete_quip_unique_id = qp_id;
            }else{
                $("#popover-delete-btn").hide();
                $("#popover-block-btn").show();
                $("#popover-report-btn").show();
            }
        };
        $rootScope.closepopoverreportblock = function() {
            $rootScope.popoverreportblock.hide();
        };

        $rootScope.showConfirmblock = function(handle) {
          if($rootScope.user_data.quipper_id == $rootScope.reportdata.r_qpr){
                var status = "e";
                var ontap_callback = function(e){}
                var title = 'Alert';
                var btn_text = 'Okay';
                var msg = 'You can\'t block your own post!'; 
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                $rootScope.closepopoverreportblock();
                $rootScope.closepopoverreport();
                return;
          }
          var confirmPopup = $ionicPopup.confirm({
             title: 'Block this quipper',
             template: 'Do you really want to block '+handle+' and do not receive any future quip from this quipper?',
             buttons: [
                {
                   text: '<b>Confirm</b>',
                   type: 'button-positive',
                      onTap: function(e) {
                            $rootScope.closepopoverreportblock();
                            $rootScope.closepopoverreport();
                            $ionicLoading.show();
                            var quipper_blockid = $rootScope.reportdata.r_qpr;
                            API.submitblock({
                                blocker_quipperid: $rootScope.user_data.quipper_id,
                                blocked_quipperid: quipper_blockid
                            },
                            function(data){
                                $ionicLoading.hide();
                                $rootScope.reportdata = [];

                                $rootScope.$broadcast('updatenfblock',{quipper_id: quipper_blockid});
                            },function(err){
                            });
                      }
                },
               { text: 'Cancel', onTap: function(e){$rootScope.closepopoverreportblock();} }
             ]
          });
       };

       $ionicModal.fromTemplateUrl('views/modals/modal-report.html', {
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.reportpage = modal;
        });
        $rootScope.openreportpageModal = function(){
            if($rootScope.user_data.quipper_id == $rootScope.reportdata.r_qpr){
                var status = "e";
                var ontap_callback = function(e){}
                var title = 'Alert';
                var btn_text = 'Okay';
                var msg = 'This is your own post!'; 
                $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                $rootScope.closepopoverreportblock();
                $rootScope.closepopoverreport();
                return;
          }
            $rootScope.closepopoverreportblock();
            $rootScope.closepopoverreport();
            $rootScope.reportpage.show();
        }
        $rootScope.closereportpageModal = function(){
            $rootScope.reportpage.hide();
            $rootScope.reportpage.remove();

            $ionicModal.fromTemplateUrl('views/modals/modal-report.html', {
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $rootScope.reportpage = modal;
            });
        }

        $rootScope.showAlertSubmit = function() {
           $ionicLoading.show();
           if(!$rootScope.reportdata){
                return;
           }
           API.submitquipreport({
                reporter_quipperid: $rootScope.reportdata.r_qpr,
                reported_refid: $rootScope.reportdata.r_qpid,
                report_type: $rootScope.reportdata.rqtype,
                desc: $rootScope.reportdata.desc
            },
            function(data){
                $rootScope.closereportpageModal();
                $ionicLoading.hide();
                $rootScope.reportdata = [];
                var alertPopup = $ionicPopup.alert({
                 title: 'Issue report was submitted successfully! ',
                 template: 'Allow us to review this repory. We will give you feedback within the next 24 to 48 hours. Thank you.'
               });
               alertPopup.then(function(res) {
               });
            },function(err){
            }); 

           
         };
})


.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
    $ionicConfigProvider.views.transition('none');
    //$ionicConfigProvider.views.transition('ios');
    $ionicConfigProvider.scrolling.jsScrolling(true);
    $ionicConfigProvider.views.forwardCache(true); //new

    $stateProvider

    //INTRO
    .state('auth', {
        url: "/auth",
        templateUrl: "views/auth/auth.html",
        abstract: true,
        controller: 'AuthCtrl'
    })
    .state('auth.walkthrough', {
        url: '/walkthrough',
        templateUrl: "views/auth/walkthrough.html",
        controller: 'WalkthroughCtrl'
    })
    .state('auth.login', {
        url: '/login',
        templateUrl: "views/auth/login.html",
        controller: 'LoginCtrl'
    })
    .state('auth.signup', {
        url: '/signup',
        templateUrl: "views/auth/signup.html",
        controller: 'SignupCtrl'
    })
    .state('auth.signup_photo', {
        url: '/signup_photo',
        templateUrl: "views/auth/signup_photo.html",
        controller: 'SignupPhotoCtrl'
    })
    .state('auth.forgot-password', {
        url: "/forgot-password",
        templateUrl: "views/auth/forgot-pass.html",
        controller: 'ForgotPasswordCtrl'
    })

    // RECORD
    .state('record', {
        url: "/record",
        templateUrl: "views/abstract/blank.html",
        abstract: true
    })
    .state('record.record-start', {
        url: "/record-start",
        templateUrl: "views/record/record-start.html",
        controller: 'RecordStartCtrl'
    })
    .state('record.editquip', {
        url: "/editquip",
        templateUrl: "views/record/editquip.html",
        controller: 'EditQuipCtrl'
    })

    //MISC
    .state('misc', {
        url: "/misc",
        templateUrl: "views/abstract/blank.html",
        abstract: true
    })
    .state('misc.editavatar', {
        url: '/editavatar',
        templateUrl: "views/misc/editavatar.html",
        controller: 'ProfileEditAvatarCtrl'      
    })

    // APP
    .state('app', {
        url: "/app",
        abstract: true,
        templateUrl: "views/abstract/tab.home.html",
        controller: 'AppCtrl'
    })

    .state('app.home', {
        url: "/home",
        views: {
            'menuContent': {
                templateUrl: "views/app/home.html",
                controller: 'HomeCtrl'
            }
        }
    })

    .state('app.latest-quip', {
        url: "/latest-quip",
        views: {
            'menuContent': {
                templateUrl: "views/app/latest-quip.html",
                controller: 'LatestQuipCtrl'
            }
        }
    })

    .state('app.edit-sphere', {
        url: "/edit-sphere/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/edit-sphere.html",
                controller: 'EditSphereCtrl'
            }
        }
    })

    .state('app.edit-sphere-event', {
        url: "/edit-sphere-event/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/edit-sphere-event.html",
                controller: 'EditSphereEventCtrl'
            }
        }
    })

    .state('app.invite-sphere-members', {
        url: "/invite-sphere-members/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/invite-sphere-members.html",
                controller: 'InviteSphereMembersCtrl'
            }
        }
    })

    .state('app.home-topics', {
        url: "/home-topics/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/home-topics.html",
                controller: 'HomeTopicsCtrl'
            }
        }
    })

    .state('app.quippers-profile', {
        url: "/quippers-profile/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/quippers-profile.html",
                controller: 'QuipperProfileCtrl'
            }
        }
    })

    .state('app.quippers-quip', {
        url: "/quippers-quip/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/quippers-quip.html",
                controller: 'QuipperQuipCtrl'
            }
        }
    })

    .state('app.view-profile', {
        url: "/view-profile/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/view-profile.html",
                controller: 'ViewProfileCtrl'
            }
        }
    })

    .state('app.stars', {
        url: "/stars/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/stars.html",
                controller: 'StarsCtrl'
            }
        }
    })

    .state('app.follower', {
        url: "/follower/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/follower.html",
                controller: 'FollowerCtrl'
            }
        }
    })

    .state('app.following', {
        url: "/following/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/following.html",
                controller: 'FollowingCtrl'
            }
        }
    })

    .state('app.mysphere', {
        url: "/mysphere",
        cache:true,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/mysphere.html",
                controller: 'MysphereCtrl'
            }
        }
    })

    .state('app.sphere-events', {
        url: "/sphere-events/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-events.html",
                controller: 'SphereEventsCtrl'
            }
        }
    })

    .state('app.add-sphere-event', {
        url: "/add-sphere-event/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/add-sphere-event.html",
                controller: 'AddSphereEventCtrl'
            }
        }
    })

    .state('app.sphereaddcollection', {
        url: "/sphereaddcollection/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-addcollection.html",
                controller: 'SphereaddcollectionCtrl'
            }
        }
    })

    .state('app.spherecollections', {
        url: "/spherecollections/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-collections.html",
                controller: 'SpherecollectionCtrl'
            }
        }
    })
   .state('app.createcollections', {
        url: "/createcollections/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-createcollection.html",
                controller: 'CreatecollectionCtrl'
            }
        }
    })

    .state('app.collectionitems', {
        url: "/collectionitems/:id/:collectionid",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/collectionitems.html",
                controller: 'CollectionitemsCtrl'
            }
        }
    })

    .state('app.editcollection', {
        url: "/editcollection/:id/:collectionid",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-editcollection.html",
                controller: 'EditSphereCollectionCtrl'
            }
        }
    })

    .state('app.sphere', {
        url: "/sphere/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere.html",
                controller: 'SphereCtrl'
            }
        }
    })

    .state('app.create-sphere', {
        url: "/create-sphere",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/create-sphere.html",
                controller: 'CreateSphereCtrl'
            }
        }
    })

    .state('app.sphere-members', {
        url: "/sphere-members/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-members.html",
                controller: 'SphereMembersCtrl'
            }
        }
    })

    .state('app.sphere-reply', {
        url: "/sphere-reply/:sphere_id/:quip_id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-reply.html",
                controller: 'SphereReplyCtrl'
            }
        }
    })

    .state('app.sphere-followers', {
        url: "/sphere-followers/:id",
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/sphere/sphere-followers.html",
                controller: 'SphereFollowersCtrl'
            }
        }
    })

    .state('app.myprofile', {
        url: '/myprofile',
        views: {
            'menuContent': {
                templateUrl: "views/app/profile/myprofile.html",
                controller: 'ProfileCtrl'
            }
        }        
    })

    .state('app.editprofile', {
        url: '/editprofile',
        views: {
            'menuContent': {
                templateUrl: "views/app/profile/editprofile.html",
                controller: 'EditprofileCtrl'
            }
        } 
    })

    .state('app.myachievements', {
        url: '/myachievements',
        cache:false,
        views: {
            'menuContent': {
                templateUrl: "views/app/profile/myachievements.html",
                controller: 'MyAchievementsCtrl'
            }
        } 
    })

    .state('app.badges', {
        url: '/badges/:badgecode',
        views: {
            'menuContent': {
                templateUrl: "views/app/badges-info.html",
                controller: 'BadgesInfoCtrl'
            }
        } 
    })


    .state('app.quipperachievements', {
        url: '/quipperachievements/:id',
        views: {
            'menuContent': {
                templateUrl: "views/app/quipperachievements.html",
                controller: 'QuipperAchievementsCtrl'
            }
        } 
    })

    .state('app.changepassword', {
        url: '/changepassword',
        views: {
            'menuContent': {
                templateUrl: "views/app/profile/changepassword.html",
                controller: 'ChangepasswordCtrl'
            }
        } 
    })

    .state('app.newsfeed', {
        url: '/newsfeed',
        views: {
            'menuContent': {
                templateUrl: "views/app/newsfeed/list.html",
                controller: 'NewsFeedCtrl'
            }
        } 
    })

    .state('app.vsrepeat', {
        url: '/vsrepeat',
        views: {
            'menuContent': {
                templateUrl: "views/app/newsfeed/vs-repeat.html",
                controller: 'VsrepeatCtrl'
            }
        } 
    })

    .state('app.find', {
        url: "/find",
        views: {
            'menuContent': {
                templateUrl: "views/app/find.html"
            }
        }
    })

    .state('app.chathome', {
        url: '/chathome',
        cache:true,
         views: {
            'menuContent': {
                templateUrl: "views/msngr/chathome.html",
                controller: 'ChatHomeCtrl'
            }
        } 
    })

    .state('app.privatequip', {
        url: "/privatequip",
        views: {
            'menuContent': {
                templateUrl: "views/app/privatequip/privatequip.html",
                controller:'PrivateQuipCtrl'
            }
        }
    })

    .state('app.privatequipitem', {
        url: "/privatequipitem/:id",
        views: {
            'menuContent': {
                templateUrl: "views/app/privatequip/privatequipitem.html",
                controller:'PrivateQuipItemCtrl'
            }
        }
    })

    .state('app.privatequipsearch', {
        url: "/privatequipsearch",
        views: {
            'menuContent': {
                templateUrl: "views/app/privatequip/privatequip-search.html",
                controller:'PrivateQuipSearchCtrl'
            }
        }
    })

    // GALLERY
    .state('gallery', {
        url: "/gallery",
        abstract: true,
        templateUrl: "views/app/gallery.html",
        controller: 'GalleryCtrl'
    })
    .state('gallery.gallery-list', {
        url: "/gallery-list",
        templateUrl: "views/app/gallery-list.html",
        controller: 'GalleryListCtrl'
    })

    // MESSENGER
    .state('msngr', {
        url: "/msngr",
        templateUrl: "views/abstract/blank.html",
        abstract: true
    })

    .state('msngr.list', {
        url: '/list',
        cache:false,
         templateUrl: "views/msngr/chatlist.html",
        controller: 'ChatListCtrl'
    })

    .state('msngr.chatroom', {
        url: '/chatroom',
        templateUrl: "views/msngr/chatroom.html",
        controller: 'ChatroomCtrl'
    })

    /*.state('msngr.list', {
        url: '/list',
        templateUrl: "views/msngr/list.html",
        controller: 'ListCtrl'
    })*/

    .state('msngr.prv_msg', {
        url: '/prv_msg/:quipperid/:chatter/:chatterhandle',
        templateUrl: "views/msngr/prv_chat.html",
        cache:false,
        controller: 'PrivateChatCtrl'

    })

    .state('auth.introslides', {
        url: '/introslides',
        templateUrl: "views/auth/introslides.html",
        controller: 'IntroslidesCtrl'
    })

   
    ;
    // if none of the above states are matched, use this as the fallback
 /*   if($cookies.visited) {
        $urlRouterProvider.otherwise("/auth/introslides");
    } else {*/

        if(window.localStorage['newly_installed'] == 1){
            G_token = window.localStorage['user_data'];
            if(G_token == '' || G_token == null || G_token == 'null'){
                $urlRouterProvider.otherwise("/auth/walkthrough");
            }else{
                $urlRouterProvider.otherwise("app/home");
            }
        }else{
            $urlRouterProvider.otherwise("auth/introslides");
            window.localStorage['newly_installed'] = 1;
        }
    //}
});


function onProfilePicError(ele) {
    this.ele.src = ''; // set a fallback
}

function getMockMessages() {
    return {"messages":[{"_id":"535d625f898df4e80e2a125e","text":"Ionic has changed the game for hybrid app development.","userId":"534b8fb2aa5e7afc1b23e69c","date":"2014-04-27T20:02:39.082Z","read":true,"readDate":"2014-12-01T06:27:37.944Z"},{"_id":"535f13ffee3b2a68112b9fc0","text":"I like Ionic better than ice cream!","userId":"534b8e5aaa5e7afc1b23e69b","date":"2014-04-29T02:52:47.706Z","read":true,"readDate":"2014-12-01T06:27:37.944Z"},{"_id":"546a5843fd4c5d581efa263a","text":"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","userId":"534b8fb2aa5e7afc1b23e69c","date":"2014-11-17T20:19:15.289Z","read":true,"readDate":"2014-12-01T06:27:38.328Z"},{"_id":"54764399ab43d1d4113abfd1","text":"Am I dreaming?","userId":"534b8e5aaa5e7afc1b23e69b","date":"2014-11-26T21:18:17.591Z","read":true,"readDate":"2014-12-01T06:27:38.337Z"},{"_id":"547643aeab43d1d4113abfd2","text":"Is this magic?","userId":"534b8fb2aa5e7afc1b23e69c","date":"2014-11-26T21:18:38.549Z","read":true,"readDate":"2014-12-01T06:27:38.338Z"},{"_id":"547815dbab43d1d4113abfef","text":"Gee wiz, this is something special.","userId":"534b8e5aaa5e7afc1b23e69b","date":"2014-11-28T06:27:40.001Z","read":true,"readDate":"2014-12-01T06:27:38.338Z"},{"_id":"54781c69ab43d1d4113abff0","text":"I think I like Ionic more than I like ice cream!","userId":"534b8fb2aa5e7afc1b23e69c","date":"2014-11-28T06:55:37.350Z","read":true,"readDate":"2014-12-01T06:27:38.338Z"},{"_id":"54781ca4ab43d1d4113abff1","text":"Yea, it's pretty sweet","userId":"534b8e5aaa5e7afc1b23e69b","date":"2014-11-28T06:56:36.472Z","read":true,"readDate":"2014-12-01T06:27:38.338Z"},{"_id":"5478df86ab43d1d4113abff4","text":"Wow, this is really something huh?","userId":"534b8fb2aa5e7afc1b23e69c","date":"2014-11-28T20:48:06.572Z","read":true,"readDate":"2014-12-01T06:27:38.339Z"},{"_id":"54781ca4ab43d1d4113abff1","text":"Create amazing apps - ionicframework.com","userId":"534b8e5aaa5e7afc1b23e69b","date":"2014-11-29T06:56:36.472Z","read":true,"readDate":"2014-12-01T06:27:38.338Z"}],"unread":0};
}


// configure moment relative time
// moment.locale('en', {
//     relativeTime: {
//         future: "in %s",
//         past: "%s ago",
//         s: "%d sec",
//         m: "a minute",
//         mm: "%d minutes",
//         h: "an hour",
//         hh: "%d hours",
//         d: "a day",
//         dd: "%d days",
//         M: "a month",
//         MM: "%d months",
//         y: "a year",
//         yy: "%d years"
//     }
// });

/*
* angular-elastic v2.4.2
* (c) 2014 Monospaced http://monospaced.com
* License: MIT
*/

angular.module('monospaced.elastic', [])

.constant('msdElasticConfig', {
    append: ''
})

.directive('msdElastic', [
    '$timeout', '$window', 'msdElasticConfig',
    function($timeout, $window, config) {
        'use strict';

        return {
            require: 'ngModel',
            restrict: 'A, C',
            link: function(scope, element, attrs, ngModel) {

                // cache a reference to the DOM element
                var ta = element[0],
                $ta = element;

                // ensure the element is a textarea, and browser is capable
                if (ta.nodeName !== 'TEXTAREA' || !$window.getComputedStyle) {
                    return;
                }

                // set these properties before measuring dimensions
                $ta.css({
                    'overflow': 'hidden',
                    'overflow-y': 'hidden',
                    'word-wrap': 'break-word'
                });

                // force text reflow
                var text = ta.value;
                ta.value = '';
                ta.value = text;

                var append = attrs.msdElastic ? attrs.msdElastic.replace(/\\n/g, '\n') : config.append,
                $win = angular.element($window),
                mirrorInitStyle = 'position: absolute; top: -999px; right: auto; bottom: auto;' +
                'left: 0; overflow: hidden; -webkit-box-sizing: content-box;' +
                '-moz-box-sizing: content-box; box-sizing: content-box;' +
                'min-height: 0 !important; height: 0 !important; padding: 0;' +
                'word-wrap: break-word; border: 0;',
                $mirror = angular.element('<textarea tabindex="-1" ' +
                    'style="' + mirrorInitStyle + '"/>').data('elastic', true),
                mirror = $mirror[0],
                taStyle = getComputedStyle(ta),
                resize = taStyle.getPropertyValue('resize'),
                borderBox = taStyle.getPropertyValue('box-sizing') === 'border-box' ||
                taStyle.getPropertyValue('-moz-box-sizing') === 'border-box' ||
                taStyle.getPropertyValue('-webkit-box-sizing') === 'border-box',
                boxOuter = !borderBox ? {width: 0, height: 0} : {
                    width:  parseInt(taStyle.getPropertyValue('border-right-width'), 10) +
                    parseInt(taStyle.getPropertyValue('padding-right'), 10) +
                    parseInt(taStyle.getPropertyValue('padding-left'), 10) +
                    parseInt(taStyle.getPropertyValue('border-left-width'), 10),
                    height: parseInt(taStyle.getPropertyValue('border-top-width'), 10) +
                    parseInt(taStyle.getPropertyValue('padding-top'), 10) +
                    parseInt(taStyle.getPropertyValue('padding-bottom'), 10) +
                    parseInt(taStyle.getPropertyValue('border-bottom-width'), 10)
                },
                minHeightValue = parseInt(taStyle.getPropertyValue('min-height'), 10),
                heightValue = parseInt(taStyle.getPropertyValue('height'), 10),
                minHeight = Math.max(minHeightValue, heightValue) - boxOuter.height,
                maxHeight = parseInt(taStyle.getPropertyValue('max-height'), 10),
                mirrored,
                active,
                copyStyle = ['font-family',
                    'font-size',
                    'font-weight',
                    'font-style',
                    'letter-spacing',
                    'line-height',
                    'text-transform',
                    'word-spacing',
                    'text-indent'];

                // exit if elastic already applied (or is the mirror element)
                if ($ta.data('elastic')) {
                    return;
                }

                // Opera returns max-height of -1 if not set
                maxHeight = maxHeight && maxHeight > 0 ? maxHeight : 9e4;

                // append mirror to the DOM
                if (mirror.parentNode !== document.body) {
                    angular.element(document.body).append(mirror);
                }

                // set resize and apply elastic
                $ta.css({
                    'resize': (resize === 'none' || resize === 'vertical') ? 'none' : 'horizontal'
                }).data('elastic', true);

                /*
                * methods
                */

                function initMirror() {
                    var mirrorStyle = mirrorInitStyle;

                    mirrored = ta;
                    // copy the essential styles from the textarea to the mirror
                    taStyle = getComputedStyle(ta);
                    angular.forEach(copyStyle, function(val) {
                        mirrorStyle += val + ':' + taStyle.getPropertyValue(val) + ';';
                    });
                    mirror.setAttribute('style', mirrorStyle);
                }

                function adjust() {
                    var taHeight,
                    taComputedStyleWidth,
                    mirrorHeight,
                    width,
                    overflow;

                    if (mirrored !== ta) {
                        initMirror();
                    }

                    // active flag prevents actions in function from calling adjust again
                    if (!active) {
                        active = true;

                        mirror.value = ta.value + append; // optional whitespace to improve animation
                        mirror.style.overflowY = ta.style.overflowY;

                        taHeight = ta.style.height === '' ? 'auto' : parseInt(ta.style.height, 10);

                        taComputedStyleWidth = getComputedStyle(ta).getPropertyValue('width');

                        // ensure getComputedStyle has returned a readable 'used value' pixel width
                        if (taComputedStyleWidth.substr(taComputedStyleWidth.length - 2, 2) === 'px') {
                            // update mirror width in case the textarea width has changed
                            width = parseInt(taComputedStyleWidth, 10) - boxOuter.width;
                            mirror.style.width = width + 'px';
                        }

                        mirrorHeight = mirror.scrollHeight;

                        if (mirrorHeight > maxHeight) {
                            mirrorHeight = maxHeight;
                            overflow = 'scroll';
                        } else if (mirrorHeight < minHeight) {
                            mirrorHeight = minHeight;
                        }
                        mirrorHeight += boxOuter.height;
                        ta.style.overflowY = overflow || 'hidden';

                        if (taHeight !== mirrorHeight) {
                            ta.style.height = mirrorHeight + 'px';
                            scope.$emit('elastic:resize', $ta);
                        }

                        scope.$emit('taResize', $ta); // listen to this in the UserMessagesCtrl

                        // small delay to prevent an infinite loop
                        $timeout(function() {
                            active = false;
                            }, 1);

                    }
                }

                function forceAdjust() {
                    active = false;
                    adjust();
                }

                /*
                * initialise
                */

                // listen
                if ('onpropertychange' in ta && 'oninput' in ta) {
                    // IE9
                    ta['oninput'] = ta.onkeyup = adjust;
                } else {
                    ta['oninput'] = adjust;
                }

                $win.bind('resize', forceAdjust);

                scope.$watch(function() {
                    return ngModel.$modelValue;
                    }, function(newValue) {
                        forceAdjust();
                });

                scope.$on('elastic:adjust', function() {
                    initMirror();
                    forceAdjust();
                });

                $timeout(adjust);

                /*
                * destroy
                */

                scope.$on('$destroy', function() {
                    $mirror.remove();
                    $win.unbind('resize', forceAdjust);
                });
            }
        };
    }
]);

// autolinker
/*!
* Autolinker.js
* 0.15.0
*
* Copyright(c) 2014 Gregory Jacobs <greg@greg-jacobs.com>
* MIT Licensed. http://www.opensource.org/licenses/mit-license.php
*
* https://github.com/gregjacobs/Autolinker.js
*/
!function(a,b){"function"==typeof define&&define.amd?define([],function(){return a.returnExportsGlobal=b()}):"object"==typeof exports?module.exports=b():a.Autolinker=b()}(this,function(){var a=function(b){a.Util.assign(this,b),this.matchValidator=new a.MatchValidator};return a.prototype={constructor:a,urls:!0,email:!0,twitter:!0,newWindow:!0,stripPrefix:!0,className:"",htmlCharacterEntitiesRegex:/(&nbsp;|&#160;|&lt;|&#60;|&gt;|&#62;)/gi,matcherRegex:function(){var a=/(^|[^\w])@(\w{1,15})/,b=/(?:[\-;:&=\+\$,\w\.]+@)/,c=/(?:[A-Za-z][-.+A-Za-z0-9]+:(?![A-Za-z][-.+A-Za-z0-9]+:\/\/)(?!\d+\/?)(?:\/\/)?)/,d=/(?:www\.)/,e=/[A-Za-z0-9\.\-]*[A-Za-z0-9\-]/,f=/\.(?:international|construction|contractors|enterprises|photography|productions|foundation|immobilien|industries|management|properties|technology|christmas|community|directory|education|equipment|institute|marketing|solutions|vacations|bargains|boutique|builders|catering|cleaning|clothing|computer|democrat|diamonds|graphics|holdings|lighting|partners|plumbing|supplies|training|ventures|academy|careers|company|cruises|domains|exposed|flights|florist|gallery|guitars|holiday|kitchen|neustar|okinawa|recipes|rentals|reviews|shiksha|singles|support|systems|agency|berlin|camera|center|coffee|condos|dating|estate|events|expert|futbol|kaufen|luxury|maison|monash|museum|nagoya|photos|repair|report|social|supply|tattoo|tienda|travel|viajes|villas|vision|voting|voyage|actor|build|cards|cheap|codes|dance|email|glass|house|mango|ninja|parts|photo|shoes|solar|today|tokyo|tools|watch|works|aero|arpa|asia|best|bike|blue|buzz|camp|club|cool|coop|farm|fish|gift|guru|info|jobs|kiwi|kred|land|limo|link|menu|mobi|moda|name|pics|pink|post|qpon|rich|ruhr|sexy|tips|vote|voto|wang|wien|wiki|zone|bar|bid|biz|cab|cat|ceo|com|edu|gov|int|kim|mil|net|onl|org|pro|pub|red|tel|uno|wed|xxx|xyz|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cw|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|za|zm|zw)\b/,g=/[\-A-Za-z0-9+&@#\/%=~_()|'$*\[\]?!:,.;]*[\-A-Za-z0-9+&@#\/%=~_()|'$*\[\]]/;return new RegExp(["(",a.source,")","|","(",b.source,e.source,f.source,")","|","(","(?:","(",c.source,e.source,")","|","(?:","(.?//)?",d.source,e.source,")","|","(?:","(.?//)?",e.source,f.source,")",")","(?:"+g.source+")?",")"].join(""),"gi")}(),charBeforeProtocolRelMatchRegex:/^(.)?\/\//,link:function(b){var c=this,d=this.getHtmlParser(),e=this.htmlCharacterEntitiesRegex,f=0,g=[];return d.parse(b,{processHtmlNode:function(a,b,c){"a"===b&&(c?f=Math.max(f-1,0):f++),g.push(a)},processTextNode:function(b){if(0===f)for(var d=a.Util.splitAndCapture(b,e),h=0,i=d.length;i>h;h++){var j=d[h],k=c.processTextNode(j);g.push(k)}else g.push(b)}}),g.join("")},getHtmlParser:function(){var b=this.htmlParser;return b||(b=this.htmlParser=new a.HtmlParser),b},getTagBuilder:function(){var b=this.tagBuilder;return b||(b=this.tagBuilder=new a.AnchorTagBuilder({newWindow:this.newWindow,truncate:this.truncate,className:this.className})),b},processTextNode:function(a){var b=this;return a.replace(this.matcherRegex,function(a,c,d,e,f,g,h,i,j){var k=b.processCandidateMatch(a,c,d,e,f,g,h,i,j);if(k){var l=b.createMatchReturnVal(k.match,k.matchStr);return k.prefixStr+l+k.suffixStr}return a})},processCandidateMatch:function(b,c,d,e,f,g,h,i,j){var k,l=i||j,m="",n="";if(c&&!this.twitter||f&&!this.email||g&&!this.urls||!this.matchValidator.isValidMatch(g,h,l))return null;if(this.matchHasUnbalancedClosingParen(b)&&(b=b.substr(0,b.length-1),n=")"),f)k=new a.match.Email({matchedText:b,email:f});else if(c)d&&(m=d,b=b.slice(1)),k=new a.match.Twitter({matchedText:b,twitterHandle:e});else{if(l){var o=l.match(this.charBeforeProtocolRelMatchRegex)[1]||"";o&&(m=o,b=b.slice(1))}k=new a.match.Url({matchedText:b,url:b,protocolUrlMatch:!!h,protocolRelativeMatch:!!l,stripPrefix:this.stripPrefix})}return{prefixStr:m,suffixStr:n,matchStr:b,match:k}},matchHasUnbalancedClosingParen:function(a){var b=a.charAt(a.length-1);if(")"===b){var c=a.match(/\(/g),d=a.match(/\)/g),e=c&&c.length||0,f=d&&d.length||0;if(f>e)return!0}return!1},createMatchReturnVal:function(b,c){var d;if(this.replaceFn&&(d=this.replaceFn.call(this,this,b)),"string"==typeof d)return d;if(d===!1)return c;if(d instanceof a.HtmlTag)return d.toString();var e=this.getTagBuilder(),f=e.build(b);return f.toString()}},a.link=function(b,c){var d=new a(c);return d.link(b)},a.match={},a.Util={abstractMethod:function(){throw"abstract"},assign:function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);return a},extend:function(b,c){var d=b.prototype,e=function(){};e.prototype=d;var f;f=c.hasOwnProperty("constructor")?c.constructor:function(){d.constructor.apply(this,arguments)};var g=f.prototype=new e;return g.constructor=f,g.superclass=d,delete c.constructor,a.Util.assign(g,c),f},ellipsis:function(a,b,c){return a.length>b&&(c=null==c?"..":c,a=a.substring(0,b-c.length)+c),a},indexOf:function(a,b){if(Array.prototype.indexOf)return a.indexOf(b);for(var c=0,d=a.length;d>c;c++)if(a[c]===b)return c;return-1},splitAndCapture:function(a,b){if(!b.global)throw new Error("`splitRegex` must have the 'g' flag set");for(var c,d=[],e=0;c=b.exec(a);)d.push(a.substring(e,c.index)),d.push(c[0]),e=c.index+c[0].length;return d.push(a.substring(e)),d}},a.HtmlParser=a.Util.extend(Object,{htmlRegex:function(){var a=/[0-9a-zA-Z][0-9a-zA-Z:]*/,b=/[^\s\0"'>\/=\x01-\x1F\x7F]+/,c=/(?:".*?"|'.*?'|[^'"=<>`\s]+)/,d=b.source+"(?:\\s*=\\s*"+c.source+")?";return new RegExp(["(?:","<(!DOCTYPE)","(?:","\\s+","(?:",d,"|",c.source+")",")*",">",")","|","(?:","<(/)?","("+a.source+")","(?:","\\s+",d,")*","\\s*/?",">",")"].join(""),"gi")}(),parse:function(a,b){b=b||{};for(var c,d=b.processHtmlNode||function(){},e=b.processTextNode||function(){},f=this.htmlRegex,g=0;null!==(c=f.exec(a));){var h=c[0],i=c[1]||c[3],j=!!c[2],k=a.substring(g,c.index);k&&e(k),d(h,i.toLowerCase(),j),g=c.index+h.length}if(g<a.length){var l=a.substring(g);l&&e(l)}}}),a.HtmlTag=a.Util.extend(Object,{whitespaceRegex:/\s+/,constructor:function(b){a.Util.assign(this,b),this.innerHtml=this.innerHtml||this.innerHTML},setTagName:function(a){return this.tagName=a,this},getTagName:function(){return this.tagName||""},setAttr:function(a,b){var c=this.getAttrs();return c[a]=b,this},getAttr:function(a){return this.getAttrs()[a]},setAttrs:function(b){var c=this.getAttrs();return a.Util.assign(c,b),this},getAttrs:function(){return this.attrs||(this.attrs={})},setClass:function(a){return this.setAttr("class",a)},addClass:function(b){for(var c,d=this.getClass(),e=this.whitespaceRegex,f=a.Util.indexOf,g=d?d.split(e):[],h=b.split(e);c=h.shift();)-1===f(g,c)&&g.push(c);return this.getAttrs()["class"]=g.join(" "),this},removeClass:function(b){for(var c,d=this.getClass(),e=this.whitespaceRegex,f=a.Util.indexOf,g=d?d.split(e):[],h=b.split(e);g.length&&(c=h.shift());){var i=f(g,c);-1!==i&&g.splice(i,1)}return this.getAttrs()["class"]=g.join(" "),this},getClass:function(){return this.getAttrs()["class"]||""},hasClass:function(a){return-1!==(" "+this.getClass()+" ").indexOf(" "+a+" ")},setInnerHtml:function(a){return this.innerHtml=a,this},getInnerHtml:function(){return this.innerHtml||""},toString:function(){var a=this.getTagName(),b=this.buildAttrsStr();return b=b?" "+b:"",["<",a,b,">",this.getInnerHtml(),"</",a,">"].join("")},buildAttrsStr:function(){if(!this.attrs)return"";var a=this.getAttrs(),b=[];for(var c in a)a.hasOwnProperty(c)&&b.push(c+'="'+a[c]+'"');return b.join(" ")}}),a.MatchValidator=a.Util.extend(Object,{invalidProtocolRelMatchRegex:/^[\w]\/\//,hasFullProtocolRegex:/^[A-Za-z][-.+A-Za-z0-9]+:\/\//,uriSchemeRegex:/^[A-Za-z][-.+A-Za-z0-9]+:/,hasWordCharAfterProtocolRegex:/:[^\s]*?[A-Za-z]/,isValidMatch:function(a,b,c){return b&&!this.isValidUriScheme(b)||this.urlMatchDoesNotHaveProtocolOrDot(a,b)||this.urlMatchDoesNotHaveAtLeastOneWordChar(a,b)||this.isInvalidProtocolRelativeMatch(c)?!1:!0},isValidUriScheme:function(a){var b=a.match(this.uriSchemeRegex)[0];return"javascript:"!==b&&"vbscript:"!==b},urlMatchDoesNotHaveProtocolOrDot:function(a,b){return!(!a||b&&this.hasFullProtocolRegex.test(b)||-1!==a.indexOf("."))},urlMatchDoesNotHaveAtLeastOneWordChar:function(a,b){return a&&b?!this.hasWordCharAfterProtocolRegex.test(a):!1},isInvalidProtocolRelativeMatch:function(a){return!!a&&this.invalidProtocolRelMatchRegex.test(a)}}),a.AnchorTagBuilder=a.Util.extend(Object,{constructor:function(b){a.Util.assign(this,b)},build:function(b){var c=new a.HtmlTag({tagName:"a",attrs:this.createAttrs(b.getType(),b.getAnchorHref()),innerHtml:this.processAnchorText(b.getAnchorText())});return c},createAttrs:function(a,b){var c={href:b},d=this.createCssClass(a);return d&&(c["class"]=d),this.newWindow&&(c.target="_blank"),c},createCssClass:function(a){var b=this.className;return b?b+" "+b+"-"+a:""},processAnchorText:function(a){return a=this.doTruncate(a)},doTruncate:function(b){return a.Util.ellipsis(b,this.truncate||Number.POSITIVE_INFINITY)}}),a.match.Match=a.Util.extend(Object,{constructor:function(b){a.Util.assign(this,b)},getType:a.Util.abstractMethod,getMatchedText:function(){return this.matchedText},getAnchorHref:a.Util.abstractMethod,getAnchorText:a.Util.abstractMethod}),a.match.Email=a.Util.extend(a.match.Match,{getType:function(){return"email"},getEmail:function(){return this.email},getAnchorHref:function(){return"mailto:"+this.email},getAnchorText:function(){return this.email}}),a.match.Twitter=a.Util.extend(a.match.Match,{getType:function(){return"twitter"},getTwitterHandle:function(){return this.twitterHandle},getAnchorHref:function(){return"https://twitter.com/"+this.twitterHandle},getAnchorText:function(){return"@"+this.twitterHandle}}),a.match.Url=a.Util.extend(a.match.Match,{urlPrefixRegex:/^(https?:\/\/)?(www\.)?/i,protocolRelativeRegex:/^\/\//,protocolPrepended:!1,getType:function(){return"url"},getUrl:function(){var a=this.url;return this.protocolRelativeMatch||this.protocolUrlMatch||this.protocolPrepended||(a=this.url="http://"+a,this.protocolPrepended=!0),a},getAnchorHref:function(){var a=this.getUrl();return a.replace(/&amp;/g,"&")},getAnchorText:function(){var a=this.getUrl();return this.protocolRelativeMatch&&(a=this.stripProtocolRelativePrefix(a)),this.stripPrefix&&(a=this.stripUrlPrefix(a)),a=this.removeTrailingSlash(a)},stripUrlPrefix:function(a){return a.replace(this.urlPrefixRegex,"")},stripProtocolRelativePrefix:function(a){return a.replace(this.protocolRelativeRegex,"")},removeTrailingSlash:function(a){return"/"===a.charAt(a.length-1)&&(a=a.slice(0,-1)),a}}),a});

