angular.module('quipsphere.controllers', [])

// APP
.controller('AppCtrl', function($scope, $ionicConfig, $ionicPopover,$state,$ionicActionSheet,$ionicModal,$ionicPlatform,$rootScope) {
     var template = '<ion-popover-view style="top:532px;height:90px"> <ion-content><div style="padding: 10px;color: #000;font-size: 18px;border-bottom:1px solid #E8E8E8" ng-click="goto(\'app.profile\');closePopover();">Profile</div><div style="padding: 10px;color: #000;font-size: 18px;" ng-click="doLogout()">Logout</div></ion-content></ion-popover-view>';
     $scope.showme = {};
     $scope.gotoeditquip = 0;
     
      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      });

      $scope.openPopover = function($event) {
        $scope.popover.show($event);
      };
      $scope.closePopover = function() {
        $scope.popover.hide();
      };

      $scope.doLogout = function(){
          window.localStorage['user_data'] = null;
          window.localStorage['auth_key'] = null;
          window.localStorage['quipper_id'] = null;
        
          $scope.popover.hide();
          $state.go('auth.walkthrough');
      };

    $scope.micPressed = function(){
        
        if($scope.showme == "animate-top"){
            $scope.clickmicout();
            $scope.showme = "animate-bottom";
        }else{
            $scope.clickmicin();
            $scope.showme = "animate-top";
        }
    }

    $scope.clickmicin = function(){
        element = document.getElementById("mic-icon");
        element.src = "img/quipers-pressed.png";
    }
    $scope.clickmicout = function(){
        element = document.getElementById("mic-icon");
        element.src = "img/quipers.png";
    }

})
.controller('LatestQuipCtrl',function($rootScope, $scope, $state, ClockSrv, $ionicScrollDelegate, 
    $ionicSlideBoxDelegate,$ionicLoading,$ionicPopup,
    $stateParams,$ionicPopover, API){
    $scope.latest_quips = [];
    var playedicon = 'img/newsfeed/quip_play_icon_1.png';
    var pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.mediaPausedFlag = 0;
    $rootScope.currentMediaId = '';
    $scope.current_playing = '';
    var latest_quip_element = document.querySelector("#latest-quip");

    $scope.$on('updateratelatestquip',function(event, args){
        for(var i =0; i < $scope.latest_quips.length; i++){
            if($scope.latest_quips[i].unique_id == args.unique_id){
                $scope.latest_quips[i].is_favorited = 1;
                var currentave = $scope.latest_quips[i].average_stars;
                var ratedvalue = args.rating;
                if(currentave == 0){
                    var countdev = 1;
                }else{
                    var countdev = 2;
                }
                var latest_ave = (currentave + ratedvalue) / countdev;
                $scope.latest_quips[i].average_stars = Math.round(latest_ave);
                $scope.latest_quips[i].is_favorited_img = "img/star-quiped.png";
            }
        }
    })


    $scope.$on('updaterequiplatestquip', function(event, args) {
        var unique_id = args.unique_id;
        var id_val = args.id_val;
        for(var i =0; i < $scope.latest_quips.length; i++){
            if($scope.latest_quips[i].unique_id == unique_id){
                if(id_val == "requip_"){
                    $scope.latest_quips[i].is_requipped_img = "img/done-requip-icon.png";
                    $scope.latest_quips[i].quips_count = $scope.latest_quips[i].quips_count + 1;
                    $scope.latest_quips[i].is_requipped_id = 'undorequip_'+unique_id;
                }else{
                    $scope.latest_quips[i].is_requipped_img = "img/requip-quip.png";
                    $scope.latest_quips[i].quips_count = $scope.latest_quips[i].quips_count - 1;
                    $scope.latest_quips[i].is_requipped_id = 'requip_'+unique_id;
                }
                return;
            }
        }
    });

    $scope.$on('updaterreplylatestquip', function(event, args) {
        var unique_id = args.unique_id;
        for(var i =0; i < $scope.latest_quips.length; i++){
            if($scope.latest_quips[i].unique_id == unique_id){
                    $scope.latest_quips[i].count_reply = parseInt($scope.latest_quips[i].count_reply)+1;
                    console.log($scope.latest_quips[i].count_reply);
                return;
            }
        }
    });


    function latestQuipEvent(e){
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.classList;
            for(var i = 0; i < checktarget.length; i++){
                splited = checktarget[i].split("_");
                console.log(splited);

                if(splited[0] == "global"){
                    switch(splited[1]){
                        case "viewtopic":
                                $rootScope.goto('app.home-topics',{id:splited[2]});
                                break;
                        case 'viewprofile':
                                $rootScope.goto('app.view-profile',{id:splited[2]});
                                break;
                        case "viewsphere":
                                $rootScope.goto('app.sphere',{id:splited[2]});
                                break;
                        default:break;
                    }
                }else if(splitedclass[0] == 'viewlink'){
                        var a = classtarget[1];
                        var b = a.replace("viewlink_","");
                        window.open(b, '_system', 'location=yes');
                }
                if(splited[0] == "latestquip"){
                    switch(splited[1]){
                        case "requip":
                        console.log(splited);
                        for(var i = 0; i < $scope.latest_quips.length; i++){
                            if($scope.latest_quips[i].unique_id == splited[2]){
                                if($scope.latest_quips[i].quipper_id != $rootScope.user_data.quipper_id){
                                    console.log($scope.latest_quips[i].quipper_id);
                                    console.log($rootScope.user_data.quipper_id);
                                    $rootScope.globalEventHandler(e,function(s){
                                    });
                                }else{                  
                                    var status = "e";
                                    var ontap_callback = function(e){}
                                    var title = 'Alert';
                                    var btn_text = 'Okay';
                                    var msg = 'You can\'t requip your own post!'; 
                                    $rootScope.popAlert(msg, status, title, btn_text, ontap_callback);
                                }
                                return;
                            }
                        }
                        break;
                        case "undorequip":
                        $rootScope.globalEventHandler(e,function(s){
                        });
                        break;
                        case "sharequip":
                            var uid = splited[3];
                            console.log(uid);
                            window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                        break;
                        case "imgslider":
                            var imgs = $scope.latest_quips[splited[2]].quip_images;
                            $rootScope.showImages(imgs);
                        break;
                        case "viewquipper":
                            console.log("test");
                            $rootScope.reRoute('go','view profile', 0, {id:splited[2]});
                            $rootScope.goto('app.view-profile',{id:splited[2]});
                        break;
                        case "viewcollection":
                            $rootScope.reRoute('go','app.collectionitems', 0, {id:$stateParams.id,collectionid:splited[2], handler:$rootScope.routeParams.handler});
                            $rootScope.goto('app.collectionitems',{id:$stateParams.id,collectionid:splited[2]});
                        break;
                        case "quipmedia":
                            if($scope.current_playing != ''){
                                $scope.current_playing.src = playedicon;
                            }

                            for(var i = 0; i < $scope.latest_quips.length; i++){
                                if($scope.latest_quips[i].unique_id == splited[2]){
                                    var quip_media_class = 'auto_play_'+splited[2];
                                    var elems = document.querySelectorAll("."+quip_media_class);
                                    $scope.current_playing = '';

                                    if($scope.latest_quips[i].is_played == 0){
                                        $scope.quipHeard($scope.latest_quips[i].uniqid);
                                    }
                                    $scope.latest_quips[i].is_played = 1;
                                    for(var i = 0; i < elems.length; i++){
                                        e.target = elems[i];
                                    }
                                    if($rootScope.currentMediaId == splited[2]){
                                        if($rootScope.mediaPausedFlag == 0){
                                            e.target.src = playedicon;
                                            $rootScope.media.pause();
                                        }else{
                                            e.target.src = pausedicon;
                                            $rootScope.media.play();
                                        }
                                    }else{
                                        e.target.src = loadingicon;
                                        e.target.classList.remove('play_0');
                                        e.target.classList.add('play_1');
                                        $rootScope.currentMediaId = splited[2];
                                        $rootScope.media = document.getElementById('quip_audio_src');
                                        $rootScope.media.pause();
                                        $rootScope.media.src = e.target.name;
                                        $rootScope.media.load();
                                        $rootScope.quipPlayerItem = e.target;
                                        $rootScope.sphereQuipUniqueId = splited[2];
                                        $scope.sphere_last_played_id = splited[2];
                                        $scope.current_playing = e.target;
                                    }
                                    return;
                                }
                            }
                        break;
                        case "thread":
                            console.log(splited);
                            $rootScope.threadParentUniqueId = splited[3];
                            for(var i = 0; i < $scope.latest_quips.length; i++){
                                console.log($scope.latest_quips[i].unique_id+":")
                                if($scope.latest_quips[i].unique_id == splited[3]){
                                    console.log("okay");
                                    $rootScope.selectedtopics.handler = $scope.latest_quips[i].quipper_name;
                                    $rootScope.openTopicThreadModal(splited[3]);
                                    $rootScope.reRoute('go','reply thread');
                                    return;
                                }
                            }
                        break;
                        case 'replythread':
                            for(var i = 0; i < $scope.latest_quips.length; i++){
                                if($scope.latest_quips[i].unique_id == splited[2]){
                                    $rootScope.selectedtopics.handler = $scope.latest_quips[i].quipper_name;
                                    $rootScope.threadParentUniqueId = splited[2];
                                    $rootScope.openRecorderModal();
                                    $rootScope.reRoute('go','recorder',1);
                                    return;
                                }
                            }
                        break;

                        case 'ratequip':
                            for(var i = 0; i < $scope.latest_quips.length; i++){
                               if($scope.latest_quips[i].unique_id == splited[2]){ 
                                   $rootScope.ratedata.selecteddata = $scope.latest_quips[i];
                                   $rootScope.openPopoverRate(e,$scope.latest_quips[i].unique_id,'app.latest-quip');
                                   return;
                               }
                           }
                        break;

                        case 'report':
                            for(var i = 0; i < $scope.latest_quips.length; i++){
                               if($scope.latest_quips[i].unique_id == splited[2]){ 
                                   $rootScope.reportdata.r_qpr = $scope.latest_quips[i].quipper_id;
                                   $rootScope.reportdata.r_qpid = $scope.latest_quips[i].unique_id;
                                   $rootScope.reportdata.rqtype = "Quip";
                                   $rootScope.$apply();
                                   $rootScope.openpopoverreport(e);
                                   return;
                               }
                           }
                        break;
                        default:
                        break;
                    }
                }
            }

        }
    }

    $scope.$on('$ionicView.beforeEnter', function() {
        console.log("adding event listener latestQuipEvent")
        latest_quip_element.addEventListener("click", latestQuipEvent, false);
    }); 
    $scope.$on('$ionicView.afterEnter', function() {

    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        console.log("removing event listener latestQuipEvent")
        latest_quip_element.removeEventListener("click", latestQuipEvent, false);
    }); 
    $scope.$on('$ionicView.afterLeave', function() {

    }); 
    $scope.$on('activePullToRefresh',function(){
        PullToRefresh.init({
            contentEl:"sp-content",
            ptrEl:"sp-ptr",
            limittrigger:'sp-container',
            bodyId:'sp-bodycontainer',
            loadingFunction: getLatestQuipData,
            limitscroll: 0
        });
    });
    function getLatestQuipData(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                document.querySelector("#sp-ptr").style.display = "block";
                if($scope.latest_quips.length != 0){
                    API.getLatestQuip({
                        action:'get_latest',
                        unique_id:$scope.latest_quips[0].unique_id
                    },function(data){
                        if(data.Result == 1){
                            if(data.Data.length != 0){
                                window.localStorage['latest_quips'] = JSON.stringify(data.Data.concat($scope.latest_quips));
                                $scope.latest_quips = JSON.parse(window.localStorage['latest_quips']);
                            }
                        }
                        document.querySelector("#sp-ptr").style.display = "none";
                    },function(err){
                        document.querySelector("#sp-ptr").style.display = "none";
                    });
                }else{
                    API.getLatestQuip({
                    },function(data){
                        console.log(data);
                        if(data.Result == 1){
                            if(data.Data.length != 0){
                                window.localStorage['latest_quips'] = JSON.stringify(data.Data.concat($scope.latest_quips));
                                $scope.latest_quips = JSON.parse(window.localStorage['latest_quips']);
                            }
                        }
                        document.querySelector("#sp-ptr").style.display = "none";
                    },function(err){
                        document.querySelector("#sp-ptr").style.display = "none";
                    });
                }
            } else {
                reject();
            }
        } );
    }
    $scope.loadmoreLatestQuip = function(){
        if($scope.stoploadinglatestquip === false){
            $scope.stoploadinglatestquip = true;
            if($scope.latest_quips.length){
                document.getElementById("latestquiploading").style.display = "block";
                console.log($scope.latest_quips[$scope.latest_quips.length - 1].unique_id);
                API.getLatestQuip({
                    unique_id : $scope.latest_quips[$scope.latest_quips.length - 1].unique_id,
                    action: "show_more"
                }, function(data){
                    if(data.Data.length > 0){
                        $scope.latest_quips = $scope.latest_quips.concat(data.Data);
                    }else{
                        
                    }
                    $scope.stoploadinglatestquip = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    document.getElementById("latestquiploading").style.display = "none"
                    
                }, function(err){
                    $scope.stoploadinglatestquip = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    document.getElementById("latestquiploading").style.display = "none"
                });

                var loadinginficon = document.getElementsByClassName("loading-inf");
                loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
            }else{
                $scope.$broadcast('scroll.infiniteScrollComplete');
                document.getElementById("latestquiploading").style.display = "none"
            }
        }
    }
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        if(toState.name == 'app.latest-quip'){
            document.querySelector("#sp-ptr").style.display = "none";
            document.querySelector("#sp-content").style.display = "none";
            API.getLatestQuip({
            },function(data){
                $scope.$broadcast('activePullToRefresh');
                if(data.Result == 1){
                    if(data.Data.length!=0){
                        window.localStorage['latest_quips'] = JSON.stringify(data.Data);
                        $scope.latest_quips = data.Data;
                        $scope.stoploadinglatestquip = false;
                    }
                }else{
                }
                document.querySelector("#sp-ptr").style.display = "none";
                document.querySelector("#sp-content").style.display = "block";
            },function(err){
                $scope.$broadcast('activePullToRefresh');
                document.querySelector("#sp-ptr").style.display = "none";
                document.querySelector("#sp-content").style.display = "block";
            });
        }
    });   

})
.controller('HomeCtrl', function($scope, $rootScope, $ionicSlideBoxDelegate, $ionicHistory, $timeout,$state, 
        $ionicScrollDelegate,$ionicModal, HomeInit, API, $log, Constant, $cordovaGoogleAnalytics) {

    function _waitForAnalytics(){ 
        if(typeof analytics !== 'undefined'){
            $cordovaGoogleAnalytics.startTrackerWithId('UA-76820046-1'); 
            $cordovaGoogleAnalytics.trackView('Android Home Screen');
            $cordovaGoogleAnalytics.setUserId($rootScope.user_data.quipper_id);
        }else{ 
            setTimeout(function(){ 
                _waitForAnalytics(); 
            },250); 
        } 
    }; 
    _waitForAnalytics();

    // if(quipDebug == 0){
    //     if($rootScope.flagsplash === 0){
    //         $rootScope.opensplashModal();
    //         $timeout(function() {
    //             $rootScope.closesplashModal();
    //             $rootScope.flagsplash = 1;
    //         }, 3000);
    //     }
    // }
    
    $scope.profile_main_picture = 'img/no_pic.png?'+ new Date().getTime();
    $scope.$on('$ionicView.beforeEnter', function() {
        
        var parentmenutab = document.querySelector("#parentmenutab");
        parentmenutab.addEventListener("click", doEvent, false);

        var theParent = document.querySelector("#parenttabevent");
        theParent.addEventListener("click", doEvent, false);
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        var parentmenutab = document.querySelector("#parentmenutab");
        parentmenutab.removeEventListener("click", doEvent, false);

        var theParent = document.querySelector("#parenttabevent");
        theParent.removeEventListener("click", doEvent, false);
    });

    $scope.topictap = function(){
        $scope.stoploadingtopic = true;
        $scope.showloadinghometopic = true;

        if($scope.trendtopicdata){
            $timeout(function(){
                if($scope.trendtopicdata.length > 0){
                    $scope.stoploadingtopic = false;
                }
                $scope.showloadinghometopic = false;

            $ionicSlideBoxDelegate.$getByHandle('homeimgslide').update();
            $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
                WebPullToRefresh.init({
                    contentEl:"topic_content",
                    ptrEl:"topic-ptr",
                    limittrigger:'topiclist-container',
                    bodyId:'topic_container',
                    loadingFunction: getTrendingTopics
                });
            },3000);
        }
    }

    $scope.tapquipper = function(){
        $scope.showloadinghomequipper = true;
        $scope.stoploadingquipper = true;
        console.log($scope.trendquippersdata.length);
        if($scope.trendquippersdata.length > 0){
            $scope.showloadinghomequipper = false;
        }
        else{
            getTrendingQuippers(); 
            $timeout(function(){
                if($scope.trendquippersdata.length > 0){
                    $scope.showloadinghomequipper = false;

                    WebPullToRefresh2.init({
                        contentEl:"quippers_content",
                        ptrEl:"quippers-ptr",
                        limittrigger:'quipperlist-container',
                        bodyId:'quippers_container',
                        loadingFunction: getTrendingQuippers
                    });
                }else{
                    $scope.showloadinghomequipper = false;
                }
            },3000);
        }
    }
    function ImageExist(url) 
    {
       var img = new Image();
       img.src = url;
       return img.height != 0;
    }
    
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
        if(toState.name == 'app.home'){
            $rootScope.reRoute('go','home');
            $ionicSlideBoxDelegate.$getByHandle('homeimgslide').update();
            $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
            if (window.localStorage['quipper_profilepic']){
                imageURI = window.localStorage['quipper_profilepic'];
                if (ImageExist(imageURI)){
                    var image = document.getElementById('smallImage');$scope.profile_main_picture = imageURI;
                   
                }else{
                    //imageURI = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                    $scope.profile_main_picture = imageURI;
                    
                }
            }else{
                    //imageURI = 'http://api.quipsphere.com/GetImage.php?pictype=profile&file='+$rootScope.user_data.quipper_id+'.jpg?'+ new Date().getTime();
                    imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +$rootScope.user_data.quipper_id ;
                    $scope.profile_main_picture = imageURI;
                   
            }  
             $rootScope.searchfor = 0;
            $rootScope.selectedtopics.handler = '';
            $rootScope.selectedtopics.hashtag = '';
            $scope.stoploadingtopic = true;
            if(!$scope.trendtopicdata){
                $scope.showloadinghometopic = true;
                getTrendingTopics();
                var timerchecktopic = setInterval(function(){ checktopicdata() }, 1000);
                function checktopicdata(){
                    if($scope.trendtopicdata.length > 0){
                        $ionicSlideBoxDelegate.$getByHandle('homeimgslide').update();
                        $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
                        WebPullToRefresh.init({
                            contentEl:"topic_content",
                            ptrEl:"topic-ptr",
                            limittrigger:'topiclist-container',
                            bodyId:'topic_container',
                            loadingFunction: getTrendingTopics
                        });

                        $scope.showloadinghometopic = false;
                        $scope.stoploadingtopic = false;
                        document.querySelector("#slide-topics .slider-pager").innerHTML = "<div id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'><h3 id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>"+$scope.trendtopicdata[0].topichash+"</h3><p id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>"+$scope.trendtopicdata[0].quips_count+" quips about this trend</p><button class='button btn-q-blue' id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>JOIN</button></div>";

                        $scope.$apply();
                        var wi = document.querySelectorAll('.trendtopic ion-slide')[0].offsetWidth - 2;
                        var imgw = document.querySelectorAll('.trendtopic ion-slide')[0].offsetWidth;
                        $scope.sldbox = ".trendtopic img{width:"+imgw+"px} .trendtopic ion-slide:nth-child(2) {left: -"+wi+"px!important;}";
                        clearInterval(timerchecktopic);
                    }
                }
            }else{
                $scope.stoploadingtopic = false;
            }

        }

    });
    $scope.openModalsearch = function(){
        if(window.localStorage['trendquippersdata'] == 'undefined' || window.localStorage['trendquippersdata'] == undefined || window.localStorage['trendquippersdata'] == ''){
            $scope.trendquippersdata = [];
        }else{
            $scope.trendquippersdata = JSON.parse(window.localStorage['trendquippersdata']);
        }
        API.getQuipperByHandle({quipper_id:$rootScope.user_data.quipper_id, handle: $scope.search},
        function(data){
            window.localStorage['trendquippersdata'] = JSON.stringify(data.Data);
            $scope.trendquippersdata = JSON.parse(window.localStorage['trendquippersdata']);
            console.log($scope.trendquippersdata);
            $ionicSlideBoxDelegate.update();
        },function(err){
        });
    }

    $rootScope.follow = function(quipper_id, isFollower){
        var spinner = document.getElementById("modal-quipper-follow-spinner");
        spinner.style.visibility = "visible";
        if(isFollower){

            API.unfollowQuipper({
                quipper_id : $rootScope.user_data.quipper_id,
                target_quipper_id : quipper_id
            },function(data){
                spinner.style.visibility = "hidden";
                console.log(data);
                $rootScope.selectedquippers.follower = false;
            },function(err){
                spinner.style.visibility = "hidden";
                console.log(err);
            })
        }else{
            API.followQuipper({
                quipper_id : $rootScope.user_data.quipper_id,
                target_quipper_id : quipper_id
            },function(data){
                spinner.style.visibility = "hidden";
                console.log(data);
                $rootScope.selectedquippers.follower = true;
            },function(err){
                spinner.style.visibility = "hidden";
                console.log(err);
            })
        }
    }

    $scope.slide = function(to) {
        $scope.current = to;
        $ionicSlideBoxDelegate.$getByHandle('homeslide').slide(to);
    }

    $scope.slideHasChanged = function(index) {
        e1 = document.getElementById("slide_0");
        e2 = document.getElementById("slide_1");
        e3 = document.getElementById("slide_2");
        if(index == 0){
            $rootScope.searchfor = 0;
            if(!$scope.trendtopicdata){
                $scope.showloadinghometopic = true;
                getTrendingTopics();
                if($scope.trendtopicdata){
                    $timeout(function(){
                        $scope.showloadinghometopic = false;
                    },3000);
                }
                  
            }
            $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
            e1.classList.add('active');
        }else{
            e1.classList.remove('active');
        }
        if(index == 1){
            $rootScope.searchfor = 1;
            $scope.showloadinghomequipper = true;
            $scope.stoploadingquipper = true;
            if(!$scope.trendquippersdata){
                getTrendingQuippers(); 
                var timercheck = setInterval(function(){ checkquipdata() }, 500);
                function checkquipdata(){
                    if($scope.trendquippersdata.length > 0){
                        $scope.showloadinghomequipper = false;
                        $scope.stoploadingquipper = false;
                        $scope.$apply();
                        WebPullToRefresh2.init({
                            contentEl:"quippers_content",
                            ptrEl:"quippers-ptr",
                            limittrigger:'quipperlist-container',
                            bodyId:'quippers_container',
                            loadingFunction: getTrendingQuippers
                        });
                        clearInterval(timercheck);
                    }
                }
            }
            else{
                $scope.showloadinghomequipper = false;
            }
            $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
            e2.classList.add('active');
        }else{
            e2.classList.remove('active');
        }
        if(index == 2){
            $rootScope.searchfor = 2;
            if(!$scope.trendspheresdata){
                $scope.showloadinghomesphere = true;
                $scope.stoploadingsphere = true;
                getTrendingSpheres();   
                var timerchecksp = setInterval(function(){ checkspdata() }, 500);
                function checkspdata(){
                    if($scope.trendspheresdata.length > 0){
                        $scope.showloadinghomesphere = false;
                        $scope.$apply();
                        WebPullToRefresh3.init({
                            contentEl:"spheres_content",
                            ptrEl:"spheres-ptr",
                            limittrigger:'spherelist-container',
                            bodyId:'spheres_container',
                            loadingFunction: getTrendingSpheres
                        });
                        clearInterval(timerchecksp);
                    }
                }
            }
            $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
            e3.classList.add('active');
        }else{
            e3.classList.remove('active');
        }
    }

    $scope.disableSwipe = function() {
       $ionicSlideBoxDelegate.$getByHandle('homeslide').enableSlide(false);
    };

    function getTrendingTopics(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                if(window.localStorage['trendtopicdata'] == undefined || window.localStorage['trendtopicdata'] == ''){
                    $scope.trendtopicdata = [];
                }else{
                    $scope.trendtopicdata = JSON.parse(window.localStorage['trendtopicdata']);
                }
                API.getTrendingTopics({quipper_id:$rootScope.user_data.quipper_id, datastart: 0},
                function(data){
                    window.localStorage['trendtopicdata'] = JSON.stringify(data.Data);
                    $scope.trendtopicdata = JSON.parse(window.localStorage['trendtopicdata']);
                    $scope.starttopic = $scope.trendtopicdata.length;

                    $ionicSlideBoxDelegate.$getByHandle('homeimgslide').update();
                    $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
                    if($scope.trendtopicdata.length > 0){
                        document.querySelector("#slide-topics .slider-pager").innerHTML = "<div id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'><h3 id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>"+$scope.trendtopicdata[0].topichash+"</h3><p id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>"+$scope.trendtopicdata[0].quips_count+" quips about this trend</p><button class='button btn-q-blue' id='topicmodal_"+$scope.trendtopicdata[0].topichash.slice(1)+"'>JOIN</button></div>";
                    }
                    
                    // $scope.showloadinghometopic = false;
                    $scope.stoploadingtopic = false;
                    
                    $ionicSlideBoxDelegate.$getByHandle('homeimgslide').update();
                    $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
                },function(err){
                }); 
            } else {
                reject();
            }
        } );
    }
    $scope.loadmoreTrendingTopics = function(){
        var starttopic = $scope.trendtopicdata.length;
        API.getTrendingTopics({quipper_id:$rootScope.user_data.quipper_id, datastart: starttopic},
        function(data){
                for(i = 0; i < data.Data.length; i++){
                    $scope.trendtopicdata.push(data.Data[i]);
                }

                if(data.Data.length === 0){
                    $scope.stoploadingtopic = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                
            },function(err){
        });
         var loadinginficon = document.getElementsByClassName("loading-inf");
        loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';

    }
    function getTrendingQuippers(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                if(window.localStorage['trendquippersdata'] == undefined || window.localStorage['trendquippersdata'] == 'undefined' || window.localStorage['trendquippersdata'] == ''){
                    $scope.trendquippersdata = [];
                }else{
                    $scope.trendquippersdata = JSON.parse(window.localStorage['trendquippersdata']);
                }
                API.getTrendingQuippers({quipper_id:$rootScope.user_data.quipper_id, datastart: 0},
                function(data){
                    window.localStorage['trendquippersdata'] = JSON.stringify(data.Data);
                    $scope.trendquippersdata = JSON.parse(window.localStorage['trendquippersdata']);
                    $scope.startquipper = $scope.trendquippersdata.length;
                    if($scope.showloadinghomequipper === false){
                        if($scope.trendquippersdata.length > 0){
                            $scope.stoploadingquipper = false;
                        }
                    }

                    $ionicSlideBoxDelegate.$getByHandle('homeslide').update();
                },function(err){
                }); 
            } else {
                reject();
            }
        } );
    }
    $scope.loadmoreTrendingQuippers = function(){

        var quipdatacount = $scope.trendquippersdata.length;
        API.getTrendingQuippers({quipper_id:$rootScope.user_data.quipper_id, datastart: quipdatacount},
        function(data){
                for(i = 0; i < data.Data.length; i++){
                    $scope.trendquippersdata.push(data.Data[i]);
                }
                if(data.Data.length === 0){
                    $scope.stoploadingquipper = true;
                }

                
                console.log($scope.startquipper);
                $scope.$broadcast('scroll.infiniteScrollComplete');
            },function(err){
        });
        var loadinginficon = document.getElementsByClassName("loading-inf");
        loadinginficon[1].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';

    }
    function getTrendingSpheres(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                if(window.localStorage['trendspheresdata'] == undefined || window.localStorage['trendspheresdata'] == ''){
                    $scope.trendspheresdata = [];
                }else{
                    $scope.trendspheresdata = JSON.parse(window.localStorage['trendspheresdata']);
                }
                API.getTrendingSpheres({quipper_id:$rootScope.user_data.quipper_id},
                function(data){
                    window.localStorage['trendspheresdata'] = JSON.stringify(data.Data);
                    $scope.trendspheresdata = JSON.parse(window.localStorage['trendspheresdata']);
                    $ionicSlideBoxDelegate.update();
                },function(err){
                       
                }); 
            } else {
                reject();
            }
        } );
    }
    function doEvent(e) {

        if (e.target !== e.currentTarget) {
            var checktarget = e.target.id;
            splited = checktarget.split("_");

            switch(splited[0]){
                case "unfollow":
                    $rootScope.globalFollowEvent(e);
                    break;
                case "follow":
                    $rootScope.globalFollowEvent(e);
                    break;
                case "topicmodal":
                    $rootScope.selectedtopics.hashtag = '#'+splited[1];
                    $rootScope.reRoute('go','topic thread');
                    $rootScope.goto('app.home-topics',{id:splited[1]});
                    break;
                case "quippermodal":
                    var quipperid = window.localStorage['quipper_id'];
                    if(quipperid == splited[1]){
                        $rootScope.lasttempurl.url = 'app.myprofile';
                        $rootScope.goto('app.myprofile',{id:splited[1]});
                        $rootScope.reRoute('go','view my profile');
                    }else{
                        $rootScope.lasttempurl.url = 'app.view-profile';
                        $rootScope.goto('app.view-profile',{id:splited[1]});
                        $rootScope.reRoute('go','view profile');
                    }
                    $rootScope.lasttempurl.id = splited[1];
                    break;
                case "quippersquip":
                    $rootScope.goto('app.quippers-quip',{id:splited[1]});
                    $rootScope.selectedtopics.handler = '@'+splited[1];
                    $rootScope.lasttempurl.url = 'app.quippers-quip';
                    $rootScope.lasttempurl.id = splited[1];
                    $rootScope.reRoute('go','quippers');
                    break;
                case "viewsphere":
                    $rootScope.reRoute('go','app.mysphere');
                    //$rootScope.threadParentUniqueId = splited[2];
                    $rootScope.reRoute('go','app.sphere', 0, {id:splited[1], handler: splited[2]});
                    $rootScope.goto('app.sphere',{id:splited[1]});
                    break;
                case "quipperimg":
                    var imgs = $scope.trendquippersdata[splited[1]].images;
                    $scope.showImages(imgs);
                    break;
                case "sphereimg":
                    var tobeview = true;
                    for(var i = 0; i < $scope.trendspheresdata.length; i++){
                        if($scope.trendspheresdata[i].unique_id == splited[1]){
                            if(tobeview){
                                var imgs = $scope.trendspheresdata[i].images;
                                $scope.showImages(imgs);
                                tobeview = false;
                            }
                        }
                    }
                    break;
                /*menu tab*/
                default:
            }
        }
        e.stopPropagation();
    }

})

.controller('QuipperProfileCtrl', function($scope, $state, $ionicPopup, $state, $stateParams, $rootScope, API) {
    $scope.qp_selectedquipper = [];
    $scope.showLoading = false;
    
    //--- media variables
    var playedicon = 'img/quip_play_icon.png';
    var pausedicon = 'img/quip_pause_icon.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.media = document.getElementById('quip_audio_src');
    $rootScope.mediaPausedFlag = 0;
    $rootScope.currentMediaId = '';
    var mediaLoadedFlag = 0;
    //--- media variables
    $scope.$on('$ionicView.beforeEnter', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "none";

        var parentelement = document.querySelector("#quipper-profile");
        parentelement.addEventListener("click", doEvent, false);
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });


    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });
    });
    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        if(toState.name == 'app.quippers-profile'){
            $rootScope.showloading = true;
            API.viewProfille({
              quipper_id:$rootScope.user_data.quipper_id,
              target_quipper_id: $stateParams.id
            },function(data){
              $scope.qp_selectedquipper = [];
              window.localStorage['qp_selectedquipper'] = JSON.stringify(data.Data);
              $scope.qp_selectedquipper = JSON.parse(window.localStorage['qp_selectedquipper']);
              console.log($scope.qp_selectedquipper);
                $rootScope.showloading = false;
            },function(err){
                $rootScope.showloading = false;
            });
            
        }
    });
    //$rootScope.showloading = true;
    
    $scope.follow2 = function(quipper_id, isFollower){
        $scope.showLoading = true;
        if(isFollower){

            API.unfollowQuipper({
                quipper_id : $rootScope.user_data.quipper_id,
                target_quipper_id : quipper_id
            },function(data){
                $scope.showLoading = false;
                console.log(data);
                $scope.qp_selectedquipper.follower = false;
            },function(err){
                $scope.showLoading = false;
                console.log(err);
            })
        }else{
            API.followQuipper({
                quipper_id : $rootScope.user_data.quipper_id,
                target_quipper_id : quipper_id
            },function(data){
                $scope.showLoading = false;
                console.log(data);
                $scope.qp_selectedquipper.follower = true;
            },function(err){
                $scope.showLoading = false;
                console.log(err);
            })
        }
    }
    
    function doEvent(e) {
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.title;
            splited = checktarget.split("_");
            //console.log(splited);

            switch(splited[0]){
                case "follower":
                    $rootScope.goto('app.follower',{id:splited[1]});
                    break;
                case "following":
                    $rootScope.goto('app.following',{id:splited[1]});
                    break;
                case "goback":
                    $rootScope.goback();
                    break;
                case "quipmedia":
                    if($rootScope.currentMediaId == e.target.className){
                        if($rootScope.mediaPausedFlag == 0){
                            e.target.src = playedicon;
                            $rootScope.media.pause();
                        }else{
                            e.target.src = pausedicon;
                            $rootScope.media.play();
                        }
                    }else{
                        e.target.src = loadingicon;
                        if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                        }else{
                            var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                            for(var i=0;i<currentPlayerImage.length;i++){
                                currentPlayerImage[i].setAttribute('src',playedicon);
                            }
                        }
                        $rootScope.currentMediaId = e.target.className;
                        $rootScope.media = document.getElementById('quip_audio_src');
                        $rootScope.media.pause();
                        $rootScope.media.src = e.target.name;
                        $rootScope.media.load();
                        $rootScope.quipPlayerItem = e.target; // assign the object to play
                    }
                    break;
                case "imgslider":
                    var imgs = $scope.qp_selectedquipper.data[splited[1]].quip_images;
                    console.log(imgs);
                    $scope.showImages(imgs);
                    break;
                case "sharequip":
                    var uid = splited[2];
                    console.log(uid);
                    window.plugins.socialsharing.share('Listen to this!', "Listen to this", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                    break;
                default:
                    break;
            }
        }
        e.stopPropagation();
    }

})

.controller('FollowingCtrl', function($scope, $state, $ionicPopup, $state, $stateParams, $rootScope, API, $ionicLoading) {
    $scope.qp_selectedquipper = [];
    $scope.qp_modalFollowings = [];
    $scope.$on('$ionicView.beforeEnter', function() {
        // document.getElementsByTagName("ion-header-bar")[0].style.display = "none";
        // window.plugins.nativepagetransitions.slide({
        //   "direction": "left"
        // });
        $rootScope.reRoute('go','follower',$stateParams.id);
        var parentelement = document.querySelector("#followingcon");
        parentelement.addEventListener("click", followingevent, false);
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        // document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        // window.plugins.nativepagetransitions.slide({
        //   "direction": "left"
        // });
        $rootScope.reRoute('go','follower',$stateParams.id);
        var parentelement = document.querySelector("#followingcon");
        parentelement.removeEventListener("click", followingevent, false);
    });


    $scope.stateParamId = $stateParams.id;
    $scope.stoploading = true;
    var offsetf = 0;
    if($scope.qp_modalFollowings.length > 0){
        offsetf = $scope.qp_modalFollowings.length
    }
    if(window.localStorage['qp_modalFollowing'] == undefined || window.localStorage['qp_modalFollowing'] == ""){
        $rootScope.currentquipperfollowing = $stateParams.id;
        $ionicLoading.show();
        API.getFollowings({
            offset:offsetf,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }          
            $scope.qp_modalFollowings = data.Data.followings;
            window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);
            $ionicLoading.hide();

        },function(err){
            console.log(err);
        });
    }else{
        if($rootScope.currentquipperfollowing == $stateParams.id){
            $scope.qp_modalFollowings = JSON.parse(window.localStorage['qp_modalFollowing']);
        }else{
            $rootScope.currentquipperfollowing = $stateParams.id;
            $ionicLoading.show();
            API.getFollowings({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id
            },function(data){
                if(data.Result == 1){
                  $scope.stoploading = false;
                }else{
                   $scope.stoploading = true;
                }         
                $scope.qp_modalFollowings = data.Data.followings;
                window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);
                $ionicLoading.hide();

            },function(err){
                console.log(err);
            });
        }
    }
    

    $scope.fsearchfollower = function(member_name){
        API.getFollowings({
            offset:0,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id,
            member_name: member_name
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }       
            else{
                 $scope.stoploading = true;
            }   
            $scope.qp_modalFollowings = data.Data.followings;
            window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);

        },function(err){
            console.log(err);
        });
    }

    $scope.fresetsearch = function(){
        $scope.member_name = "";
        API.getFollowings({
            offset:0,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }else{
                $scope.stoploading = true;
            }          
            $scope.qp_modalFollowings = data.Data.followings;
            window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);

        },function(err){
            console.log(err);
        });
    }

    $scope.loadmorefollowing = function(){
        if($scope.stoploading == false){
            $scope.stoploading = true;
            document.querySelector(".loadingbar").classList.add("showloading");
            if($scope.qp_modalFollowings.length > 0){
                offsetf = $scope.qp_modalFollowings.length
            }
            API.getFollowings({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id,
                member_name: $scope.member_name
            },function(data){ 
                console.log(data);
                if(data.Data.followings.length > 0){
                    for(var i = 0;i < data.Data.followings.length; i++ ){
                        $scope.qp_modalFollowings.push(data.Data.followings[i]);
                    }
                    window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);
                    $scope.stoploading = false;
                }
                document.querySelector(".loadingbar").classList.remove("showloading");

            },function(err){
                $scope.showloading = false;
                console.log(err);
            });
        }
        
    }

    // var quipperprofilefollowing = document.getElementById("quipper-profile-following");
    // quipperprofilefollowing.addEventListener("click", function(e){
    //     $rootScope.globalFollowEvent(e);
    // }, false);

    function followingevent(e){
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.id;
            splited = checktarget.split("_");
            switch(splited[0]){
                case "viewprofile":
                    $rootScope.goto('app.view-profile',{id:splited[1]});
                    $rootScope.reRoute('go','view profile',splited[1]);
                    break;
                case "follow":
                    API.followQuipper({
                        quipper_id: $rootScope.user_data.quipper_id,
                        target_quipper_id: splited[1]
                        },function(data){
                            for(var i =0; i < $scope.qp_modalFollowings.length; i++){
                                if($scope.qp_modalFollowings[i].quipper_id == splited[1]){
                                    $scope.qp_modalFollowings[i].isFollower_img = "img/unfollow-icon.png";
                                    $scope.qp_modalFollowings[i].isFollower_id = "unfollow_"+splited[1];
                                    window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);
                                }
                            }

                        },function(err){
                            //console.log(err)
                    });
                    break;
                case "unfollow":
                    //console.log('.follow_'+splited[1]+'_class');
                    var name = document.querySelector('.fullname_'+splited[1]+'_class').innerText;
                    var msg  = "Stop following "+name+"?";
                    var status = "e";     
                    var title = "Unfollow this Quipper";   
                    $rootScope.popUp(msg, status, title,  function(e){
                        API.unfollowQuipper({
                            quipper_id: $rootScope.user_data.quipper_id,
                            target_quipper_id: splited[1]
                            },function(data){
                               for(var i =0; i < $scope.qp_modalFollowings.length; i++){
                                    if($scope.qp_modalFollowings[i].quipper_id == splited[1]){
                                        $scope.qp_modalFollowings[i].isFollower_img = "img/follow-icon.png";
                                        $scope.qp_modalFollowings[i].isFollower_id = "follow_"+splited[1];
                                        window.localStorage['qp_modalFollowing'] = JSON.stringify($scope.qp_modalFollowings);
                                    }
                                }
                            },function(err){
                                //console.log(err)
                        });
                    });
                    break;
                default:
                    break;
            }
        }
        e.stopPropagation();
    }
})

.controller('FollowerCtrl', function($scope, $state, $ionicPopup, $state, $stateParams, $rootScope, API, $ionicLoading ) {
    $scope.qp_selectedquipper = [];
    $scope.qp_modalFollowers = [];
    $scope.member_name = "";
    $scope.$on('$ionicView.beforeEnter', function() {
        //document.getElementsByTagName("ion-header-bar")[0].style.display = "none";
        // window.plugins.nativepagetransitions.slide({
        //   "direction": "left"
        // });
        $rootScope.reRoute('go','follower',$stateParams.id);
        var parentelement = document.querySelector("#conloading");
        parentelement.addEventListener("click", followevent, false);
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        //document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        // window.plugins.nativepagetransitions.slide({
        //   "direction": "left"
        // });
        var parentelement = document.querySelector("#conloading");
        parentelement.removeEventListener("click", followevent, false);
    });
    $scope.stateParamId = $stateParams.id;
    $scope.stoploading = true;
    var offsetf = 0;
    if($scope.qp_modalFollowers.length > 0){
        offsetf = $scope.qp_modalFollowers.length
    }
    if(window.localStorage['qp_modalFollowers'] == undefined || window.localStorage['qp_modalFollowers'] == ""){
        $rootScope.currentquipperfollower = $stateParams.id;
        //$ionicLoading.show();
        API.getFollowers({
            offset:offsetf,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }          
            $scope.qp_modalFollowers = data.Data.followers;
            window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);
           // $ionicLoading.hide();

        },function(err){
            console.log(err);
        });
    }else{
        console.log($rootScope.currentquipperfollower, $stateParams.id);
        if($rootScope.currentquipperfollower == $stateParams.id){
            $scope.qp_modalFollowers = JSON.parse(window.localStorage['qp_modalFollowers']);
        }else{
            $rootScope.currentquipperfollower = $stateParams.id;
            //$ionicLoading.show();
            API.getFollowers({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id
            },function(data){
                if(data.Result == 1){
                  $scope.stoploading = false;
                }          
                $scope.qp_modalFollowers = data.Data.followers;
                window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);
                //$ionicLoading.hide();

            },function(err){
                console.log(err);
            });
        }
    }
    
    $scope.searchfollower = function(member_name){
        API.getFollowers({
            offset:0,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id,
            member_name: member_name
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }          
            $scope.qp_modalFollowers = data.Data.followers;
            window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);

        },function(err){
            console.log(err);
        });
    }

    $scope.resetsearch = function(){
        $scope.member_name = "";
        API.getFollowers({
            offset:0,
            quipper_id: $rootScope.user_data.quipper_id,
            target_quipper_id: $stateParams.id
        },function(data){
            if(data.Result == 1){
              $scope.stoploading = false;
            }          
            $scope.qp_modalFollowers = data.Data.followers;
            window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);

        },function(err){
            console.log(err);
        });
    }

    $scope.loadmorefollower = function(){
        if($scope.stoploading == false){
            $scope.stoploading = true;
            document.querySelector(".loadingbar").classList.add("showloading");
            if($scope.qp_modalFollowers.length > 0){
                offsetf = $scope.qp_modalFollowers.length
            }
            API.getFollowers({
                offset:offsetf,
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id,
                member_name: $scope.member_name
            },function(data){ 
                if(data.Data.followers.length > 0){
                    $scope.stoploading = false;
                    for(var i = 0;i < data.Data.followers.length; i++ ){
                        $scope.qp_modalFollowers.push(data.Data.followers[i]);
                    }
                    window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);
                }
                document.querySelector(".loadingbar").classList.remove("showloading");

            },function(err){
                $rootScope.showloading = false;
                console.log(err);
            });
        }
        
    }

    function followevent(e){
            if (e.target !== e.currentTarget) {
                var checktarget = e.target.id;
                splited = checktarget.split("_");
                switch(splited[0]){
                    case "viewprofile":
                        $rootScope.goto('app.view-profile',{id:splited[1]});
                        $rootScope.reRoute('go','view profile',splited[1]);
                        break;
                    case "follow":
                        API.followQuipper({
                            quipper_id: $rootScope.user_data.quipper_id,
                            target_quipper_id: splited[1]
                            },function(data){
                                for(var i =0; i < $scope.qp_modalFollowers.length; i++){
                                    if($scope.qp_modalFollowers[i].quipper_id == splited[1]){
                                        $scope.qp_modalFollowers[i].isFollower_img = "img/unfollow-icon.png";
                                        $scope.qp_modalFollowers[i].isFollower_id = "unfollow_"+splited[1];
                                        window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);
                                    }
                                }

                            },function(err){
                                //console.log(err)
                        });
                        break;
                    case "unfollow":
                        //console.log('.follow_'+splited[1]+'_class');
                        var name = document.querySelector('.fullname_'+splited[1]+'_class').innerText;
                        var msg  = "Stop following "+name+"?";
                        var status = "e";     
                        var title = "Unfollow this Quipper";   
                        $rootScope.popUp(msg, status, title,  function(e){
                            API.unfollowQuipper({
                                quipper_id: $rootScope.user_data.quipper_id,
                                target_quipper_id: splited[1]
                                },function(data){
                                   for(var i =0; i < $scope.qp_modalFollowers.length; i++){
                                        if($scope.qp_modalFollowers[i].quipper_id == splited[1]){
                                            $scope.qp_modalFollowers[i].isFollower_img = "img/follow-icon.png";
                                            $scope.qp_modalFollowers[i].isFollower_id = "follow_"+splited[1];
                                            window.localStorage['qp_modalFollowers'] = JSON.stringify($scope.qp_modalFollowers);
                                        }
                                    }
                                },function(err){
                                    //console.log(err)
                            });
                        });
                        break;
                    default:
                        break;
                }
            }
            e.stopPropagation();
        }
})
.controller('StarsCtrl', function($scope, $state, $ionicPopup, $state, $stateParams, $rootScope, API, Constant) {
    $scope.qp_modalStars = [];
    $scope.$on('$ionicView.beforeEnter', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "none";
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        document.getElementsByTagName("ion-header-bar")[0].style.display = "block";
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
        if(toState.name == 'app.stars'){
            $scope.stateParamId = $stateParams.id;

            API.getStars({
                quipper_id: $rootScope.user_data.quipper_id,
                target_quipper_id: $stateParams.id
            },function(data){
                if(data.Result == 1){
                    console.log(data);
                  window.localStorage['qp_modalStars'] = JSON.stringify(data.Data);
                }          
                
                var tmpdata = data.Data;

                for(var i=0; tmpdata.length > i; i++){
                    
                        //console.log(tmpdata[i].rateduser_quipper_id);

                        //var imageURI = Constant.QUIPSHERE_API_HOST+ '/GetImage.php?pictype=profile&file='+ tmpdata[i].rateduser_quipper_id+'.jpg?'+ new Date().getTime();
                        var imageURI = Constant.QUIPSHERE_API_HOST + '/quipper/getprofilepic?quipperid=' +tmpdata[i].quipper_id ;
                        $scope.starslistrating =tmpdata[i].stars_rating;
                        
                        tmpdata[i].rateduser_avatar =  imageURI;
                        //console.log($rootScope.qp_modalStars[i].rateduser_avatar);
                    
                }
                
                $scope.qp_modalStars = tmpdata;

                console.log($scope.qp_modalStars );
                
                
            },function(err){
                console.log(err);
            });
        }
    });

    
})

    

.controller("ExampleController", function($scope, $cordovaMedia, $ionicLoading) {

    $scope.play = function(src) {
        var media = new Media(src, null, null, mediaStatusCallback);
        $cordovaMedia.play(media);
    }
 
    var mediaStatusCallback = function(status) {
        if(status == 1) {
            $ionicLoading.show({template: 'Loading...'});
        } else {
            $ionicLoading.hide();
        }
    }
 
})

.controller('NotificationCtrl', function($rootScope, $scope, $state, $ionicHistory, API, quipDB, $timeout) {
    
    $scope.notifications = [];

    $scope.$on('$ionicView.beforeEnter', function() {
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });
    }); 

    $scope.$on('$ionicView.beforeLeave', function() {
        window.plugins.nativepagetransitions.slide({
          "direction": "left"
        });
    });

    function createTableNotification(){
        quipDB.execute('DROP TABLE IF EXISTS notifications');
        quipDB.execute('CREATE TABLE IF NOT EXISTS notifications (id integer primary key, notid integer, uniqid, created, nottype, nottype_img, mobi_subject, mobi_content, profile_images_string, url, mobi_read_flag integer, userid integer)');
    }

    function insertNotification(params){
        quipDB.executeSql("INSERT INTO notifications (notid, uniqid, created, nottype, nottype_img, mobi_subject, mobi_content, profile_images_string, url, mobi_read_flag, userid)VALUES(?,?,?,?,?,?,?,?,?,?,?)",
            params,function(tx,res){
            //console.log(tx);
            //console.log(res);
        },function(err){
            //console.log(err);
        });
    }

    function updateNotification(params){
        quipDB.executeSql("UPDATE notifications SET mobi_read_flag = 1 WHERE uniqid = ?",
            params,function(tx,res){
            //console.log(tx);
            //console.log(res);
        },function(err){
            //console.log(err);
        });
        API.readNotification({uniqid:params[0]},function(data){

        }, function(err){

        })
    }

    function selectNotification(callback){
        quipDB.executeSql("SELECT * FROM notifications", [], function(tx,res){
            //console.log(tx);
            //console.log(res);
            var len = res.rows.length;
            var data = [];
            for (var i = 0; i < len; i++){
                var row = res.rows.item(i);
                //console.log(row)
                row['profile_images'] = row.profile_images_string.split(',');
                data.push(row);
            }
            callback(data);
        }, function(err){
            //console.log(err)
            callback(null);
        });
    }

    function insertTop10Latest(){
        createTableNotification();
        if($scope.notifications.length != 0){
            for(var i = 0; i < 10; i++){
                var notification = $scope.notifications[i];
                var insert_params = [];
                var str = "";                
                var profile_images_array = [];
                var profile_images_string = "";
                for(var a in notification.profile_images){
                    profile_images_array.push(notification.profile_images[a])
                }
                profile_images_string = profile_images_array.join(',');
                insert_params.push(notification.notid);
                insert_params.push(notification.uniqid);
                insert_params.push(notification.created);
                insert_params.push(notification.nottype);
                insert_params.push(notification.nottype_img);
                insert_params.push(notification.mobi_subject);
                insert_params.push(notification.mobi_content);
                insert_params.push(profile_images_string);
                insert_params.push(notification.url);
                insert_params.push(notification.mobi_read_flag);
                insert_params.push(notification.userid);
                insertNotification(insert_params);
            }
        }
    }

    $scope.getLatestNotifications = function(){
        API.getNotification({
            notid : $scope.notifications[0].notid
        },function(data){
            if(data.Result == 1){
                if(data.Data){
                    $scope.notifications = data.Data.concat($scope.notifications);
                    $scope.stoploadingnotif = false;
                    insertTop10Latest();
                }
            }
        },function(err){
        });
    }

    $scope.getPreviousNotifications = function(){
        $scope.stoploadingnotif = true;
        API.getNotification({
            offset : $scope.notifications.length
        },function(data){
            if(data.Result == 1){
                if(data.Data){
                    $scope.notifications = $scope.notifications.concat(data.Data);
                    $scope.stoploadingnotif = false;
                }
            }
            if(data.Data.length == 0){
                $scope.stoploadingnotif = true;
            }
            console.log(data.Data.length);
        },function(err){
            $rootScope.showloading = false;
            $scope.stoploadingnotif = true;
        });
    }

    $scope.getNotify = function(){
        $rootScope.showloading = true;
        console.log("Notification: isOnline "+$rootScope.isOnline);
        if(!$rootScope.isOnline){
            selectNotification(function(data){
                if(data != null){
                    $scope.notifications = data;
                    $scope.stoploadingnotif = true;
                }
            })
        }else{
            API.getNotification({
                offset : $scope.notifications.length
            },function(data){
                if(data.Result == 1){
                    if(data.Data){
                        $scope.notifications = data.Data;
                        $scope.stoploadingnotif = false;
                        insertTop10Latest();
                    }
                }
                if(data.Data.length == 0){
                    $scope.stoploadingnotif = true;
                }
            },function(err){
                $rootScope.showloading = false;
                $scope.stoploadingnotif = true;
            });
        }
    }

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){

        if(toState.name == 'app.notification'){

            if($scope.notifications.length === 0){
                $rootScope.showloading = false;
                $scope.stoploadingnotif = true;
                $scope.getNotify();
                $timeout(function(){
                    console.log($scope.notifications.length);
                    $scope.stoploadingnotif = false;
                    NotifPullToRefresh.init({
                        contentEl:"notif-content",
                        ptrEl:"notif-ptr",
                        limittrigger:'notification-view',
                        bodyId:'notif-bodycontainer',
                        loadingFunction: getNotification
                    });
                },3000);
            }
            else{
                $scope.stoploadingnotif = false;
                NotifPullToRefresh.init({
                    contentEl:"notif-content",
                    ptrEl:"notif-ptr",
                    limittrigger:'notification-view',
                    bodyId:'notif-bodycontainer',
                    loadingFunction: getNotification
                });
            }
            
             

            function getNotification(){
                return new Promise( function( resolve, reject ) {
                    if (true) {
                        resolve();
                        $scope.getLatestNotifications();
                    } else {
                        reject();
                    }
                } );
            }

        }

    });

    $rootScope.$on('getNotify',function(){
        $scope.getLatestNotifications();
    })

    $scope.loadMoreNotification = function(){
        if($scope.stoploadingnotif == false){
            API.getNotification({
                offset : $scope.notifications.length
            },function(data){
                if(data.Data.length > 0){
                    $scope.notifications = $scope.notifications.concat(data.Data);
                }else{
                    $scope.stoploadingnotif = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            },function(err){
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
            var loadinginficon = document.getElementsByClassName("loading-inf");
            loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';
        }
    }

    var notificationevents = function(e){
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.title;
            console.log(checktarget); 
            splited = checktarget.split("_");
            switch(splited[0]){
                case "FOLLOW":
                    var uniqid = splited[1];
                    var id = splited[2];
                    $scope.notifications[id].mobi_read_flag = 1;
                    updateNotification([uniqid]);
                    if($scope.notifications[id].url != ""){
                        var url = $scope.notifications[id].url;
                        var new_url = url.split('_');
                        $rootScope.goto(new_url[0],{id: new_url[1]});
                    }
                    $scope.$apply();
                break;
                case "search":
                    var splited = e.target.parentNode.title.split("_");
                    if(splited[0] == "FOLLOW"){
                        var uniqid = splited[1];
                        var id = splited[2];
                        $scope.notifications[id].mobi_read_flag = 1;
                        updateNotification([uniqid]);
                        if($scope.notifications[id].url != ""){
                            var url = $scope.notifications[id].url;
                            var new_url = url.split('_');
                            $rootScope.goto(new_url[0],{id: new_url[1]});
                        }
                        $scope.$apply();
                    }
                break;
            }
        }
    }

    var notificationview = document.querySelector("#notification-view");
    notificationview.addEventListener("click", notificationevents, false);
})



.controller('GalleryCtrl', function($scope, $state) {

})

.controller('GalleryListCtrl', function($scope, $ionicSlideBoxDelegate, $ionicHistory) {

    // $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        
    //     //$ionicHistory.clearCache();

    //     if(toState.name == 'gallery.gallery-list'){
           
            

    //     }
    // });

$scope.musicfiles = [
    {
        music_file : "1.mp3",
        music_name:"Astalavista Baby!"
    },
    {
        music_file : "1.mp3",
        music_name:"You're nothing but a second grade test dot"
    },
    {
        music_file : "1.mp3",
        music_name:"Astalavista Baby!"
    },
    {
        music_file : "1.mp3",
        music_name:"You're nothing but a second grade test dot"
    },
    {
        music_file : "1.mp3",
        music_name:"Astalavista Baby!"
    },
    {
        music_file : "1.mp3",
        music_name:"You're nothing but a second grade test dot"
    },
    {
        music_file : "1.mp3",
        music_name:"Astalavista Baby!"
    },
    {
        music_file : "1.mp3",
        music_name:"You're nothing but a second grade test dot"
    }
];

    // $scope.disableSwipe = function() {
    //    $ionicSlideBoxDelegate.enableSlide(false);
    // };
})


.controller('QuipperQuipCtrl', function($scope, $state, $stateParams, $timeout,API, $rootScope) {
    $scope.quipperaddress = "";
    $scope.quipperquiploading = false;
    $scope.quipperquipsdata = [];
    $scope.stoploadingqp = true;


    //--- media variables
    var playedicon = 'img/quip_play_icon.png';
    var pausedicon = 'img/quip_pause_icon.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.media = null; var mediaPausedFlag = 0; var currentMediaId = ''; var mediaLoadedFlag = 0;
    //--- media variables

    //--- parent function

    $scope.$on('$ionicView.beforeEnter', function() {
        var parentmenutab = document.querySelector("#qp-bodycontainer");
        parentmenutab.addEventListener("click", qpevent, false);
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        var parentmenutab = document.querySelector("#qp-bodycontainer");
        parentmenutab.removeEventListener("click", qpevent, false);
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
        if(toState.name == 'app.quippers-quip'){
            $rootScope.fromWhatMain = 'quippers';
            $scope.quipperquipsdata = [];
            $scope.quipperaddress = $stateParams.id;
            $scope.quipperquiploading = true;
            getSearchquip($stateParams.id);
            if($scope.quipperquipsdata){
                $timeout(function(){
                    $scope.quipperquiploading = false;
                    $scope.stoploadingqp = false;
                    NewsfeedPullToRefresh.init({
                        contentEl:"qp-content",
                        ptrEl:"qp-ptr",
                        limittrigger:'qp-container',
                        bodyId:'qp-bodycontainer',
                        loadingFunction: getSearchquip
                    });
                },1000);
            }

            
        }

    });

    function getSearchquip(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                var address = $scope.quipperaddress;  
                if($scope.quipperquipsdata.length > 0){
                    var start = $scope.quipperquipsdata[0].quipid;
                }
                else{
                    var start = 0;
                }  
                API.searchQuipper({
                    start: start,
                    hash:address,
                    action:"refresh"
                },
                function(data){
                    $scope.quipperquipsdata = data.Data.concat($scope.quipperquipsdata);
                },function(err){
                }); 
            } else {
                reject();
            }
        } );
    }
    
    $scope.loadmoreqp = function(){
        if($scope.stoploadingqp === false){
            $scope.stoploadingqp = true;
            var address = $scope.quipperaddress;   
            var endquipid = $scope.quipperquipsdata[$scope.quipperquipsdata.length - 1].quipid;
            API.searchQuipper({
                end: endquipid,
                hash: address,
                action:"showmore"
                },
                function(data){
                    if(data.Data.length === 0){
                        $scope.stoploadingqp = true;
                    }
                    else{
                        for(var i = 0; i < data.Data.length; i++){
                            $scope.quipperquipsdata.push(data.Data[i]);
                        }
                        //$rootScope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.stoploadingqp = false;
                    }
                },function(err){
            }); 

            //  var loadinginficon = document.getElementsByClassName("loading-inf");
            // loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';

        }
        
    }


    function qpevent(e) {
        if (e.target !== e.currentTarget) {
            var classtarget = e.target.classList;
              for(var i = 0; i < classtarget.length; i++){
                splitedclass = classtarget[i].split("_");
                if(splitedclass[0] == 'global'){
                    switch(splitedclass[1]){
                        case "viewtopic":
                        $rootScope.goto('app.home-topics',{id:splitedclass[2]});
                        break;
                        case 'viewprofile':
                        $rootScope.goto('app.view-profile',{id:splitedclass[2]});
                        break;
                        case "viewsphere":
                        $rootScope.goto('app.sphere',{id:splitedclass[2]});
                        break;
                        default:break;
                    }
                }else if(splitedclass[0] == 'viewlink'){
                    var a = classtarget[1];
                    var b = a.replace("viewlink_","");
                    window.open(b, '_system', 'location=yes');
                }
            }
            
            var checktarget = e.target.id;
            splited = checktarget.split("_");
            switch(splited[0]){
                case "requip":
                    $rootScope.globalEventHandler(e,function(s){
                            console.log(s)
                    });
                break;
                case "undorequip":
                    $rootScope.globalEventHandler(e,function(s){
                            console.log(s)
                    });
                break;
                case "imgslider":
                    for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                        if($scope.quipperquipsdata[i].unique_id == splited[1]){
                            var imgs = $scope.quipperquipsdata[i].quip_images;
                        }
                    }
                    $rootScope.showImages(imgs);
                    break;
                case "quipmedia":
                    if($rootScope.currentMediaId == e.target.className){
                        if($rootScope.mediaPausedFlag == 0){
                            e.target.src = playedicon;
                            $rootScope.media.pause();
                        }else{
                            e.target.src = pausedicon;
                            $rootScope.media.play();
                        }
                    }else{
                        e.target.src = loadingicon;
                        if($rootScope.currentMediaId == '' || $rootScope.currentMediaId == null){
                        }else{
                            var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                            for(var i=0;i<currentPlayerImage.length;i++){
                                currentPlayerImage[i].setAttribute('src',playedicon);
                            }
                        }
                        $rootScope.currentMediaId = e.target.className;
                        $rootScope.media = document.getElementById('quip_audio_src');
                        $rootScope.media.pause();
                        $rootScope.media.src = e.target.name;
                        $rootScope.media.load();
                        $rootScope.quipPlayerItem = e.target; // assign the object to play
                    }
                    break;
                case "replythread":
                    for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                        if($scope.quipperquipsdata[i].unique_id == splited[2]){
                            $rootScope.selectedtopics.handler = $scope.quipperquipsdata[i].quipper_name;
                        }
                    }
                    $rootScope.threadParentUniqueId = splited[1];
                    $rootScope.openRecorderModal();
                    $rootScope.reRoute('go','recorder',1);
                break;
                case "thread":

                    $rootScope.threadParentUniqueId = splited[1];
                    for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                        if($scope.quipperquipsdata[i].unique_id == splited[2]){
                            $rootScope.selectedtopics.handler = $scope.quipperquipsdata[i].quipper_name;
                        }
                    }
                    $rootScope.openTopicThreadModal(splited[1]);
                    $rootScope.reRoute('go','reply thread');
                break;
                case "quippermodal":
                    $rootScope.selectedtopics.hashtag = '';
                    for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                        if($scope.quipperquipsdata[i].unique_id == splited[2]){
                            $rootScope.selectedtopics.handler = $scope.quipperquipsdata[i].quipper_name;
                        }
                    }
                    
                    $rootScope.lasttempurl.id = splited[1];
                    var quipperid = window.localStorage['quipper_id'];
                    if(quipperid == splited[1]){
                        $rootScope.lasttempurl.url = 'app.myprofile';
                        $rootScope.goto('app.myprofile',{id:splited[1]});
                        $rootScope.reRoute('go','my profile');
                    }else{
                        $rootScope.lasttempurl.url = 'app.view-profile';
                        $rootScope.goto('app.view-profile', {id:splited[1]});
                        $rootScope.reRoute('go','view profile');
                    }
                    break;
                case "ratequip":
                    for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                        if($scope.quipperquipsdata[i].unique_id == splited[1]){
                            $rootScope.ratedata.selecteddata = $scope.quipperquipsdata[i];
                            $rootScope.openPopoverRate(e,splited[1],splited[2]);
                        }
                    }
                    break;
                case "sharequip":
                    var uid = splited[2];
                    console.log(uid);
                    window.plugins.socialsharing.share('Listen to this!', "Listen to this!", null, 'http://quipsphere.com/quip/quipshare.php?quipid=' + uid);
                    break;
                case 'report':
                        for(var i = 0; i < $scope.quipperquipsdata.length; i++){
                           if($scope.quipperquipsdata[i].unique_id == splited[1]){ 
                               $rootScope.reportdata.r_qpr = $scope.quipperquipsdata[i].quipper_id;
                               $rootScope.reportdata.r_qpid = $scope.quipperquipsdata[i].unique_id;
                               $rootScope.reportdata.rqtype = "Quip";
                               $rootScope.$apply();
                               $rootScope.openpopoverreport(e);
                           }
                       }
                break;
                default: break;
            }
        }
        e.stopPropagation();
    }

    $scope.$on('updaterequipqq', function(event, args) {
            var unique_id = args.unique_id;
            var id_val = args.id_val;
            for(var i =0; i < $scope.quipperquipsdata.length; i++){
                if($scope.quipperquipsdata[i].unique_id == unique_id){
                    if(id_val == "requip_"){
                        $scope.quipperquipsdata[i].is_requipped_img = "img/done-requip-icon.png";
                        $scope.quipperquipsdata[i].quips_count = $scope.quipperquipsdata[i].quips_count + 1;
                        $scope.quipperquipsdata[i].is_requipped_id = 'undorequip_'+unique_id;
                    }else{
                        $scope.quipperquipsdata[i].is_requipped_img = "img/requip-quip.png";
                        $scope.quipperquipsdata[i].quips_count = $scope.quipperquipsdata[i].quips_count - 1;
                        $scope.quipperquipsdata[i].is_requipped_id = 'requip_'+unique_id;
                    }
                }
            }
        });

        $scope.$on('updaterateqq', function(event, args) {
            var unique_id = args.unique_id;
            var counted = args.counted;
            var rating = args.rating;
            for(var i =0; i < $scope.quipperquipsdata.length; i++){
                if($scope.quipperquipsdata[i].unique_id == unique_id){
                    $scope.quipperquipsdata[i].is_favorited = 1;
                    var currentave = $scope.quipperquipsdata[i].average_stars;
                    var ratedvalue = rating;
                    if(currentave == 0){
                        var countdev = 1;
                    }else{
                        var countdev = 2;
                    }
                    var latest_ave = (currentave + ratedvalue) / countdev;
                    $scope.quipperquipsdata[i].average_stars = Math.round(latest_ave);
                    $scope.quipperquipsdata[i].is_favorited_img = "img/star-quiped.png";
                }
            }
        });
})

;
