angular.module('quipsphere.privatequip.controllers', [])

.controller('PrivateQuipCtrl', function($scope, $ionicConfig, $window, API, $rootScope, $log,$ionicLoading) {

    $scope.$on('$ionicView.beforeEnter', function() {
        var parentmenutab = document.querySelector("#privatequips");
        parentmenutab.addEventListener("click", prvlstevent, false);
    }); 
    $scope.$on('$ionicView.afterEnter', function() {
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "none";
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        var parentmenutab = document.querySelector("#privatequips");
        parentmenutab.removeEventListener("click", prvlstevent, false);
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "block";
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams, doLogout) {
        if(toState.name == 'app.privatequip'){
            getLatestPrvl();
            PullToRefresh.init({
                contentEl:"prvlq-content",
                ptrEl:"prvlq-ptr",
                limittrigger:'prvlq-container',
                bodyId:'prvlq-bodycontainer',
                loadingFunction: getLatestPrvl,
                limitscroll: 0
            });
        
        }
    });

    function getLatestPrvl(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                API.prvquips({}, function(data){
                    if(data.Result==1){
                        $scope.privatequiplist = data.Data;
                        console.log($scope.privatequiplist);
                    }
                    }, function(data){

                });

            } else {
                reject();
            }
        } );
    }
    $scope.loadmorePrvItem = function(){
        var end = $scope.privatequip[$scope.privatequip.length].prvquipid;
        API.prvquipsthread({'quipper_id':$stateParams.id,'action':'showmore','end':end}, function(data){
            if(data.Result==1){
                for(i = 0; i < data.Data.result.length; i++){
                    $scope.privatequip .push(data.Data.result[i]);
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            }, function(data){

        });
         var loadinginficon = document.getElementsByClassName("loading-inf");
        loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';

    }
    $scope.prvquip = function(val){
        $ionicLoading.show();
        API.privatequipGetquipper({'quipper_id':val}, function(data){
            if(data.Result == 1){
                $ionicLoading.hide();
                $rootScope.threadPrvParentUniqueId = data.Data.parentunique;
                $rootScope.prv_to_quipperid = val;
                $rootScope.openRecorderModal('1');
                $rootScope.isprivate = 1;
                $rootScope.reRoute('go','privatequip thread');
            }
            }, function(data){

        }); 
    }
    //--- media variables
    playedicon = 'img/newsfeed/quip_play_icon_1.png';
    pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.media = document.getElementById('quip_audio_src');
    $rootScope.mediaPausedFlag = 0;
    $rootScope.currentMediaId = ''; var mediaLoadedFlag = 0;
    //--- media variables
    function prvlstevent(e) {
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.id;
            splited = checktarget.split("_");
            switch(splited[0]){
                case "imgslider":
                    var imgs = $scope.privatequiplist[splited[1]].quip_images;
                    $scope.showImages(imgs);
                    break;
                case "player":
                    //insert here
                    break;
                case "quipmedia":
                    thisClass = e.target.className.split(' ');
                    if($rootScope.currentMediaId == thisClass[0]){
                        if($rootScope.mediaPausedFlag == 0){
                            e.target.src = playedicon;
                            $rootScope.media.pause();
                        }else{
                            e.target.src = pausedicon;
                            $rootScope.media.play();
                        }
                    }else{
                        if($rootScope.currentMediaId != '' && $rootScope.currentMediaId != null){
                            var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                            for(var i=0;i<currentPlayerImage.length;i++){
                                currentPlayerImage[i].setAttribute('src',playedicon);
                            }
                            e.target.src = loadingicon;
                        }

                        var uniqueid_update = splited[1];
                        if(uniqueid_update){
                            var data = {'quip_unique_id':uniqueid_update};
                            API.updatePrivPlay(data, function(data){
                                console.log(data);
                            }, function(data){
                                $log.info('error on played update');
                            }); 
                        }

                        $rootScope.currentMediaId = thisClass[0];
                        $rootScope.media = document.getElementById('quip_audio_src');
                        $rootScope.media.pause();
                        $rootScope.media.src = e.target.name;
                        $rootScope.media.load();
                        e.target.src = pausedicon;
                        // update

                        e.target.classList.remove('play_0');
                        e.target.classList.add('play_1');
                        
                    }
                    break;
                case "quippermodal":
                    $rootScope.goto('app.view-profile',{id:splited[1]});
                    //$rootScope.selectedtopics.handler = $rootScope.newsfeeds[splited[2]].quipper_name;
                    $rootScope.lasttempurl.url = 'app.view-profile';
                    $rootScope.lasttempurl.id = splited[1];
                    $rootScope.reRoute('go','viewprofile');
                    break;
                case "thread":
                    $rootScope.goto('app.privatequipitem',{id:splited[1]}); 
                    $rootScope.reRoute('go','privatequip thread');
                    break;
                case 'replythread':
                    $rootScope.selectedtopics.handler = $rootScope.newsfeeds[splited[2]].quipper_name;
                    $rootScope.threadParentUniqueId = splited[1];
                    $rootScope.openRecorderModal();
                    $rootScope.reRoute('go','recorder',1);
                    break;
                case 'ratequip':
                    $rootScope.openPopoverRate(splited[1],splited[2]);
                    break;
                default:break;
            }
        }
        e.stopPropagation();
    }
})
.controller('PrivateQuipItemCtrl', function($scope, $ionicConfig, $stateParams, API, $rootScope, $log) {
    $scope.privatequip = [];
    $rootScope.prv_to_quipperid = $stateParams.id;
    $scope.stoploadingitem = true;
    
    $scope.$on('$ionicView.beforeEnter', function() {
        $rootScope.isprivate = 1;
        var parentmenutab = document.querySelector("#privatequipsitem");
        parentmenutab.addEventListener("click", prvitemevent, false);
    }); 
    $scope.$on('$ionicView.afterEnter', function() {
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "none";
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        $rootScope.isprivate = 0;
        var parentmenutab = document.querySelector("#privatequipsitem");
        parentmenutab.removeEventListener("click", prvitemevent, false);
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "block";
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
        if(toState.name == 'app.privatequipitem'){
            getLatestPrv(); 

             PullToRefresh.init({
                contentEl:"prvq-content",
                ptrEl:"prvq-ptr",
                limittrigger:'prvq-container',
                bodyId:'prvq-bodycontainer',
                loadingFunction: getLatestPrv,
                limitscroll: 0
            });
        }
    });

    $scope.$on("getlatestprivate",function () {
        getLatestPrv();
    });

    $scope.prvquip = function(){
        $rootScope.openRecorderModal('1');
        $rootScope.isprivate = 1;
        $rootScope.reRoute("go","recorder");
       
    }

    function getLatestPrv(){
        return new Promise( function( resolve, reject ) {
            if (true) {
                resolve();
                if($scope.privatequip){
                    if($scope.privatequip.length > 0){
                        var start = $scope.privatequip[0].prvquipid;
                    }else{
                       var start = 0; 
                    }
                }else{
                    var start = 0;
                    $scope.privatequip = [];
                }
                
                API.prvquipsthread({'quipper_id':$stateParams.id,'action':'refresh','start':start}, function(data){
                    if(data.Result==1){
                        if(data.Data.result){
                            if($scope.privatequip.length > 0){
                                $scope.privatequip = data.Data.result.concat($scope.privatequip); 
                                $scope.stoploadingitem = false;
                            }else{
                                $scope.privatequip = data.Data.result; 
                                $scope.stoploadingitem = false;
                            }
                            $rootScope.threadPrvParentUniqueId = data.Data.parentunique;
                        }else{
                            $scope.stoploadingitem = true;
                        }
                        $rootScope.prv_to_quipperid = $stateParams.id;
                    }
                    }, function(data){

                });

            } else {
                reject();
            }
        } );
    }
    $scope.loadMorePrvItem = function(){
        var end = $scope.privatequip[$scope.privatequip.length - 1].prvquipid;
        API.prvquipsthread({'quipper_id':$stateParams.id,'action':'showmore','end':end}, function(data){
            if(data.Data.result){
                for(i = 0; i < data.Data.result.length; i++){
                    $scope.privatequip .push(data.Data.result[i]);
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }else{
                $scope.stoploadingitem = true;
            }
            }, function(data){

        });
         var loadinginficon = document.getElementsByClassName("loading-inf");
        loadinginficon[0].innerHTML = '<div class="ptrloading" style="display:block"><span id="l1"></span><span id="l2"></span><span id="l3"></span></div>';

    }

    //--- media variables
    playedicon = 'img/newsfeed/quip_play_icon_1.png';
    pausedicon = 'img/newsfeed/quip_pause_icon_1.png';
    var loadingicon = 'img/quip_loading_icon.gif';
    $rootScope.media = document.getElementById('quip_audio_src');
    $rootScope.mediaPausedFlag = 0;
    $rootScope.currentMediaId = ''; var mediaLoadedFlag = 0;
    //--- media variables
    function prvitemevent(e) {
        if (e.target !== e.currentTarget) {
            var checktarget = e.target.id;
            splited = checktarget.split("_");
            switch(splited[0]){
                case "imgslider":
                    var imgs = $scope.privatequip[splited[1]].quip_images;
                    $scope.showImages(imgs);
                    break;
                case "player":
                    //insert here
                    break;
                case "quipmedia":
                    thisClass = e.target.className.split(' ');
                    if($rootScope.currentMediaId == thisClass[0]){
                        if($rootScope.mediaPausedFlag == 0){
                            e.target.src = playedicon;
                            $rootScope.media.pause();
                        }else{
                            e.target.src = pausedicon;
                            $rootScope.media.play();
                        }
                    }else{
                        if($rootScope.currentMediaId != '' && $rootScope.currentMediaId != null){
                            var currentPlayerImage = document.querySelectorAll("."+$rootScope.currentMediaId);
                            for(var i=0;i<currentPlayerImage.length;i++){
                                currentPlayerImage[i].setAttribute('src',playedicon);
                            }
                            e.target.src = loadingicon;
                        }
                        $rootScope.currentMediaId = thisClass[0];
                        $rootScope.media = document.getElementById('quip_audio_src');
                        $rootScope.media.pause();
                        $rootScope.media.src = e.target.name;
                        console.log($rootScope.media.load());
                        e.target.src = pausedicon;
                        // update

                        e.target.classList.remove('play_0');
                        e.target.classList.add('play_1');
                        var uniqueid_update = splited[1];
                        if(uniqueid_update){
                            var data = {'quip_unique_id':uniqueid_update};
                            API.updatePrivPlay(data, function(data){
                                console.log(data);
                            }, function(data){
                                $log.info('error on played update');
                            }); 
                        } 
                    }
                    break;
                case "quippermodal":
                    $rootScope.goto('app.view-profile',{id:splited[1]});
                    //$rootScope.selectedtopics.handler = $rootScope.newsfeeds[splited[2]].quipper_name;
                    $rootScope.lasttempurl.url = 'app.view-profile';
                    $rootScope.lasttempurl.id = splited[1];
                    $rootScope.reRoute('go','viewprofile');
                    break;
                case "thread":
                    $rootScope.threadParentUniqueId = splited[1];
                    $rootScope.selectedtopics.handler = $rootScope.newsfeeds[splited[2]].quipper_name;
                    $rootScope.openTopicThreadModal(splited[1]);
                    $rootScope.reRoute('go','reply thread');
                    break;
                case 'replythread':
                    $rootScope.selectedtopics.handler = $rootScope.newsfeeds[splited[2]].quipper_name;
                    $rootScope.threadParentUniqueId = splited[1];
                    $rootScope.openRecorderModal();
                    $rootScope.reRoute('go','recorder',1);
                    break;
                case 'ratequip':
                    $rootScope.openPopoverRate(splited[1],splited[2]);
                    break;
                default:break;
            }
        }
        e.stopPropagation();
    }

})

.controller('PrivateQuipSearchCtrl', function($scope, $ionicConfig, $window, API, $rootScope, $log ) {

    $scope.$on('$ionicView.beforeEnter', function() {
        // var parentmenutab = document.querySelector("#privatequipsitem");
        // parentmenutab.addEventListener("click", prvitemevent, false);
    }); 
    $scope.$on('$ionicView.afterEnter', function() {
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "none";
    }); 
    $scope.$on('$ionicView.beforeLeave', function() {
        // var parentmenutab = document.querySelector("#privatequipsitem");
        // parentmenutab.removeEventListener("click", prvitemevent, false);
        document.getElementsByTagName("ion-footer-bar")[0].style.display = "block";
    });

    $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams, doLogout) {
        $scope.searchquipperdata = [];
        if(toState.name == 'app.privatequipsearch'){
            
        }

        var delay = (function () {
            var timer = 0;
            return function (callback, ms) {
                clearTimeout(timer);
                timer = setTimeout(callback, ms);
            };
        })();

        $scope.searchQuipper = function(namehandle){      
            $scope.showLoading = true;
            delay(function () {
                API.privatequipSearchQuipper({
                    namehandle: namehandle
                    },
                    function(data){
                        $scope.showLoading = false;
                        if(data.Result == 1){
                          window.localStorage['prvq_quippers'] = JSON.stringify(data.Data);
                          console.log(data);
                        }          
                        $scope.searchquipperdata = JSON.parse(window.localStorage['prvq_quippers']);
                    },
                    function(err){
                        $scope.showLoading = false;
                        //console.log(err);
                    }
                );  
            }, 1);    
        }
    });

})
