angular.module('quipsphere.searchpage.controllers', [])



.controller('SrcPageCtrl', function($scope,$ionicSlideBoxDelegate,$rootScope, API) {
    $scope.slidesearch = function(to) {
        $ionicSlideBoxDelegate.$getByHandle('searchslide').slide(to);
    }

    $scope.slideSearchChange = function(index) {
        e1 = document.getElementById("s_slide_0");
        e2 = document.getElementById("s_slide_1");
        e3 = document.getElementById("s_slide_2");
        if(index == 0){
            $rootScope.searchselected = "topic";
            $scope.searchpage($scope.searchdata);
            $ionicSlideBoxDelegate.$getByHandle('searchslide').update();
            e1.classList.add('active');
        }else{
            e1.classList.remove('active');
        }
        if(index == 1){
            $rootScope.searchselected = "quipper";
            $scope.searchpage($scope.searchdata);
            $ionicSlideBoxDelegate.$getByHandle('searchslide').update();
            e2.classList.add('active');
        }else{
            e2.classList.remove('active');
        }
        if(index == 2){
            $rootScope.searchselected = "sphere";
            $scope.searchpage($scope.searchdata);
            e3.classList.add('active');
        }else{
            e3.classList.remove('active');
        }
    }

    var delaysearch = (function () {
        var timer = 0;
        return function (callback, ms) {
            clearTimeout(timer);
            timer = setTimeout(callback, ms);
        };
    })();

    $scope.searchpage = function(val){
        switch($rootScope.searchselected){
            case "topic":
                delaysearch(function () {
                    API.searchTopics({hash:val},function(data){
                        $rootScope.searchTopics = [];
                        $rootScope.searchTopics = data.Data; 
                        },function(err){
                    });
                }, 500); 
            break;
            case "quipper":
                delaysearch(function () {
                    API.searchQuippers({hash:val},function(data){
                        $rootScope.searchQuippers = [];
                        $rootScope.searchQuippers = data.Data;  
                        },function(err){
                    });
                }, 500);
            break;
            case "sphere":
                delaysearch(function () {
                    API.searchSpheres({hash:val},function(data){
                        $rootScope.searchSpheres = [];
                        $rootScope.searchSpheres = data.Data;  
                        },function(err){
                    });
                }, 500);
            break;
            default:break;
        }   
    }

    $scope.s_disableSwipe = function() {
       $ionicSlideBoxDelegate.$getByHandle('searchslide').enableSlide(false);
    };

    $scope.clearSearch = function(){
        $scope.searchdata = "";
        $rootScope.searchTopics = [];  
        $rootScope.searchQuippers = []; 
        $rootScope.searchSpheres = [];   
    }
    $scope.$on('updateslide', function(event, args) {
        $ionicSlideBoxDelegate.$getByHandle('searchslide').enableSlide(false);
        $scope.searchdata = "";
        var searchevent = document.querySelector("#evntsearch");
        searchevent.addEventListener("click",evnt, false);
    });

    function evnt(e) {

        if (e.target !== e.currentTarget) {
            var checktarget = e.target.id;
            splited = checktarget.split("_");

            switch(splited[0]){
                case "topic":
                    $rootScope.selectedtopics.hashtag = '#'+splited[1];
                    $rootScope.reRoute('go','topic thread');
                    $rootScope.goto('app.home-topics',{id:splited[1]});
                    $rootScope.closeSearchModals();
                    break;
                case "quipper":
                    var quipperid = window.localStorage['quipper_id'];
                    if(quipperid == splited[1]){
                        $rootScope.lasttempurl.url = 'app.myprofile';
                        $rootScope.goto('app.myprofile',{id:splited[1]});
                        $rootScope.reRoute('go','view my profile');
                    }else{
                        $rootScope.lasttempurl.url = 'app.view-profile';
                        $rootScope.goto('app.view-profile',{id:splited[1]});
                        $rootScope.reRoute('go','view profile');
                    }
                    $rootScope.lasttempurl.id = splited[1];
                    $rootScope.closeSearchModals();
                    break;
                    case "sphere":
                        $rootScope.closeSearchModals();
                        $rootScope.reRoute('go','app.mysphere');
                        $rootScope.reRoute('go','app.sphere', 0, {id:splited[1], handler: splited[2]});
                        $rootScope.goto('app.sphere',{id:splited[1]});
                    break;
                case "follow":
                    $rootScope.globalFollowEvent(e);
                    break;
                case "unfollow":
                    $rootScope.globalFollowEvent(e);
                    break;
                // case "topicmodal":
                //     $rootScope.selectedtopics.hashtag = '#'+splited[1];
                //     $rootScope.reRoute('go','topic thread');
                //     $rootScope.goto('app.home-topics',{id:splited[1]});
                //     break;
                // case "quippermodal":
                //     var quipperid = window.localStorage['quipper_id'];
                //     if(quipperid == splited[1]){
                //         $rootScope.lasttempurl.url = 'app.myprofile';
                //         $rootScope.goto('app.myprofile',{id:splited[1]});
                //         $rootScope.reRoute('go','view my profile');
                //     }else{
                //         $rootScope.lasttempurl.url = 'app.view-profile';
                //         $rootScope.goto('app.view-profile',{id:splited[1]});
                //         $rootScope.reRoute('go','view profile');
                //     }
                //     $rootScope.lasttempurl.id = splited[1];
                //     break;
                // case "quippersquip":
                //     $rootScope.goto('app.quippers-quip',{id:splited[1]});
                //     $rootScope.selectedtopics.handler = '@'+splited[1];
                //     $rootScope.lasttempurl.url = 'app.quippers-quip';
                //     $rootScope.lasttempurl.id = splited[1];
                //     $rootScope.reRoute('go','quippers');
                //     break;
                // case "viewsphere":
                //     $rootScope.goto('app.sphere',{id:splited[1]});
                //     break;
                // case "quipperimg":
                //     var imgs = $scope.trendquippersdata[splited[1]].images;
                //     $scope.showImages(imgs);
                //     break;
                // case "sphereimg":
                //     var tobeview = true;
                //     for(var i = 0; i < $scope.trendspheresdata.length; i++){
                //         if($scope.trendspheresdata[i].unique_id == splited[1]){
                //             if(tobeview){
                //                 var imgs = $scope.trendspheresdata[i].images;
                //                 $scope.showImages(imgs);
                //                 tobeview = false;
                //             }
                //         }
                //     }
                //     break;
                /*menu tab*/
                default:
            }
        }
        e.stopPropagation();
    }
})